// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient
{
    using Microsoft.Rest;
    using Models;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.IO;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// PTV xServer 1.0.49421-SNAPSHOT - 2.19 API document
    /// </summary>
    public partial interface IXServer : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }


        /// <summary>
        /// Determines the time zone for a given location.
        /// </summary>
        /// <param name='x'>
        /// The value in x-direction (west to east), longitude for WGS84.
        /// </param>
        /// <param name='y'>
        /// The value in y-direction (south to north), latitude for WGS84.
        /// </param>
        /// <param name='timeZoneMethodParameters'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<TimeZoneResponse>> TimeZoneMethodWithHttpMessagesAsync(double x, double y, TimeZoneMethodParameters timeZoneMethodParameters = default(TimeZoneMethodParameters), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Searches for locations matching a given address, specified as a
        /// free-form text input.
        /// </summary>
        /// <param name='address'>
        /// The input address.
        /// </param>
        /// <param name='locationsParameters'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<LocationsResponse>> LocationsWithHttpMessagesAsync(string address, LocationsParameters locationsParameters = default(LocationsParameters), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Render a single map tile according the concept of the Map Tile API.
        /// By means of different frameworks a map image can be composed of
        /// multiple tiles. These tiles can be cached and reused for drawing of
        /// similar sections of a map. Optionally it is possible to return
        /// textual information on drawn Feature Layer data. Therefore, this
        /// operation can return either an image directly or a structured
        /// response which contains the image and additional information on
        /// drawn Feature Layer data such as their positions and names.
        /// </summary>
        /// <param name='zoomLevel'>
        /// Zoom level. Details about zoom levels are documented in the Map
        /// Tile API.
        /// </param>
        /// <param name='x'>
        /// Horizontal tile index.
        /// </param>
        /// <param name='y'>
        /// Vertical tile index.
        /// </param>
        /// <param name='tileBinaryParameters'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Stream>> TileBinaryWithHttpMessagesAsync(int zoomLevel, int x, int y, TileBinaryParameters tileBinaryParameters = default(TileBinaryParameters), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Calculates a route from start to destination and returns route
        /// information. This operation supports exactly two on-road waypoints.
        /// </summary>
        /// <param name='startX'>
        /// The longitude in WGS84 (EPSG:4326) of the start location. The
        /// location is interpreted as an routing.OnRoadRouteLocation.
        /// </param>
        /// <param name='startY'>
        /// The latitude in WGS84 (EPSG:4326) of the start location. The
        /// location is interpreted as an routing.OnRoadRouteLocation.
        /// </param>
        /// <param name='destinationX'>
        /// The longitude in WGS84 (EPSG:4326) of the destination location. The
        /// location is interpreted as an routing.OnRoadRouteLocation.
        /// </param>
        /// <param name='destinationY'>
        /// The latitude in WGS84 (EPSG:4326) of the destination location. The
        /// location is interpreted as an routing.OnRoadRouteLocation.
        /// </param>
        /// <param name='routeParameters'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<RouteResponse>> RouteWithHttpMessagesAsync(double startX, double startY, double destinationX, double destinationY, RouteParameters routeParameters = default(RouteParameters), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Returns information about the data used by PTV xServer as a REST
        /// service.
        /// </summary>
        /// <param name='dataInformationParameters'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DataInformationResponse>> DataInformationWithHttpMessagesAsync(DataInformationParameters dataInformationParameters = default(DataInformationParameters), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Calculates a cluster planning for the given request. In contrast to
        /// the method planClusters, not all locations need to be covered.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ClustersResponse>> CoverLocationsWithHttpMessagesAsync(CoverLocationsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type ClustersResponse for the given job. If the
        /// calculation ended with an exception, fetchClustersResponse will
        /// rethrow it. If the id of the job is unknown, a XServerException
        /// with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ClustersResponse>> FetchClustersResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type VisitSequenceResponse for the given job. If
        /// the calculation ended with an exception, fetchVisitSequenceResponse
        /// will rethrow it. If the id of the job is unknown, a
        /// XServerException with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VisitSequenceResponse>> FetchVisitSequenceResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type VisitsResponse for the given job. If the
        /// calculation ended with an exception, fetchVisitsResponse will
        /// rethrow it. If the id of the job is unknown, a XServerException
        /// with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VisitsResponse>> FetchVisitsResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Solves visit sequencing problems with street distances. This is
        /// equivalent to a traveling salesman problem (TSP) with street
        /// distances.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VisitSequenceResponse>> OptimizeVisitSequenceWithHttpMessagesAsync(OptimizeVisitSequenceRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Calculates a cluster planning for the given request including all
        /// of the locations.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ClustersResponse>> PlanClustersWithHttpMessagesAsync(PlanClustersRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Calculates a daily visit planning for the given request in a
        /// certain planning period.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VisitsResponse>> PlanVisitsWithHttpMessagesAsync(PlanVisitsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of coverLocations. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchClustersResponse. If the job ended with status
        /// FAILED, fetchClustersResponse throws the exception that occurred
        /// during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartCoverLocationsWithHttpMessagesAsync(CoverLocationsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of optimizeVisitSequence. Calling
        /// this operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchVisitSequenceResponse. If the job ended with
        /// status FAILED, fetchVisitSequenceResponse throws the exception that
        /// occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartOptimizeVisitSequenceWithHttpMessagesAsync(OptimizeVisitSequenceRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of planClusters. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchClustersResponse. If the job ended with status
        /// FAILED, fetchClustersResponse throws the exception that occurred
        /// during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartPlanClustersWithHttpMessagesAsync(PlanClustersRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of planVisits. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchVisitsResponse. If the job ended with status
        /// FAILED, fetchVisitsResponse throws the exception that occurred
        /// during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartPlanVisitsWithHttpMessagesAsync(PlanVisitsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Creates a snapshot of the current state of automatically updated
        /// data, such as PTV\_TrafficIncidents Feature Layer. See technical
        /// concept about content snapshots for more details. Returns the ID of
        /// the content snapshot.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ContentSnapshotResponse>> CreateContentSnapshotWithHttpMessagesAsync(CreateContentSnapshotRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Deletes a content snapshot.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VoidResponse>> DeleteContentSnapshotWithHttpMessagesAsync(DeleteContentSnapshotRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Deletes a high-performance routing network with a given ID
        /// considering user privileges and concurrent usage.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VoidResponse>> DeleteHighPerformanceRoutingNetworkWithHttpMessagesAsync(DeleteHighPerformanceRoutingNetworkRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type HighPerformanceRoutingNetworkResponse for
        /// the given job. If the calculation ended with an exception,
        /// fetchHighPerformanceRoutingNetworkResponse will rethrow it. If the
        /// id of the job is unknown, a XServerException with message 'unknown
        /// id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<HighPerformanceRoutingNetworkResponse>> FetchHighPerformanceRoutingNetworkResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Determines the time zone for a given location.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<TimeZoneResponse>> GetTimeZoneWithHttpMessagesAsync(TimeZoneRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Lists available content snapshots including their meta data
        /// considering user privileges.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ContentSnapshotsListResponse>> ListContentSnapshotsWithHttpMessagesAsync(ListContentSnapshotsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Lists available high-performance routing networks including their
        /// meta data considering user privileges. Both networks of the map and
        /// user-created networks are listed. Networks belonging to the map
        /// have no scope, no tenant, and cannot be deleted. See technical
        /// concept about multitenancy on how to list networks for all
        /// available tenants or scopes.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<HighPerformanceRoutingNetworksListResponse>> ListHighPerformanceRoutingNetworksWithHttpMessagesAsync(ListHighPerformanceRoutingNetworksRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Creates a high-performance routing network. Returns the ID of the
        /// high-performance routing network. Calling this operation will not
        /// block until the result has been calculated. Instead of a result
        /// object, a Job object is returned which identifies the started
        /// calculation. To get status updates on a running job, use the
        /// operation watchJob. If the status changes to SUCCEEDED, the
        /// calculation was successful and the result can be obtained using
        /// fetchHighPerformanceRoutingNetworkResponse. If the job ended with
        /// status FAILED, fetchHighPerformanceRoutingNetworkResponse throws
        /// the exception that occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartCreateHighPerformanceRoutingNetworkWithHttpMessagesAsync(CreateHighPerformanceRoutingNetworkRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Creates a distance matrix by calculating road distances and travel
        /// times between given locations. An InvalidValueException is returned
        /// if the feature layer theme PTV\_RestrictionZones is activated.
        /// PTV\_RestrictionZones cannot be used for distance matrices. Returns
        /// a summary of this distance matrix calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DistanceMatrixResponse>> CreateDistanceMatrixWithHttpMessagesAsync(CreateDistanceMatrixRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Deletes a distance matrix with a given ID considering user
        /// privileges and concurrent usage.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VoidResponse>> DeleteDistanceMatrixWithHttpMessagesAsync(DeleteDistanceMatrixRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type DistanceMatrixResponse for the given job.
        /// If the calculation ended with an exception,
        /// fetchDistanceMatrixResponse will rethrow it. If the id of the job
        /// is unknown, a XServerException with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DistanceMatrixResponse>> FetchDistanceMatrixResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Gets the distance matrix contents for specific matrix elements
        /// specified as relations between route locations or specified as an
        /// array of start and destination locations. Returns arrays
        /// representing the matrix contents for the requested part of the
        /// matrix.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DistanceMatrixResponse>> GetDistanceMatrixWithHttpMessagesAsync(GetDistanceMatrixRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Lists available distance matrices including their meta data
        /// considering user privileges and concurrent usage. See technical
        /// concept about multitenancy how to list matrices for all available
        /// tenants or scopes.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DistanceMatrixListResponse>> ListDistanceMatricesWithHttpMessagesAsync(ListDistanceMatricesRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of createDistanceMatrix. Calling
        /// this operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchDistanceMatrixResponse. If the job ended with
        /// status FAILED, fetchDistanceMatrixResponse throws the exception
        /// that occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartCreateDistanceMatrixWithHttpMessagesAsync(CreateDistanceMatrixRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of updateDistanceMatrix. Calling
        /// this operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchDistanceMatrixResponse. If the job ended with
        /// status FAILED, fetchDistanceMatrixResponse throws the exception
        /// that occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartUpdateDistanceMatrixWithHttpMessagesAsync(UpdateDistanceMatrixRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Updates an existing distance matrix by extending it with new
        /// locations or overwriting existing entries. Returns a summary of
        /// this distance matrix calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DistanceMatrixResponse>> UpdateDistanceMatrixWithHttpMessagesAsync(UpdateDistanceMatrixRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type PackedBinsResponse for the given job. If
        /// the calculation ended with an exception, fetchPackedBinsResponse
        /// will rethrow it. If the id of the job is unknown, a
        /// XServerException with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<PackedBinsResponse>> FetchPackedBinsResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Performs a bin packing operation as described by the request.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<PackedBinsResponse>> PackBinsWithHttpMessagesAsync(PackBinsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of packBins. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchPackedBinsResponse. If the job ended with
        /// status FAILED, fetchPackedBinsResponse throws the exception that
        /// occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartPackBinsWithHttpMessagesAsync(PackBinsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type LocationsBulkResponse for the given job. If
        /// the calculation ended with an exception, fetchLocationsBulkResponse
        /// will rethrow it. If the id of the job is unknown, a
        /// XServerException with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<LocationsBulkResponse>> FetchLocationsBulkResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Searches for locations matching a given address
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<LocationsResponse>> SearchLocationsWithHttpMessagesAsync(SearchLocationsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// For each element of a list of addresses, searches for locations
        /// matching that address.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<LocationsBulkResponse>> SearchLocationsInBulkWithHttpMessagesAsync(SearchLocationsBulkRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of searchLocationsInBulk. Calling
        /// this operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchLocationsBulkResponse. If the job ended with
        /// status FAILED, fetchLocationsBulkResponse throws the exception that
        /// occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartSearchLocationsInBulkWithHttpMessagesAsync(SearchLocationsBulkRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Render image(s) of a map and return information on drawn Feature
        /// Layer data.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<MapResponse>> RenderMapWithHttpMessagesAsync(MapRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Calculate the areas which can be reached from a location within
        /// given horizons. This operation requires a special license.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ReachableAreasResponse>> CalculateReachableAreasWithHttpMessagesAsync(ReachableAreasRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Calculates and returns route information.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<RouteResponse>> CalculateRouteWithHttpMessagesAsync(RouteRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type ReachableAreasResponse for the given job.
        /// If the calculation ended with an exception,
        /// fetchReachableAreasResponse will rethrow it. If the id of the job
        /// is unknown, a XServerException with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ReachableAreasResponse>> FetchReachableAreasResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type RouteResponse for the given job. If the
        /// calculation ended with an exception, fetchRouteResponse will
        /// rethrow it. If the id of the job is unknown, a XServerException
        /// with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<RouteResponse>> FetchRouteResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of calculateReachableAreas.
        /// Calling this operation will not block until the result has been
        /// calculated. Instead of a result object, a Job object is returned
        /// which identifies the started calculation. To get status updates on
        /// a running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchReachableAreasResponse. If the job ended with
        /// status FAILED, fetchReachableAreasResponse throws the exception
        /// that occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartCalculateReachableAreasWithHttpMessagesAsync(ReachableAreasRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of calculateRoute. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchRouteResponse. If the job ended with status
        /// FAILED, fetchRouteResponse throws the exception that occurred
        /// during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartCalculateRouteWithHttpMessagesAsync(RouteRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Attempts to delete a running job. If successful, the returned job
        /// will have state DELETED.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> DeleteJobWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Immediately deletes a running request.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VoidResponse>> DeleteRequestWithHttpMessagesAsync(StopDeleteRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Returns information about the data used by PTV xServer.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<DataInformationResponse>> GetDataInformationWithHttpMessagesAsync(DataInformationRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Attempts to stop a running job. If the status of the job changes to
        /// SUCCEEDED, preliminary results can be fetched, if available.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StopJobWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Tries to stop a running request.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<VoidResponse>> StopRequestWithHttpMessagesAsync(StopDeleteRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Returns the status of the given job.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> WatchJobWithHttpMessagesAsync(WatchRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Change existing tours via specified actions. Returns a plan
        /// containing the changed tours and reports with additional
        /// information about those changed tours. The source tour(s) and
        /// target tour are always returned even if the tours did not change
        /// (for example if an addTripAction with an insertion position of type
        /// insertion at best position does not find a valid insertion
        /// position). Furthermore the stored request will be the original
        /// PlanToursRequest with changed tours information contained in the
        /// input plan.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ToursResponse>> ChangeToursWithHttpMessagesAsync(ChangeToursRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type ChangeToursProposalsResponse for the given
        /// job. If the calculation ended with an exception,
        /// fetchChangeToursProposalsResponse will rethrow it. If the id of the
        /// job is unknown, a XServerException with message 'unknown id' is
        /// thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ChangeToursProposalsResponse>> FetchChangeToursProposalsResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Fetches results of type ToursResponse for the given job. If the
        /// calculation ended with an exception, fetchToursResponse will
        /// rethrow it. If the id of the job is unknown, a XServerException
        /// with message 'unknown id' is thrown.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ToursResponse>> FetchToursResponseWithHttpMessagesAsync(JobRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Propose ChangeToursActions to change an existing tour plan as
        /// desired. Returns proposed ChangeToursActions with resulting
        /// TourReports if the corresponding ChangeToursAction would be applied
        /// via a ChangeToursRequest.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ChangeToursProposalsResponse>> FindChangeToursProposalsWithHttpMessagesAsync(FindChangeToursProposalsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Plan tours that ideally include all orders that are specified in
        /// the request. Returns a plan with tours and reports with additional
        /// information about the planned tours.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<ToursResponse>> PlanToursWithHttpMessagesAsync(PlanToursRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of changeTours. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchToursResponse. If the job ended with status
        /// FAILED, fetchToursResponse throws the exception that occurred
        /// during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartChangeToursWithHttpMessagesAsync(ChangeToursRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of findChangeToursProposals.
        /// Calling this operation will not block until the result has been
        /// calculated. Instead of a result object, a Job object is returned
        /// which identifies the started calculation. To get status updates on
        /// a running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchChangeToursProposalsResponse. If the job ended
        /// with status FAILED, fetchChangeToursProposalsResponse throws the
        /// exception that occurred during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartFindChangeToursProposalsWithHttpMessagesAsync(FindChangeToursProposalsRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// This is the asynchronous version of planTours. Calling this
        /// operation will not block until the result has been calculated.
        /// Instead of a result object, a Job object is returned which
        /// identifies the started calculation. To get status updates on a
        /// running job, use the operation watchJob. If the status changes to
        /// SUCCEEDED, the calculation was successful and the result can be
        /// obtained using fetchToursResponse. If the job ended with status
        /// FAILED, fetchToursResponse throws the exception that occurred
        /// during calculation.
        /// </summary>
        /// <param name='body'>
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<Job>> StartPlanToursWithHttpMessagesAsync(PlanToursRequest body, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Render a single map tile according the concept of the Map Tile API.
        /// By means of different frameworks a map image can be composed of
        /// multiple tiles. These tiles can be cached and reused for drawing of
        /// similar sections of a map. Optionally it is possible to return
        /// textual information on drawn Feature Layer data. Therefore, this
        /// operation can return either an image directly or a structured
        /// response which contains the image and additional information on
        /// drawn Feature Layer data such as their positions and names.
        /// </summary>
        /// <param name='zoomLevel'>
        /// Zoom level. Details about zoom levels are documented in the Map
        /// Tile API.
        /// </param>
        /// <param name='x'>
        /// Horizontal tile index.
        /// </param>
        /// <param name='y'>
        /// Vertical tile index.
        /// </param>
        /// <param name='tileParameters'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<TileResponse>> TileWithHttpMessagesAsync(int zoomLevel, int x, int y, TileParameters tileParameters = default(TileParameters), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

    }
}
