// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class AddTripAction : ChangeToursAction
    {
        /// <summary>
        /// Initializes a new instance of the AddTripAction class.
        /// </summary>
        public AddTripAction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AddTripAction class.
        /// </summary>
        /// <param name="storedRequestId">ID of the stored PlanToursRequest
        /// that contains all information about the tours to be changed as
        /// input plan. This request with changed input plan containing the
        /// tours information after the ChangeToursAction will be again stored
        /// in the session storage and the ID of the stored request will be
        /// returned as stored request.</param>
        /// <param name="targetVehicleId">ID of the vehicle for that a trip is
        /// added. The vehicle can be empty or already have a tour with one or
        /// more trips assigned.</param>
        /// <param name="insertionPosition">InsertionPosition of the trip that
        /// is added. If InsertionPosition is of type InsertionAtBestPosition,
        /// orders in orderIds that can not be moved to the target vehicle are
        /// listed in a NoValidInsertionPositionFoundLimitation as
        /// objectIds.</param>
        public AddTripAction(string storedRequestId, string targetVehicleId, InsertionPosition insertionPosition, IList<string> orderIds = default(IList<string>))
            : base(storedRequestId)
        {
            OrderIds = orderIds;
            TargetVehicleId = targetVehicleId;
            InsertionPosition = insertionPosition;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "orderIds")]
        public IList<string> OrderIds { get; set; }

        /// <summary>
        /// Gets or sets ID of the vehicle for that a trip is added. The
        /// vehicle can be empty or already have a tour with one or more trips
        /// assigned.
        /// </summary>
        [JsonProperty(PropertyName = "targetVehicleId")]
        public string TargetVehicleId { get; set; }

        /// <summary>
        /// Gets or sets insertionPosition of the trip that is added. If
        /// InsertionPosition is of type InsertionAtBestPosition, orders in
        /// orderIds that can not be moved to the target vehicle are listed in
        /// a NoValidInsertionPositionFoundLimitation as objectIds.
        /// </summary>
        [JsonProperty(PropertyName = "insertionPosition")]
        public InsertionPosition InsertionPosition { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (TargetVehicleId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetVehicleId");
            }
            if (InsertionPosition == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "InsertionPosition");
            }
        }
    }
}
