// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents the address of a geographical object. Where a string, such
    /// as a city or street name, is available in multiple languages, it is
    /// returned in the default language specified by the object's location,
    /// i.e. in which country it is located. Because addressing schemes vary
    /// strongly between countries, most fields are optional.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xlocate.Address
    /// </summary>
    public partial class Address
    {
        /// <summary>
        /// Initializes a new instance of the Address class.
        /// </summary>
        public Address()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Address class.
        /// </summary>
        /// <param name="country">The country. In a response, it is represented
        /// by its full name (not abbreviated or encoded) unless a different
        /// representation is requested via
        /// SearchOptions.outputCountryType.</param>
        /// <param name="state">The name of the principal country subdivision
        /// which the address belongs to (for example, a state in the USA, or a
        /// canton in Switzerland).</param>
        /// <param name="province">The name of the second-level country
        /// subdivision which the address belongs to (for example, a county in
        /// the UK, or a province in Italy).</param>
        /// <param name="postalCode">The postal code of the address.</param>
        /// <param name="city">The city of the address, i.e. the highest entity
        /// at the communal level which the address belongs to.</param>
        /// <param name="district">The district of the address, i.e. the entity
        /// below city.</param>
        /// <param name="subdistrict">The subdistrict of the address, i.e. the
        /// entity below district.</param>
        /// <param name="street">The street of the address.</param>
        /// <param name="houseNumber">The house number of the address.</param>
        public Address(string country = default(string), string state = default(string), string province = default(string), string postalCode = default(string), string city = default(string), string district = default(string), string subdistrict = default(string), string street = default(string), string houseNumber = default(string))
        {
            Country = country;
            State = state;
            Province = province;
            PostalCode = postalCode;
            City = city;
            District = district;
            Subdistrict = subdistrict;
            Street = street;
            HouseNumber = houseNumber;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the country. In a response, it is represented by its
        /// full name (not abbreviated or encoded) unless a different
        /// representation is requested via SearchOptions.outputCountryType.
        /// </summary>
        [JsonProperty(PropertyName = "country")]
        public string Country { get; set; }

        /// <summary>
        /// Gets or sets the name of the principal country subdivision which
        /// the address belongs to (for example, a state in the USA, or a
        /// canton in Switzerland).
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets the name of the second-level country subdivision which
        /// the address belongs to (for example, a county in the UK, or a
        /// province in Italy).
        /// </summary>
        [JsonProperty(PropertyName = "province")]
        public string Province { get; set; }

        /// <summary>
        /// Gets or sets the postal code of the address.
        /// </summary>
        [JsonProperty(PropertyName = "postalCode")]
        public string PostalCode { get; set; }

        /// <summary>
        /// Gets or sets the city of the address, i.e. the highest entity at
        /// the communal level which the address belongs to.
        /// </summary>
        [JsonProperty(PropertyName = "city")]
        public string City { get; set; }

        /// <summary>
        /// Gets or sets the district of the address, i.e. the entity below
        /// city.
        /// </summary>
        [JsonProperty(PropertyName = "district")]
        public string District { get; set; }

        /// <summary>
        /// Gets or sets the subdistrict of the address, i.e. the entity below
        /// district.
        /// </summary>
        [JsonProperty(PropertyName = "subdistrict")]
        public string Subdistrict { get; set; }

        /// <summary>
        /// Gets or sets the street of the address.
        /// </summary>
        [JsonProperty(PropertyName = "street")]
        public string Street { get; set; }

        /// <summary>
        /// Gets or sets the house number of the address.
        /// </summary>
        [JsonProperty(PropertyName = "houseNumber")]
        public string HouseNumber { get; set; }

    }
}
