// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the allowed orientations for items. Depending on how an item
    /// is oriented, load will be applied on a different axis of the item if
    /// something is stacked on top of it. See ItemOrientation.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xload.AllowedItemOrientations
    /// </summary>
    public partial class AllowedItemOrientations
    {
        /// <summary>
        /// Initializes a new instance of the AllowedItemOrientations class.
        /// </summary>
        public AllowedItemOrientations()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AllowedItemOrientations class.
        /// </summary>
        /// <param name="original">Item are is allowed to be packed unrotated.
        /// Dimensions stay (x,y,z).</param>
        /// <param name="x">Items are allowed to be packed rotated widthwise
        /// (around x-axis) by 90 degrees. Dimensions would be (x,z,y).</param>
        /// <param name="y">Items are allowed to be packed rotated heightwise
        /// (around y-axis) by 90 degrees. Dimensions would be (z,y,x).</param>
        /// <param name="z">Items are allowed to be packed rotated lengthwise
        /// (around z-axis) by 90 degrees. Dimensions would be (y,x,z).</param>
        /// <param name="xz">Items are allowed to be packed rotated width- then
        /// heightwise (around x- then z-axis) by 90 degrees. Dimensions would
        /// be (z,x,y).</param>
        /// <param name="yz">Items are allowed to be packed rotated length-
        /// then heightwise (around its y- then z-axis) by 90 degrees.
        /// Dimensions would be (y,z,x).</param>
        public AllowedItemOrientations(bool? original = default(bool?), bool? x = default(bool?), bool? y = default(bool?), bool? z = default(bool?), bool? xz = default(bool?), bool? yz = default(bool?))
        {
            Original = original;
            X = x;
            Y = y;
            Z = z;
            Xz = xz;
            Yz = yz;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets item are is allowed to be packed unrotated. Dimensions
        /// stay (x,y,z).
        /// </summary>
        [JsonProperty(PropertyName = "original")]
        public bool? Original { get; set; }

        /// <summary>
        /// Gets or sets items are allowed to be packed rotated widthwise
        /// (around x-axis) by 90 degrees. Dimensions would be (x,z,y).
        /// </summary>
        [JsonProperty(PropertyName = "x")]
        public bool? X { get; set; }

        /// <summary>
        /// Gets or sets items are allowed to be packed rotated heightwise
        /// (around y-axis) by 90 degrees. Dimensions would be (z,y,x).
        /// </summary>
        [JsonProperty(PropertyName = "y")]
        public bool? Y { get; set; }

        /// <summary>
        /// Gets or sets items are allowed to be packed rotated lengthwise
        /// (around z-axis) by 90 degrees. Dimensions would be (y,x,z).
        /// </summary>
        [JsonProperty(PropertyName = "z")]
        public bool? Z { get; set; }

        /// <summary>
        /// Gets or sets items are allowed to be packed rotated width- then
        /// heightwise (around x- then z-axis) by 90 degrees. Dimensions would
        /// be (z,x,y).
        /// </summary>
        [JsonProperty(PropertyName = "xz")]
        public bool? Xz { get; set; }

        /// <summary>
        /// Gets or sets items are allowed to be packed rotated length- then
        /// heightwise (around its y- then z-axis) by 90 degrees. Dimensions
        /// would be (y,z,x).
        /// </summary>
        [JsonProperty(PropertyName = "yz")]
        public bool? Yz { get; set; }

    }
}
