// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes a cuboid bin type into which items can be packed.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xload.BinType
    /// </summary>
    public partial class BinType
    {
        /// <summary>
        /// Initializes a new instance of the BinType class.
        /// </summary>
        public BinType()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BinType class.
        /// </summary>
        /// <param name="id">User provided ID for this type of bin. Must be
        /// unique.</param>
        /// <param name="dimensions">Inner dimensions of a single bin of this
        /// type. Along each axis the dimension should be between 1 and 5000
        /// cm. The maximum volume of a bin is 425.385 m³ .</param>
        /// <param name="numberOfBins">Number of bins of this type available
        /// for packing. Maximum is 1000.</param>
        /// <param name="maximumVolumeCapacity">Maximum accumulated volume of
        /// items that can be packed into a single bin of this type
        /// irrespective of bin dimensions. This value must never exceed the
        /// natural inner volume specified by dimensions. If not given,
        /// defaults to the natural inner volume specified by dimensions.
        /// Internally rounded to nearest full cubic centimeter.</param>
        /// <param name="maximumWeightCapacity">Maximum accumulated weight of
        /// items that can be packed into a single bin of this type. If not
        /// given the weight capacity is assumed to be infinite. Internally
        /// rounded to nearest full gram. The maximum allowed weight capacity
        /// is 80 t.</param>
        public BinType(string id, BoxDimensions dimensions, int? numberOfBins = default(int?), double? maximumVolumeCapacity = default(double?), double? maximumWeightCapacity = default(double?))
        {
            Id = id;
            NumberOfBins = numberOfBins;
            Dimensions = dimensions;
            MaximumVolumeCapacity = maximumVolumeCapacity;
            MaximumWeightCapacity = maximumWeightCapacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets user provided ID for this type of bin. Must be unique.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets number of bins of this type available for packing.
        /// Maximum is 1000.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfBins")]
        public int? NumberOfBins { get; set; }

        /// <summary>
        /// Gets or sets inner dimensions of a single bin of this type. Along
        /// each axis the dimension should be between 1 and 5000 cm. The
        /// maximum volume of a bin is 425.385 m³ .
        /// </summary>
        [JsonProperty(PropertyName = "dimensions")]
        public BoxDimensions Dimensions { get; set; }

        /// <summary>
        /// Gets or sets maximum accumulated volume of items that can be packed
        /// into a single bin of this type irrespective of bin dimensions. This
        /// value must never exceed the natural inner volume specified by
        /// dimensions. If not given, defaults to the natural inner volume
        /// specified by dimensions. Internally rounded to nearest full cubic
        /// centimeter.
        /// </summary>
        [JsonProperty(PropertyName = "maximumVolumeCapacity")]
        public double? MaximumVolumeCapacity { get; set; }

        /// <summary>
        /// Gets or sets maximum accumulated weight of items that can be packed
        /// into a single bin of this type. If not given the weight capacity is
        /// assumed to be infinite. Internally rounded to nearest full gram.
        /// The maximum allowed weight capacity is 80 t.
        /// </summary>
        [JsonProperty(PropertyName = "maximumWeightCapacity")]
        public double? MaximumWeightCapacity { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (Dimensions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Dimensions");
            }
            if (Dimensions != null)
            {
                Dimensions.Validate();
            }
        }
    }
}
