// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A ChangeToursProposal contains a ChangeToursAction with information
    /// about the resulting ToursResponse if the change would be applied to the
    /// tour plan.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.ChangeToursProposal
    /// </summary>
    public partial class ChangeToursProposal
    {
        /// <summary>
        /// Initializes a new instance of the ChangeToursProposal class.
        /// </summary>
        public ChangeToursProposal()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ChangeToursProposal class.
        /// </summary>
        /// <param name="changeToursAction">The proposed ChangeToursAction that
        /// could be applied to the tour plan via a ChangeToursRequest.</param>
        /// <param name="violated">True if there is any tour violation.</param>
        /// <param name="preferencesRespected">True if all preferences for
        /// order group consideration are respected.</param>
        public ChangeToursProposal(ChangeToursAction changeToursAction = default(ChangeToursAction), IList<Tour> tours = default(IList<Tour>), IList<TourReport> tourReports = default(IList<TourReport>), IList<string> vehicleIdsNotPlanned = default(IList<string>), bool? violated = default(bool?), bool? preferencesRespected = default(bool?))
        {
            ChangeToursAction = changeToursAction;
            Tours = tours;
            TourReports = tourReports;
            VehicleIdsNotPlanned = vehicleIdsNotPlanned;
            Violated = violated;
            PreferencesRespected = preferencesRespected;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the proposed ChangeToursAction that could be applied
        /// to the tour plan via a ChangeToursRequest.
        /// </summary>
        [JsonProperty(PropertyName = "changeToursAction")]
        public ChangeToursAction ChangeToursAction { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tours")]
        public IList<Tour> Tours { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tourReports")]
        public IList<TourReport> TourReports { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "vehicleIdsNotPlanned")]
        public IList<string> VehicleIdsNotPlanned { get; set; }

        /// <summary>
        /// Gets or sets true if there is any tour violation.
        /// </summary>
        [JsonProperty(PropertyName = "violated")]
        public bool? Violated { get; set; }

        /// <summary>
        /// Gets or sets true if all preferences for order group consideration
        /// are respected.
        /// </summary>
        [JsonProperty(PropertyName = "preferencesRespected")]
        public bool? PreferencesRespected { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ChangeToursAction != null)
            {
                ChangeToursAction.Validate();
            }
            if (Tours != null)
            {
                foreach (var element in Tours)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (TourReports != null)
            {
                foreach (var element1 in TourReports)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
        }
    }
}
