// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contains parameter values for the basic clustering use cases.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.clusterplanningprofile.Clustering
    /// </summary>
    public partial class Clustering
    {
        /// <summary>
        /// Initializes a new instance of the Clustering class.
        /// </summary>
        public Clustering()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Clustering class.
        /// </summary>
        /// <param name="compactnessLevel">Defines the exponent with which the
        /// distances are incorporated in the model.</param>
        /// <param name="approximationTolerance">Defines (in percent) how close
        /// to the optimal solution value the solver should come before exiting
        /// an iteration. For instance, compared to 10% the value of 5% means
        /// better solution at the cost of higher running time.</param>
        /// <param name="performPreprocessingStep">Perform preprocessing to
        /// reduce the complexity of the optimization problem. For example by
        /// excluding forbidden or redundant combinations. For large problems
        /// the preprocessing itself can be very time-consuming.</param>
        /// <param name="boostActivityImportance">Setting this parameter will
        /// privilege important locations with high activity when determining
        /// territory centers.</param>
        /// <param name="maximumNumberOfIterations">The maximum number of
        /// iterations the solver may use to provide a solution.</param>
        /// <param name="minimumRelativeImprovement">The minimum relative
        /// solution value improvement (in percent) between iterations. If the
        /// relative improvement is less than the given value, no further
        /// iterations will be performed.</param>
        /// <param name="maximumNumberOfStarts">The maximum number of starts
        /// the solver may use to provide a solution. For each start the
        /// maximum number of iterations mentioned in this profile will be
        /// used.</param>
        /// <param name="maximumNumberOfSamplings">The maximum number of
        /// samplings needed mainly in the case that the number of territories
        /// is being changed and it is required to choose some "territory
        /// centers" from a given list.</param>
        /// <param name="numberOfNearestNeighbors">The number of nearest
        /// neighbors used for the tour estimator.</param>
        /// <param name="reassignmentMethod">Defines the method of reassignment
        /// for locations after an iteration. Setting this to REDUCE might
        /// yield a better solution at the cost of more execution time.
        /// Possible values include: 'DECIDE', 'REDUCE'</param>
        public Clustering(int? compactnessLevel = default(int?), double? approximationTolerance = default(double?), bool? performPreprocessingStep = default(bool?), bool? boostActivityImportance = default(bool?), int? maximumNumberOfIterations = default(int?), double? minimumRelativeImprovement = default(double?), int? maximumNumberOfStarts = default(int?), int? maximumNumberOfSamplings = default(int?), int? numberOfNearestNeighbors = default(int?), ReassignmentMethod? reassignmentMethod = default(ReassignmentMethod?))
        {
            CompactnessLevel = compactnessLevel;
            ApproximationTolerance = approximationTolerance;
            PerformPreprocessingStep = performPreprocessingStep;
            BoostActivityImportance = boostActivityImportance;
            MaximumNumberOfIterations = maximumNumberOfIterations;
            MinimumRelativeImprovement = minimumRelativeImprovement;
            MaximumNumberOfStarts = maximumNumberOfStarts;
            MaximumNumberOfSamplings = maximumNumberOfSamplings;
            NumberOfNearestNeighbors = numberOfNearestNeighbors;
            ReassignmentMethod = reassignmentMethod;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the exponent with which the distances are
        /// incorporated in the model.
        /// </summary>
        [JsonProperty(PropertyName = "compactnessLevel")]
        public int? CompactnessLevel { get; set; }

        /// <summary>
        /// Gets or sets defines (in percent) how close to the optimal solution
        /// value the solver should come before exiting an iteration. For
        /// instance, compared to 10% the value of 5% means better solution at
        /// the cost of higher running time.
        /// </summary>
        [JsonProperty(PropertyName = "approximationTolerance")]
        public double? ApproximationTolerance { get; set; }

        /// <summary>
        /// Gets or sets perform preprocessing to reduce the complexity of the
        /// optimization problem. For example by excluding forbidden or
        /// redundant combinations. For large problems the preprocessing itself
        /// can be very time-consuming.
        /// </summary>
        [JsonProperty(PropertyName = "performPreprocessingStep")]
        public bool? PerformPreprocessingStep { get; set; }

        /// <summary>
        /// Gets or sets setting this parameter will privilege important
        /// locations with high activity when determining territory centers.
        /// </summary>
        [JsonProperty(PropertyName = "boostActivityImportance")]
        public bool? BoostActivityImportance { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of iterations the solver may use to
        /// provide a solution.
        /// </summary>
        [JsonProperty(PropertyName = "maximumNumberOfIterations")]
        public int? MaximumNumberOfIterations { get; set; }

        /// <summary>
        /// Gets or sets the minimum relative solution value improvement (in
        /// percent) between iterations. If the relative improvement is less
        /// than the given value, no further iterations will be performed.
        /// </summary>
        [JsonProperty(PropertyName = "minimumRelativeImprovement")]
        public double? MinimumRelativeImprovement { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of starts the solver may use to
        /// provide a solution. For each start the maximum number of iterations
        /// mentioned in this profile will be used.
        /// </summary>
        [JsonProperty(PropertyName = "maximumNumberOfStarts")]
        public int? MaximumNumberOfStarts { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of samplings needed mainly in the
        /// case that the number of territories is being changed and it is
        /// required to choose some "territory centers" from a given list.
        /// </summary>
        [JsonProperty(PropertyName = "maximumNumberOfSamplings")]
        public int? MaximumNumberOfSamplings { get; set; }

        /// <summary>
        /// Gets or sets the number of nearest neighbors used for the tour
        /// estimator.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfNearestNeighbors")]
        public int? NumberOfNearestNeighbors { get; set; }

        /// <summary>
        /// Gets or sets defines the method of reassignment for locations after
        /// an iteration. Setting this to REDUCE might yield a better solution
        /// at the cost of more execution time. Possible values include:
        /// 'DECIDE', 'REDUCE'
        /// </summary>
        [JsonProperty(PropertyName = "reassignmentMethod")]
        public ReassignmentMethod? ReassignmentMethod { get; set; }

    }
}
