// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Cost related information describing tours or trips. The cost report
    /// contains accumulated values describing its parent object, which is
    /// either a tour response, a tour report or a trip report.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.CostReport
    /// </summary>
    public partial class CostReport
    {
        /// <summary>
        /// Initializes a new instance of the CostReport class.
        /// </summary>
        public CostReport()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CostReport class.
        /// </summary>
        /// <param name="travelTime">The total duration between start and end
        /// of the described object. The travelTime contains all waiting,
        /// service, driving, break and rest times.</param>
        /// <param name="drivingTime">The total driving time, which is the sum
        /// of the length of all driving events. The driving time of an empty
        /// ride might not belong to any trip. See Tours and Trips.</param>
        /// <param name="distance">The total driven distance.</param>
        /// <param name="serviceTime">The total service time, which is the sum
        /// of the length of all service events.</param>
        public CostReport(double travelTime, double drivingTime, double distance, double? serviceTime = default(double?))
        {
            TravelTime = travelTime;
            DrivingTime = drivingTime;
            ServiceTime = serviceTime;
            Distance = distance;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the total duration between start and end of the
        /// described object. The travelTime contains all waiting, service,
        /// driving, break and rest times.
        /// </summary>
        [JsonProperty(PropertyName = "travelTime")]
        public double TravelTime { get; set; }

        /// <summary>
        /// Gets or sets the total driving time, which is the sum of the length
        /// of all driving events. The driving time of an empty ride might not
        /// belong to any trip. See Tours and Trips.
        /// </summary>
        [JsonProperty(PropertyName = "drivingTime")]
        public double DrivingTime { get; set; }

        /// <summary>
        /// Gets or sets the total service time, which is the sum of the length
        /// of all service events.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTime")]
        public double? ServiceTime { get; set; }

        /// <summary>
        /// Gets or sets the total driven distance.
        /// </summary>
        [JsonProperty(PropertyName = "distance")]
        public double Distance { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
