// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the parameters of the routing algorithm that control the course
    /// of the route.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.routingprofile.Course
    /// </summary>
    public partial class Course
    {
        /// <summary>
        /// Initializes a new instance of the Course class.
        /// </summary>
        public Course()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Course class.
        /// </summary>
        /// <param name="violations">Defines the parameters that control
        /// whether road restrictions can be violated. See the technical
        /// concept for details.</param>
        /// <param name="network">Defines the parameters that concern network
        /// specific segment attributes, e.g. penalties for road segments of a
        /// certain network class.</param>
        /// <param name="toll">Defines the parameters for toll specific segment
        /// attributes, e.g. penalty of toll segments, etc.</param>
        /// <param name="specialAreas">Defines the parameters concerning the
        /// special areas, such as urban segments, low emission zones,
        /// etc.</param>
        /// <param name="combinedTransport">Defines the parameters concerning
        /// combined transport like the truck being carried by boat or by
        /// rail.</param>
        /// <param name="maneuver">Defines the parameters that control how
        /// special maneuvers (turns) affect the route calculation.</param>
        /// <param name="distanceTimeWeighting">The weight factor for route
        /// travel time. The distance enters the basic cost term with a weight
        /// of 100 - distanceTimeWeighting. Hence, with a value of 100, only
        /// travel time is optimized, while with a value of 0 only the distance
        /// of the route is optimized.</param>
        public Course(Violations violations = default(Violations), Network network = default(Network), Toll toll = default(Toll), SpecialAreas specialAreas = default(SpecialAreas), CombinedTransport combinedTransport = default(CombinedTransport), Maneuver maneuver = default(Maneuver), double? distanceTimeWeighting = default(double?))
        {
            Violations = violations;
            Network = network;
            Toll = toll;
            SpecialAreas = specialAreas;
            CombinedTransport = combinedTransport;
            Maneuver = maneuver;
            DistanceTimeWeighting = distanceTimeWeighting;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the parameters that control whether road
        /// restrictions can be violated. See the technical concept for
        /// details.
        /// </summary>
        [JsonProperty(PropertyName = "violations")]
        public Violations Violations { get; set; }

        /// <summary>
        /// Gets or sets defines the parameters that concern network specific
        /// segment attributes, e.g. penalties for road segments of a certain
        /// network class.
        /// </summary>
        [JsonProperty(PropertyName = "network")]
        public Network Network { get; set; }

        /// <summary>
        /// Gets or sets defines the parameters for toll specific segment
        /// attributes, e.g. penalty of toll segments, etc.
        /// </summary>
        [JsonProperty(PropertyName = "toll")]
        public Toll Toll { get; set; }

        /// <summary>
        /// Gets or sets defines the parameters concerning the special areas,
        /// such as urban segments, low emission zones, etc.
        /// </summary>
        [JsonProperty(PropertyName = "specialAreas")]
        public SpecialAreas SpecialAreas { get; set; }

        /// <summary>
        /// Gets or sets defines the parameters concerning combined transport
        /// like the truck being carried by boat or by rail.
        /// </summary>
        [JsonProperty(PropertyName = "combinedTransport")]
        public CombinedTransport CombinedTransport { get; set; }

        /// <summary>
        /// Gets or sets defines the parameters that control how special
        /// maneuvers (turns) affect the route calculation.
        /// </summary>
        [JsonProperty(PropertyName = "maneuver")]
        public Maneuver Maneuver { get; set; }

        /// <summary>
        /// Gets or sets the weight factor for route travel time. The distance
        /// enters the basic cost term with a weight of 100 -
        /// distanceTimeWeighting. Hence, with a value of 100, only travel time
        /// is optimized, while with a value of 0 only the distance of the
        /// route is optimized.
        /// </summary>
        [JsonProperty(PropertyName = "distanceTimeWeighting")]
        public double? DistanceTimeWeighting { get; set; }

    }
}
