// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Input parameters for the covering algorithm.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.CoverLocationsOptions
    /// </summary>
    public partial class CoverLocationsOptions
    {
        /// <summary>
        /// Initializes a new instance of the CoverLocationsOptions class.
        /// </summary>
        public CoverLocationsOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CoverLocationsOptions class.
        /// </summary>
        /// <param name="coveringHorizon">Defines the coverage radius of a
        /// cluster, i.e. all locations included in the horzion of a cluster
        /// are covered by it. A horizon can be specified by travel time or by
        /// distance, depending on its specific type DistanceBasedHorizon or
        /// TravelTimeBasedHorizon.</param>
        /// <param name="optimizationGoal">Defines the optimization goal for
        /// the algorithm. The optimization goal can be seen as exit criterion
        /// for iterations of the algorithm.</param>
        public CoverLocationsOptions(Horizon coveringHorizon, OptimizationGoal optimizationGoal, IList<string> mandatoryLocationIds = default(IList<string>), IList<string> mandatoryClusterIds = default(IList<string>))
        {
            CoveringHorizon = coveringHorizon;
            OptimizationGoal = optimizationGoal;
            MandatoryLocationIds = mandatoryLocationIds;
            MandatoryClusterIds = mandatoryClusterIds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the coverage radius of a cluster, i.e. all
        /// locations included in the horzion of a cluster are covered by it. A
        /// horizon can be specified by travel time or by distance, depending
        /// on its specific type DistanceBasedHorizon or
        /// TravelTimeBasedHorizon.
        /// </summary>
        [JsonProperty(PropertyName = "coveringHorizon")]
        public Horizon CoveringHorizon { get; set; }

        /// <summary>
        /// Gets or sets defines the optimization goal for the algorithm. The
        /// optimization goal can be seen as exit criterion for iterations of
        /// the algorithm.
        /// </summary>
        [JsonProperty(PropertyName = "optimizationGoal")]
        public OptimizationGoal OptimizationGoal { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "mandatoryLocationIds")]
        public IList<string> MandatoryLocationIds { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "mandatoryClusterIds")]
        public IList<string> MandatoryClusterIds { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CoveringHorizon == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CoveringHorizon");
            }
            if (OptimizationGoal == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OptimizationGoal");
            }
        }
    }
}
