// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// This type represents meta data about a distance matrix.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xdima.DistanceMatrixDescription
    /// </summary>
    public partial class DistanceMatrixDescription
    {
        /// <summary>
        /// Initializes a new instance of the DistanceMatrixDescription class.
        /// </summary>
        public DistanceMatrixDescription()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DistanceMatrixDescription class.
        /// </summary>
        /// <param name="summary">The summary of this distance matrix.</param>
        /// <param name="distanceMatrixOptions">The options used for
        /// calculation of this distance matrix.
        ///
        /// Warning: Options are removed from the response if they cannot be
        /// represented using the requested API version. This situation might
        /// occur if a more recent API version was used for the creation of the
        /// distance matrix than for this list request. In general, it is not
        /// recommended to mix different API versions.</param>
        /// <param name="profile">The profile used for calculation of this
        /// distance matrix.
        ///
        /// Warning: Profile elements are removed from the response if they
        /// cannot be represented using the requested API version. This
        /// restriction also applies to elements of the stored profile used for
        /// calculation of this distance matrix. If the returned profile should
        /// be used as a request profile in a subsequent request (e.g. for
        /// creating another distance matrix or for a route calculation), it is
        /// recommended to specify the same stored profile as in the original
        /// create request. In general, it is not recommended to mix different
        /// API versions.</param>
        /// <param name="tenant">The tenant is returned only for
        /// administrators.</param>
        /// <param name="scope">The user defined scope.</param>
        /// <param name="lastUsedAt">Indicates the date the distance matrix was
        /// used the last time.</param>
        public DistanceMatrixDescription(DistanceMatrixSummary summary, IList<RouteLocation> startLocations = default(IList<RouteLocation>), IList<RouteLocation> destinationLocations = default(IList<RouteLocation>), IList<Relation> directDistanceRelations = default(IList<Relation>), DistanceMatrixOptions distanceMatrixOptions = default(DistanceMatrixOptions), RequestProfile profile = default(RequestProfile), string tenant = default(string), string scope = default(string), System.DateTime? lastUsedAt = default(System.DateTime?))
        {
            Summary = summary;
            StartLocations = startLocations;
            DestinationLocations = destinationLocations;
            DirectDistanceRelations = directDistanceRelations;
            DistanceMatrixOptions = distanceMatrixOptions;
            Profile = profile;
            Tenant = tenant;
            Scope = scope;
            LastUsedAt = lastUsedAt;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the summary of this distance matrix.
        /// </summary>
        [JsonProperty(PropertyName = "summary")]
        public DistanceMatrixSummary Summary { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "startLocations")]
        public IList<RouteLocation> StartLocations { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "destinationLocations")]
        public IList<RouteLocation> DestinationLocations { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "directDistanceRelations")]
        public IList<Relation> DirectDistanceRelations { get; set; }

        /// <summary>
        /// Gets or sets the options used for calculation of this distance
        /// matrix.
        ///
        /// Warning: Options are removed from the response if they cannot be
        /// represented using the requested API version. This situation might
        /// occur if a more recent API version was used for the creation of the
        /// distance matrix than for this list request. In general, it is not
        /// recommended to mix different API versions.
        /// </summary>
        [JsonProperty(PropertyName = "distanceMatrixOptions")]
        public DistanceMatrixOptions DistanceMatrixOptions { get; set; }

        /// <summary>
        /// Gets or sets the profile used for calculation of this distance
        /// matrix.
        ///
        /// Warning: Profile elements are removed from the response if they
        /// cannot be represented using the requested API version. This
        /// restriction also applies to elements of the stored profile used for
        /// calculation of this distance matrix. If the returned profile should
        /// be used as a request profile in a subsequent request (e.g. for
        /// creating another distance matrix or for a route calculation), it is
        /// recommended to specify the same stored profile as in the original
        /// create request. In general, it is not recommended to mix different
        /// API versions.
        /// </summary>
        [JsonProperty(PropertyName = "profile")]
        public RequestProfile Profile { get; set; }

        /// <summary>
        /// Gets or sets the tenant is returned only for administrators.
        /// </summary>
        [JsonProperty(PropertyName = "tenant")]
        public string Tenant { get; set; }

        /// <summary>
        /// Gets or sets the user defined scope.
        /// </summary>
        [JsonProperty(PropertyName = "scope")]
        public string Scope { get; set; }

        /// <summary>
        /// Gets or sets indicates the date the distance matrix was used the
        /// last time.
        /// </summary>
        [JsonProperty(PropertyName = "lastUsedAt")]
        public System.DateTime? LastUsedAt { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Summary == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Summary");
            }
            if (Summary != null)
            {
                Summary.Validate();
            }
            if (DirectDistanceRelations != null)
            {
                foreach (var element in DirectDistanceRelations)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (DistanceMatrixOptions != null)
            {
                DistanceMatrixOptions.Validate();
            }
        }
    }
}
