// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This type represents options of a distance matrix.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.dima.DistanceMatrixOptions
    /// </summary>
    public partial class DistanceMatrixOptions
    {
        /// <summary>
        /// Initializes a new instance of the DistanceMatrixOptions class.
        /// </summary>
        public DistanceMatrixOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DistanceMatrixOptions class.
        /// </summary>
        /// <param name="timeConsideration">Set this parameter if time
        /// dependent features should be considered for the distance matrix
        /// calculation. The different scenarios of time consideration are
        /// explained in more detail in the technical concept about time
        /// consideration. If the object is NULL, all data which have time
        /// restrictions are not considered. For some scenarios a reference
        /// time is needed to match properties with a time domain against this
        /// reference time. If for this time no time zone is defined, i.e. it
        /// represents a local time, all matrix locations are checked for their
        /// time zone offsets. If a time zone cannot be determined for such a
        /// location, this location is not taken into further consideration.
        /// So, in a first step a set of locations with calculated time zones
        /// is determined. If this set contains no elements, an exception is
        /// thrown. When the time zones differ for some locations, then the
        /// time zone containing most locations is used and a result limitation
        /// is added to the result. If all locations are in the same time zone,
        /// then this time zone is used and the result is calculated as usual.
        /// Please note that the time consideration values
        /// ExactTimeConsiderationAtStart and ExactTimeConsiderationAtArrival
        /// are not available and if used an exception will be
        /// returned.</param>
        /// <param name="contentSnapshotId">Specifies the content snapshot to
        /// use. If no snapshot ID is set, the most recent content is
        /// used.</param>
        /// <param name="highPerformanceRoutingNetworkId">Specifies the
        /// high-performance routing network to use. Besides, the routing type
        /// must be explicitly set to RoutingType.HIGH\_PERFORMANCE\_ROUTING
        /// otherwise a exceptions.ParameterConflictException is thrown. The
        /// profile and request parameters of the high-performance routing
        /// network are used for linking and routing. The stored profile of the
        /// service.RequestBase will be ignored. Throws a
        /// exceptions.DataNotAvailableException if the high-performance
        /// routing network with the given id does not exist.</param>
        /// <param name="geographicRestrictions">Geographic restrictions that
        /// are considered for each routing that is done during the distance
        /// matrix calculation.</param>
        /// <param name="detourFactor">A factor that describes the average
        /// detour an actual route on the road requires, compared to the direct
        /// distance. This factor is used to approximate a relation that could
        /// not be calculated using the road network.</param>
        /// <param name="averageSpeed">The average speed of the vehicle. This
        /// parameter is used to approximate a relation that could not be
        /// calculated using the road network.</param>
        /// <param name="routingType">Strategy to decide if high-performance
        /// routing or conventional routing is used. For further explanation
        /// see the definition of RoutingType. Possible values include:
        /// 'CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING_WITH_FALLBACK_CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING'</param>
        public DistanceMatrixOptions(TimeConsideration timeConsideration = default(TimeConsideration), string contentSnapshotId = default(string), string highPerformanceRoutingNetworkId = default(string), GeographicRestrictions geographicRestrictions = default(GeographicRestrictions), double? detourFactor = default(double?), double? averageSpeed = default(double?), RoutingType? routingType = default(RoutingType?))
        {
            TimeConsideration = timeConsideration;
            ContentSnapshotId = contentSnapshotId;
            HighPerformanceRoutingNetworkId = highPerformanceRoutingNetworkId;
            GeographicRestrictions = geographicRestrictions;
            DetourFactor = detourFactor;
            AverageSpeed = averageSpeed;
            RoutingType = routingType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets set this parameter if time dependent features should
        /// be considered for the distance matrix calculation. The different
        /// scenarios of time consideration are explained in more detail in the
        /// technical concept about time consideration. If the object is NULL,
        /// all data which have time restrictions are not considered. For some
        /// scenarios a reference time is needed to match properties with a
        /// time domain against this reference time. If for this time no time
        /// zone is defined, i.e. it represents a local time, all matrix
        /// locations are checked for their time zone offsets. If a time zone
        /// cannot be determined for such a location, this location is not
        /// taken into further consideration. So, in a first step a set of
        /// locations with calculated time zones is determined. If this set
        /// contains no elements, an exception is thrown. When the time zones
        /// differ for some locations, then the time zone containing most
        /// locations is used and a result limitation is added to the result.
        /// If all locations are in the same time zone, then this time zone is
        /// used and the result is calculated as usual. Please note that the
        /// time consideration values ExactTimeConsiderationAtStart and
        /// ExactTimeConsiderationAtArrival are not available and if used an
        /// exception will be returned.
        /// </summary>
        [JsonProperty(PropertyName = "timeConsideration")]
        public TimeConsideration TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets specifies the content snapshot to use. If no snapshot
        /// ID is set, the most recent content is used.
        /// </summary>
        [JsonProperty(PropertyName = "contentSnapshotId")]
        public string ContentSnapshotId { get; set; }

        /// <summary>
        /// Gets or sets specifies the high-performance routing network to use.
        /// Besides, the routing type must be explicitly set to
        /// RoutingType.HIGH\_PERFORMANCE\_ROUTING otherwise a
        /// exceptions.ParameterConflictException is thrown. The profile and
        /// request parameters of the high-performance routing network are used
        /// for linking and routing. The stored profile of the
        /// service.RequestBase will be ignored. Throws a
        /// exceptions.DataNotAvailableException if the high-performance
        /// routing network with the given id does not exist.
        /// </summary>
        [JsonProperty(PropertyName = "highPerformanceRoutingNetworkId")]
        public string HighPerformanceRoutingNetworkId { get; set; }

        /// <summary>
        /// Gets or sets geographic restrictions that are considered for each
        /// routing that is done during the distance matrix calculation.
        /// </summary>
        [JsonProperty(PropertyName = "geographicRestrictions")]
        public GeographicRestrictions GeographicRestrictions { get; set; }

        /// <summary>
        /// Gets or sets a factor that describes the average detour an actual
        /// route on the road requires, compared to the direct distance. This
        /// factor is used to approximate a relation that could not be
        /// calculated using the road network.
        /// </summary>
        [JsonProperty(PropertyName = "detourFactor")]
        public double? DetourFactor { get; set; }

        /// <summary>
        /// Gets or sets the average speed of the vehicle. This parameter is
        /// used to approximate a relation that could not be calculated using
        /// the road network.
        /// </summary>
        [JsonProperty(PropertyName = "averageSpeed")]
        public double? AverageSpeed { get; set; }

        /// <summary>
        /// Gets or sets strategy to decide if high-performance routing or
        /// conventional routing is used. For further explanation see the
        /// definition of RoutingType. Possible values include: 'CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING_WITH_FALLBACK_CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING'
        /// </summary>
        [JsonProperty(PropertyName = "routingType")]
        public RoutingType? RoutingType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (GeographicRestrictions != null)
            {
                GeographicRestrictions.Validate();
            }
        }
    }
}
