// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents the meta information of a distance matrix.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.dima.DistanceMatrixSummary
    /// </summary>
    public partial class DistanceMatrixSummary
    {
        /// <summary>
        /// Initializes a new instance of the DistanceMatrixSummary class.
        /// </summary>
        public DistanceMatrixSummary()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DistanceMatrixSummary class.
        /// </summary>
        /// <param name="numberOfStartLocations">The number of start locations
        /// in the distance matrix.</param>
        /// <param name="numberOfDestinationLocations">The number of
        /// destination locations in the distance matrix.</param>
        /// <param name="percentageOfDirectDistanceRelations">Percentage of
        /// relations in the distance matrix which has not been calculated
        /// successfully. It depends on the use case and the geographical
        /// region which values can be tolerated or not.</param>
        /// <param name="id">The ID of the distance matrix which is generated
        /// when the distance matrix is created. Use this ID to reference the
        /// matrix for further use.</param>
        /// <param name="routingType">Indicates what route calculation
        /// algorithm was used for the distances matrix calculation. If a
        /// profile dependent high-performance routing network is configured
        /// but there is no matching high-performance graph for the called
        /// profile the routing mode will fall back to profile independent
        /// routing. Possible values include: 'CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING_WITH_FALLBACK_CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING'</param>
        /// <param name="label">The optional label of the distance matrix, if
        /// it was specified in the request. This label is only used for
        /// displaying the distance matrix, e.g. in the dashboard, and is not
        /// considered in any other way.</param>
        public DistanceMatrixSummary(int numberOfStartLocations, int numberOfDestinationLocations, double percentageOfDirectDistanceRelations, string id = default(string), RoutingType? routingType = default(RoutingType?), string label = default(string))
        {
            Id = id;
            NumberOfStartLocations = numberOfStartLocations;
            NumberOfDestinationLocations = numberOfDestinationLocations;
            PercentageOfDirectDistanceRelations = percentageOfDirectDistanceRelations;
            RoutingType = routingType;
            Label = label;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the ID of the distance matrix which is generated when
        /// the distance matrix is created. Use this ID to reference the matrix
        /// for further use.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the number of start locations in the distance matrix.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfStartLocations")]
        public int NumberOfStartLocations { get; set; }

        /// <summary>
        /// Gets or sets the number of destination locations in the distance
        /// matrix.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfDestinationLocations")]
        public int NumberOfDestinationLocations { get; set; }

        /// <summary>
        /// Gets or sets percentage of relations in the distance matrix which
        /// has not been calculated successfully. It depends on the use case
        /// and the geographical region which values can be tolerated or not.
        /// </summary>
        [JsonProperty(PropertyName = "percentageOfDirectDistanceRelations")]
        public double PercentageOfDirectDistanceRelations { get; set; }

        /// <summary>
        /// Gets or sets indicates what route calculation algorithm was used
        /// for the distances matrix calculation. If a profile dependent
        /// high-performance routing network is configured but there is no
        /// matching high-performance graph for the called profile the routing
        /// mode will fall back to profile independent routing. Possible values
        /// include: 'CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING_WITH_FALLBACK_CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING'
        /// </summary>
        [JsonProperty(PropertyName = "routingType")]
        public RoutingType? RoutingType { get; set; }

        /// <summary>
        /// Gets or sets the optional label of the distance matrix, if it was
        /// specified in the request. This label is only used for displaying
        /// the distance matrix, e.g. in the dashboard, and is not considered
        /// in any other way.
        /// </summary>
        [JsonProperty(PropertyName = "label")]
        public string Label { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
