// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A driver is always assigned to a specific vehicle instance and may not
    /// always be available to operate it. To be precise, a driver can only
    /// operate the corresponding vehicle instance within given time intervals.
    /// In addition, it may be specified how long the driver has already
    /// worked.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.Driver
    /// </summary>
    public partial class Driver
    {
        /// <summary>
        /// Initializes a new instance of the Driver class.
        /// </summary>
        public Driver()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Driver class.
        /// </summary>
        /// <param name="id">ID of the driver.</param>
        /// <param name="vehicleId">ID of the driver's vehicle.</param>
        /// <param name="workLogbookSummary">The summary of a logbook of a
        /// driver. If such a summary is missing, it is assumed that the driver
        /// is fully rested.</param>
        public Driver(string id, string vehicleId, IList<Interval> operatingIntervals = default(IList<Interval>), WorkLogbookSummary workLogbookSummary = default(WorkLogbookSummary))
        {
            Id = id;
            OperatingIntervals = operatingIntervals;
            VehicleId = vehicleId;
            WorkLogbookSummary = workLogbookSummary;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the driver.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "operatingIntervals")]
        public IList<Interval> OperatingIntervals { get; set; }

        /// <summary>
        /// Gets or sets ID of the driver's vehicle.
        /// </summary>
        [JsonProperty(PropertyName = "vehicleId")]
        public string VehicleId { get; set; }

        /// <summary>
        /// Gets or sets the summary of a logbook of a driver. If such a
        /// summary is missing, it is assumed that the driver is fully rested.
        /// </summary>
        [JsonProperty(PropertyName = "workLogbookSummary")]
        public WorkLogbookSummary WorkLogbookSummary { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (VehicleId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VehicleId");
            }
            if (WorkLogbookSummary != null)
            {
                WorkLogbookSummary.Validate();
            }
        }
    }
}
