// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The attributes for calculating CEN or factor-based emissions. The
    /// response element contains only those scenarios for which the
    /// corresponding request parameter is set.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.EffectiveFuelConsumption
    /// </summary>
    public partial class EffectiveFuelConsumption
    {
        /// <summary>
        /// Initializes a new instance of the EffectiveFuelConsumption class.
        /// </summary>
        public EffectiveFuelConsumption()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EffectiveFuelConsumption class.
        /// </summary>
        /// <param name="fleetSpecificAverageFuelConsumption">The average fuel
        /// consumption for a fleet in \[l/100km\] for liquid fuel types or
        /// \[kg/100km\] for gaseous fuel types like
        /// COMPRESSED\_NATURAL\_GAS.</param>
        /// <param name="routeSpecificAverageFuelConsumption">The average fuel
        /// consumption for a specific type of route in \[l/100km\] for liquid
        /// fuel types or \[kg/100km\] for gaseous fuel types like
        /// COMPRESSED\_NATURAL\_GAS.</param>
        /// <param name="actualFuelConsumptionForThisRoute">The actual fuel
        /// consumption for this route in \[l\] for liquid fuel types or \[kg\]
        /// for gaseous fuel types like COMPRESSED\_NATURAL\_GAS.</param>
        public EffectiveFuelConsumption(double? fleetSpecificAverageFuelConsumption = default(double?), double? routeSpecificAverageFuelConsumption = default(double?), double? actualFuelConsumptionForThisRoute = default(double?))
        {
            FleetSpecificAverageFuelConsumption = fleetSpecificAverageFuelConsumption;
            RouteSpecificAverageFuelConsumption = routeSpecificAverageFuelConsumption;
            ActualFuelConsumptionForThisRoute = actualFuelConsumptionForThisRoute;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the average fuel consumption for a fleet in
        /// \[l/100km\] for liquid fuel types or \[kg/100km\] for gaseous fuel
        /// types like COMPRESSED\_NATURAL\_GAS.
        /// </summary>
        [JsonProperty(PropertyName = "fleetSpecificAverageFuelConsumption")]
        public double? FleetSpecificAverageFuelConsumption { get; set; }

        /// <summary>
        /// Gets or sets the average fuel consumption for a specific type of
        /// route in \[l/100km\] for liquid fuel types or \[kg/100km\] for
        /// gaseous fuel types like COMPRESSED\_NATURAL\_GAS.
        /// </summary>
        [JsonProperty(PropertyName = "routeSpecificAverageFuelConsumption")]
        public double? RouteSpecificAverageFuelConsumption { get; set; }

        /// <summary>
        /// Gets or sets the actual fuel consumption for this route in \[l\]
        /// for liquid fuel types or \[kg\] for gaseous fuel types like
        /// COMPRESSED\_NATURAL\_GAS.
        /// </summary>
        [JsonProperty(PropertyName = "actualFuelConsumptionForThisRoute")]
        public double? ActualFuelConsumptionForThisRoute { get; set; }

    }
}
