// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An EncodedGeometry contains one or more representations of the same
    /// Geometry which can be selected for each request by
    /// service.GeometryOptions.responseGeometryTypes. If z-coordinates have to
    /// be represented WKB and WKT are used in an extended form as described by
    /// OpenGIS document 99-402r2.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.geometry.EncodedGeometry
    /// </summary>
    public partial class EncodedGeometry
    {
        /// <summary>
        /// Initializes a new instance of the EncodedGeometry class.
        /// </summary>
        public EncodedGeometry()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EncodedGeometry class.
        /// </summary>
        /// <param name="plain">The plain representation of the geometry using
        /// structured objects.</param>
        /// <param name="wkb">The WKB (well-known binary) representation of the
        /// geometry</param>
        /// <param name="wkt">The WKT (well-known text) representation of the
        /// geometry.</param>
        /// <param name="kml">The KML (keyhole markup language) representation
        /// of the geometry. Coordinates are always present in WGS84
        /// (EPSG:4326).</param>
        /// <param name="geoJSON">The GeoJSON representation of the geometry.
        /// Coordinates are always present in WGS84 (EPSG:4326).</param>
        public EncodedGeometry(Geometry plain = default(Geometry), byte[] wkb = default(byte[]), string wkt = default(string), KML kml = default(KML), string geoJSON = default(string))
        {
            Plain = plain;
            Wkb = wkb;
            Wkt = wkt;
            Kml = kml;
            GeoJSON = geoJSON;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the plain representation of the geometry using
        /// structured objects.
        /// </summary>
        [JsonProperty(PropertyName = "plain")]
        public Geometry Plain { get; set; }

        /// <summary>
        /// Gets or sets the WKB (well-known binary) representation of the
        /// geometry
        /// </summary>
        [JsonProperty(PropertyName = "wkb")]
        public byte[] Wkb { get; set; }

        /// <summary>
        /// Gets or sets the WKT (well-known text) representation of the
        /// geometry.
        /// </summary>
        [JsonProperty(PropertyName = "wkt")]
        public string Wkt { get; set; }

        /// <summary>
        /// Gets or sets the KML (keyhole markup language) representation of
        /// the geometry. Coordinates are always present in WGS84 (EPSG:4326).
        /// </summary>
        [JsonProperty(PropertyName = "kml")]
        public KML Kml { get; set; }

        /// <summary>
        /// Gets or sets the GeoJSON representation of the geometry.
        /// Coordinates are always present in WGS84 (EPSG:4326).
        /// </summary>
        [JsonProperty(PropertyName = "geoJSON")]
        public string GeoJSON { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Kml != null)
            {
                Kml.Validate();
            }
        }
    }
}
