// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the engine parameters of the vehicle. These parameters are only
    /// relevant if the driveType is MOTOR\_VEHICLE.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.vehicleprofile.Engine
    /// </summary>
    public partial class Engine
    {
        /// <summary>
        /// Initializes a new instance of the Engine class.
        /// </summary>
        public Engine()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Engine class.
        /// </summary>
        /// <param name="engineType">The engine type. Depending on the engine
        /// type only a subset of the other engine parameters are relevant.
        /// Possible values include: 'COMBUSTION', 'ELECTRIC'</param>
        /// <param name="cylinderCapacity">The cylinder capacity. (2,3)</param>
        /// <param name="fuelType">The type of fuel (gasoline, diesel, etc.).
        /// (3). Possible values include: 'GASOLINE', 'DIESEL',
        /// 'COMPRESSED_NATURAL_GAS', 'LIQUEFIED_PETROLEUM_GAS'</param>
        /// <param name="bioFuelRatio">The ratio of biofuel to conventional
        /// fuel. (3)</param>
        /// <param name="fuelConsumption">The fuel consumption. The unit
        /// depends on the fuel type. (3)</param>
        /// <param name="emissionTechnology">The emission technology (only
        /// relevant for some emission classes). (3). Possible values include:
        /// 'NONE', 'EXHAUST_GAS_RECIRCULATION',
        /// 'SELECTIVE_CATALYTIC_REDUCTION'</param>
        /// <param name="particleFilterInstalled">Describes if a particle
        /// filter is installed. (2)</param>
        /// <param name="particleReductionClass">The particle reduction class
        /// (Partikelminderungsklasse) according to "Anlage XIV zu § 48 StVZO"
        /// (German law). (2). Possible values include: 'PMK_0', 'PMK_1',
        /// 'PMK_2', 'PMK_3', 'PMK_4'</param>
        /// <param name="emissionStandardEU">The emission standard valid in the
        /// European Union. (2,3). Possible values include: 'NONE', 'EURO_0',
        /// 'EURO_1', 'EURO_2', 'EURO_3', 'EURO_4', 'EURO_5', 'EURO_EEV',
        /// 'EURO_6', 'EURO_6c', 'EURO_7'</param>
        /// <param name="emissionStandardAustralia">The emission standard valid
        /// in Australia. (2,3). Possible values include: 'NONE', 'ADR_30',
        /// 'ADR_70_00', 'ADR_80_00', 'ADR_80_02', 'ADR_80_03', 'ADR_80_04',
        /// 'ADR_80_05'</param>
        /// <param name="lowEmissionZoneTypes">The low-emission zone types of
        /// the vehicle as a comma-separated list. The treatment of road
        /// segments that are not allowed because of the low-emission zone type
        /// is controlled by the penalty value forbiddenLowEmissionZonePenalty.
        /// Available types are DE\_GREEN, DE\_YELLOW, DE\_RED for Germany.
        /// (1)</param>
        public Engine(EngineType? engineType = default(EngineType?), int? cylinderCapacity = default(int?), FuelType? fuelType = default(FuelType?), double? bioFuelRatio = default(double?), double? fuelConsumption = default(double?), EmissionTechnology? emissionTechnology = default(EmissionTechnology?), bool? particleFilterInstalled = default(bool?), ParticleReductionClass? particleReductionClass = default(ParticleReductionClass?), EmissionStandardEU? emissionStandardEU = default(EmissionStandardEU?), EmissionStandardAustralia? emissionStandardAustralia = default(EmissionStandardAustralia?), string lowEmissionZoneTypes = default(string))
        {
            EngineType = engineType;
            CylinderCapacity = cylinderCapacity;
            FuelType = fuelType;
            BioFuelRatio = bioFuelRatio;
            FuelConsumption = fuelConsumption;
            EmissionTechnology = emissionTechnology;
            ParticleFilterInstalled = particleFilterInstalled;
            ParticleReductionClass = particleReductionClass;
            EmissionStandardEU = emissionStandardEU;
            EmissionStandardAustralia = emissionStandardAustralia;
            LowEmissionZoneTypes = lowEmissionZoneTypes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the engine type. Depending on the engine type only a
        /// subset of the other engine parameters are relevant. Possible values
        /// include: 'COMBUSTION', 'ELECTRIC'
        /// </summary>
        [JsonProperty(PropertyName = "engineType")]
        public EngineType? EngineType { get; set; }

        /// <summary>
        /// Gets or sets the cylinder capacity. (2,3)
        /// </summary>
        [JsonProperty(PropertyName = "cylinderCapacity")]
        public int? CylinderCapacity { get; set; }

        /// <summary>
        /// Gets or sets the type of fuel (gasoline, diesel, etc.). (3).
        /// Possible values include: 'GASOLINE', 'DIESEL',
        /// 'COMPRESSED_NATURAL_GAS', 'LIQUEFIED_PETROLEUM_GAS'
        /// </summary>
        [JsonProperty(PropertyName = "fuelType")]
        public FuelType? FuelType { get; set; }

        /// <summary>
        /// Gets or sets the ratio of biofuel to conventional fuel. (3)
        /// </summary>
        [JsonProperty(PropertyName = "bioFuelRatio")]
        public double? BioFuelRatio { get; set; }

        /// <summary>
        /// Gets or sets the fuel consumption. The unit depends on the fuel
        /// type. (3)
        /// </summary>
        [JsonProperty(PropertyName = "fuelConsumption")]
        public double? FuelConsumption { get; set; }

        /// <summary>
        /// Gets or sets the emission technology (only relevant for some
        /// emission classes). (3). Possible values include: 'NONE',
        /// 'EXHAUST_GAS_RECIRCULATION', 'SELECTIVE_CATALYTIC_REDUCTION'
        /// </summary>
        [JsonProperty(PropertyName = "emissionTechnology")]
        public EmissionTechnology? EmissionTechnology { get; set; }

        /// <summary>
        /// Gets or sets describes if a particle filter is installed. (2)
        /// </summary>
        [JsonProperty(PropertyName = "particleFilterInstalled")]
        public bool? ParticleFilterInstalled { get; set; }

        /// <summary>
        /// Gets or sets the particle reduction class
        /// (Partikelminderungsklasse) according to "Anlage XIV zu § 48 StVZO"
        /// (German law). (2). Possible values include: 'PMK_0', 'PMK_1',
        /// 'PMK_2', 'PMK_3', 'PMK_4'
        /// </summary>
        [JsonProperty(PropertyName = "particleReductionClass")]
        public ParticleReductionClass? ParticleReductionClass { get; set; }

        /// <summary>
        /// Gets or sets the emission standard valid in the European Union.
        /// (2,3). Possible values include: 'NONE', 'EURO_0', 'EURO_1',
        /// 'EURO_2', 'EURO_3', 'EURO_4', 'EURO_5', 'EURO_EEV', 'EURO_6',
        /// 'EURO_6c', 'EURO_7'
        /// </summary>
        [JsonProperty(PropertyName = "emissionStandardEU")]
        public EmissionStandardEU? EmissionStandardEU { get; set; }

        /// <summary>
        /// Gets or sets the emission standard valid in Australia. (2,3).
        /// Possible values include: 'NONE', 'ADR_30', 'ADR_70_00',
        /// 'ADR_80_00', 'ADR_80_02', 'ADR_80_03', 'ADR_80_04', 'ADR_80_05'
        /// </summary>
        [JsonProperty(PropertyName = "emissionStandardAustralia")]
        public EmissionStandardAustralia? EmissionStandardAustralia { get; set; }

        /// <summary>
        /// Gets or sets the low-emission zone types of the vehicle as a
        /// comma-separated list. The treatment of road segments that are not
        /// allowed because of the low-emission zone type is controlled by the
        /// penalty value forbiddenLowEmissionZonePenalty. Available types are
        /// DE\_GREEN, DE\_YELLOW, DE\_RED for Germany. (1)
        /// </summary>
        [JsonProperty(PropertyName = "lowEmissionZoneTypes")]
        public string LowEmissionZoneTypes { get; set; }

    }
}
