// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Defines styles for data of a Feature Layer theme in the corresponding
    /// set of countries.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.renderingprofile.FeatureLayerThemeStyle
    /// </summary>
    public partial class FeatureLayerThemeStyle
    {
        /// <summary>
        /// Initializes a new instance of the FeatureLayerThemeStyle class.
        /// </summary>
        public FeatureLayerThemeStyle()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FeatureLayerThemeStyle class.
        /// </summary>
        /// <param name="id">The ID of the Feature Layer theme.</param>
        /// <param name="labelingConflictResolution">Defines the behavior when
        /// labels or icons overlap. In order to avoid overlapping with labels
        /// already drawn they can be displaced so that they do not overlap,
        /// anymore. This means that labels already drawn will not be
        /// repositioned but stay where they are.</param>
        /// <param name="timeDependencyStyle">Defines how to modify the style
        /// of restricted features, e.g. time-dependent features or those not
        /// relevant by time.</param>
        public FeatureLayerThemeStyle(string id, IList<IconStyle> defaultIcons = default(IList<IconStyle>), IList<IconStyle> groupIcons = default(IList<IconStyle>), LabelingConflictResolution labelingConflictResolution = default(LabelingConflictResolution), TimeDependencyStyle timeDependencyStyle = default(TimeDependencyStyle), IList<RenderingStyle> styles = default(IList<RenderingStyle>))
        {
            DefaultIcons = defaultIcons;
            GroupIcons = groupIcons;
            LabelingConflictResolution = labelingConflictResolution;
            TimeDependencyStyle = timeDependencyStyle;
            Styles = styles;
            Id = id;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "defaultIcons")]
        public IList<IconStyle> DefaultIcons { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "groupIcons")]
        public IList<IconStyle> GroupIcons { get; set; }

        /// <summary>
        /// Gets or sets defines the behavior when labels or icons overlap. In
        /// order to avoid overlapping with labels already drawn they can be
        /// displaced so that they do not overlap, anymore. This means that
        /// labels already drawn will not be repositioned but stay where they
        /// are.
        /// </summary>
        [JsonProperty(PropertyName = "labelingConflictResolution")]
        public LabelingConflictResolution LabelingConflictResolution { get; set; }

        /// <summary>
        /// Gets or sets defines how to modify the style of restricted
        /// features, e.g. time-dependent features or those not relevant by
        /// time.
        /// </summary>
        [JsonProperty(PropertyName = "timeDependencyStyle")]
        public TimeDependencyStyle TimeDependencyStyle { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "styles")]
        public IList<RenderingStyle> Styles { get; set; }

        /// <summary>
        /// Gets or sets the ID of the Feature Layer theme.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (DefaultIcons != null)
            {
                foreach (var element in DefaultIcons)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (GroupIcons != null)
            {
                foreach (var element1 in GroupIcons)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
            if (Styles != null)
            {
                foreach (var element2 in Styles)
                {
                    if (element2 != null)
                    {
                        element2.Validate();
                    }
                }
            }
        }
    }
}
