// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a geographical object in terms of its position and its
    /// address.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xlocate.Location
    /// </summary>
    public partial class GeocodingLocation
    {
        /// <summary>
        /// Initializes a new instance of the GeocodingLocation class.
        /// </summary>
        public GeocodingLocation()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GeocodingLocation class.
        /// </summary>
        /// <param name="referenceCoordinate">The actual position of the object
        /// itself, such as the rooftop of a building, the center of a street,
        /// or the reference point of a city.
        ///
        /// In rare cases (when missing in the map data) this may not be
        /// available for a building address. In such a case, there will be a
        /// roadAccessCoordinate.
        ///
        /// Please refer to the documentation of waypoints for more information
        /// on how best to use this position in a route calculation.</param>
        /// <param name="address">The address of the object.</param>
        /// <param name="roadAccessCoordinate">A position on or very close to a
        /// road network segment that marks the entry to the object. Available
        /// only for objects which represent buildings with a complete address
        /// and only if present in the data.
        ///
        /// The road from which the object can be accessed is not necessarily
        /// the road which is closest to the object. When using the location as
        /// the input to a route calculation, pass the roadAccessCoordinate to
        /// the RouteLocation for best results.
        ///
        /// Please refer to the documentation of waypoints for more information
        /// on how to use this position best in a route calculation.</param>
        /// <param name="formattedAddress">A single string representing the
        /// address, typically consisting of the street, house number, postal
        /// code, city, and country. The precise format may differ based on
        /// what is appropriate for the address.</param>
        public GeocodingLocation(Coordinate referenceCoordinate, Address address, Coordinate roadAccessCoordinate = default(Coordinate), string formattedAddress = default(string))
        {
            ReferenceCoordinate = referenceCoordinate;
            RoadAccessCoordinate = roadAccessCoordinate;
            Address = address;
            FormattedAddress = formattedAddress;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the actual position of the object itself, such as the
        /// rooftop of a building, the center of a street, or the reference
        /// point of a city.
        ///
        /// In rare cases (when missing in the map data) this may not be
        /// available for a building address. In such a case, there will be a
        /// roadAccessCoordinate.
        ///
        /// Please refer to the documentation of waypoints for more information
        /// on how best to use this position in a route calculation.
        /// </summary>
        [JsonProperty(PropertyName = "referenceCoordinate")]
        public Coordinate ReferenceCoordinate { get; set; }

        /// <summary>
        /// Gets or sets a position on or very close to a road network segment
        /// that marks the entry to the object. Available only for objects
        /// which represent buildings with a complete address and only if
        /// present in the data.
        ///
        /// The road from which the object can be accessed is not necessarily
        /// the road which is closest to the object. When using the location as
        /// the input to a route calculation, pass the roadAccessCoordinate to
        /// the RouteLocation for best results.
        ///
        /// Please refer to the documentation of waypoints for more information
        /// on how to use this position best in a route calculation.
        /// </summary>
        [JsonProperty(PropertyName = "roadAccessCoordinate")]
        public Coordinate RoadAccessCoordinate { get; set; }

        /// <summary>
        /// Gets or sets the address of the object.
        /// </summary>
        [JsonProperty(PropertyName = "address")]
        public Address Address { get; set; }

        /// <summary>
        /// Gets or sets a single string representing the address, typically
        /// consisting of the street, house number, postal code, city, and
        /// country. The precise format may differ based on what is appropriate
        /// for the address.
        /// </summary>
        [JsonProperty(PropertyName = "formattedAddress")]
        public string FormattedAddress { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ReferenceCoordinate == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ReferenceCoordinate");
            }
            if (Address == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Address");
            }
            if (ReferenceCoordinate != null)
            {
                ReferenceCoordinate.Validate();
            }
            if (RoadAccessCoordinate != null)
            {
                RoadAccessCoordinate.Validate();
            }
        }
    }
}
