// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This type represents meta data about a high-performance routing
    /// network.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xdata.HighPerformanceRoutingNetworkDescription
    /// </summary>
    public partial class HighPerformanceRoutingNetworkDescription
    {
        /// <summary>
        /// Initializes a new instance of the
        /// HighPerformanceRoutingNetworkDescription class.
        /// </summary>
        public HighPerformanceRoutingNetworkDescription()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// HighPerformanceRoutingNetworkDescription class.
        /// </summary>
        /// <param name="id">The ID of the network.</param>
        /// <param name="label">The optional label of the network, if it was
        /// specified in the request. This label is only used for displaying
        /// the network, e.g. in the dashboard, and is not considered in any
        /// other way.</param>
        /// <param name="highPerformanceRoutingNetworkOptions">The options used
        /// for this high-performance routing network.
        ///
        /// Warning: Options are removed from the response if they cannot be
        /// represented using the requested API version. This situation might
        /// occur if a more recent API version was used for the creation of the
        /// high-performance routing network than for this list request. In
        /// general, it is not recommended to mix different API
        /// versions.</param>
        /// <param name="profile">Contains only the relevant profile
        /// parameters.
        ///
        /// Warning: Profile elements are removed from the response if they
        /// cannot be represented using the requested API version. This
        /// restriction also applies to elements of the stored profile used for
        /// calculation of this high-performance routing network. If the
        /// returned profile should be used as a request profile in a
        /// subsequent request (e.g. for creating another high-performance
        /// routing network or for a route calculation), it is recommended to
        /// specify the same stored profile as in the original create request.
        /// In general, it is not recommended to mix different API
        /// versions.</param>
        /// <param name="tenant">The tenant is returned only for administrators
        /// and only for user-created networks.</param>
        /// <param name="scope">The user defined scope. It is returned only for
        /// user-created networks.</param>
        /// <param name="lastUsedAt">Indicates the date the network was used
        /// the last time.</param>
        /// <param name="size">Indicates the size of the network on the hard
        /// drive in bytes.</param>
        public HighPerformanceRoutingNetworkDescription(string id = default(string), string label = default(string), HighPerformanceRoutingNetworkOptions highPerformanceRoutingNetworkOptions = default(HighPerformanceRoutingNetworkOptions), RequestProfile profile = default(RequestProfile), string tenant = default(string), string scope = default(string), System.DateTime? lastUsedAt = default(System.DateTime?), long? size = default(long?))
        {
            Id = id;
            Label = label;
            HighPerformanceRoutingNetworkOptions = highPerformanceRoutingNetworkOptions;
            Profile = profile;
            Tenant = tenant;
            Scope = scope;
            LastUsedAt = lastUsedAt;
            Size = size;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the ID of the network.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the optional label of the network, if it was specified
        /// in the request. This label is only used for displaying the network,
        /// e.g. in the dashboard, and is not considered in any other way.
        /// </summary>
        [JsonProperty(PropertyName = "label")]
        public string Label { get; set; }

        /// <summary>
        /// Gets or sets the options used for this high-performance routing
        /// network.
        ///
        /// Warning: Options are removed from the response if they cannot be
        /// represented using the requested API version. This situation might
        /// occur if a more recent API version was used for the creation of the
        /// high-performance routing network than for this list request. In
        /// general, it is not recommended to mix different API versions.
        /// </summary>
        [JsonProperty(PropertyName = "highPerformanceRoutingNetworkOptions")]
        public HighPerformanceRoutingNetworkOptions HighPerformanceRoutingNetworkOptions { get; set; }

        /// <summary>
        /// Gets or sets contains only the relevant profile parameters.
        ///
        /// Warning: Profile elements are removed from the response if they
        /// cannot be represented using the requested API version. This
        /// restriction also applies to elements of the stored profile used for
        /// calculation of this high-performance routing network. If the
        /// returned profile should be used as a request profile in a
        /// subsequent request (e.g. for creating another high-performance
        /// routing network or for a route calculation), it is recommended to
        /// specify the same stored profile as in the original create request.
        /// In general, it is not recommended to mix different API versions.
        /// </summary>
        [JsonProperty(PropertyName = "profile")]
        public RequestProfile Profile { get; set; }

        /// <summary>
        /// Gets or sets the tenant is returned only for administrators and
        /// only for user-created networks.
        /// </summary>
        [JsonProperty(PropertyName = "tenant")]
        public string Tenant { get; set; }

        /// <summary>
        /// Gets or sets the user defined scope. It is returned only for
        /// user-created networks.
        /// </summary>
        [JsonProperty(PropertyName = "scope")]
        public string Scope { get; set; }

        /// <summary>
        /// Gets or sets indicates the date the network was used the last time.
        /// </summary>
        [JsonProperty(PropertyName = "lastUsedAt")]
        public System.DateTime? LastUsedAt { get; set; }

        /// <summary>
        /// Gets or sets indicates the size of the network on the hard drive in
        /// bytes.
        /// </summary>
        [JsonProperty(PropertyName = "size")]
        public long? Size { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (HighPerformanceRoutingNetworkOptions != null)
            {
                HighPerformanceRoutingNetworkOptions.Validate();
            }
        }
    }
}
