// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This type represents additional options that are relevant for selection
    /// of a high-performance routing network besides the profile.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xdata.HighPerformanceRoutingNetworkOptions
    /// </summary>
    public partial class HighPerformanceRoutingNetworkOptions
    {
        /// <summary>
        /// Initializes a new instance of the
        /// HighPerformanceRoutingNetworkOptions class.
        /// </summary>
        public HighPerformanceRoutingNetworkOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// HighPerformanceRoutingNetworkOptions class.
        /// </summary>
        /// <param name="timeConsideration">Set this parameter if time
        /// dependent features should be considered for the high-performance
        /// routing network calculation. The different scenarios of time
        /// consideration are explained in more detail in the technical concept
        /// about time consideration. Please note that the time consideration
        /// values ExactTimeConsiderationAtStart and
        /// ExactTimeConsiderationAtArrival are not available and if used an
        /// exception will be returned.</param>
        /// <param name="contentSnapshotId">Specifies the content snapshot to
        /// use. If no snapshot ID is set, the most recent content is
        /// used.</param>
        /// <param name="geographicRestrictions">Specifies geographic
        /// restrictions that are considered during the high-performance
        /// routing network calculation.</param>
        public HighPerformanceRoutingNetworkOptions(TimeConsideration timeConsideration = default(TimeConsideration), string contentSnapshotId = default(string), GeographicRestrictions geographicRestrictions = default(GeographicRestrictions))
        {
            TimeConsideration = timeConsideration;
            ContentSnapshotId = contentSnapshotId;
            GeographicRestrictions = geographicRestrictions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets set this parameter if time dependent features should
        /// be considered for the high-performance routing network calculation.
        /// The different scenarios of time consideration are explained in more
        /// detail in the technical concept about time consideration. Please
        /// note that the time consideration values
        /// ExactTimeConsiderationAtStart and ExactTimeConsiderationAtArrival
        /// are not available and if used an exception will be returned.
        /// </summary>
        [JsonProperty(PropertyName = "timeConsideration")]
        public TimeConsideration TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets specifies the content snapshot to use. If no snapshot
        /// ID is set, the most recent content is used.
        /// </summary>
        [JsonProperty(PropertyName = "contentSnapshotId")]
        public string ContentSnapshotId { get; set; }

        /// <summary>
        /// Gets or sets specifies geographic restrictions that are considered
        /// during the high-performance routing network calculation.
        /// </summary>
        [JsonProperty(PropertyName = "geographicRestrictions")]
        public GeographicRestrictions GeographicRestrictions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (GeographicRestrictions != null)
            {
                GeographicRestrictions.Validate();
            }
        }
    }
}
