// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines how to render the icon (e.g. a feature label).
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.renderingprofile.IconStyle
    /// </summary>
    public partial class IconStyle
    {
        /// <summary>
        /// Initializes a new instance of the IconStyle class.
        /// </summary>
        public IconStyle()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IconStyle class.
        /// </summary>
        /// <param name="renderLevel">Defines the level on which the icon is
        /// rendered, i.e. on top or below what other objects.</param>
        /// <param name="anchor">Defines the anchor point of the icon in
        /// pixels, i.e. the position of the icon which is placed on the
        /// geographical reference point on the map. If this field is
        /// specified, the alignment is ignored. It's also allowed to define an
        /// anchor point which is outside of the icon itself by using negative
        /// values. The minimal allowed values are (-16,-16) The maximum values
        /// are (66, 66) due to the maximum icon size of (50, 50)</param>
        /// <param name="alignment">The alignment of the icon. The specified
        /// position within the icon is placed at its geographic reference
        /// point on the map. This setting can be overridden by specifying an
        /// anchor point. Possible values include: 'TOP_LEFT', 'TOP_CENTER',
        /// 'TOP_RIGHT', 'LEFT_CENTER', 'CENTER', 'RIGHT_CENTER',
        /// 'BOTTOM_LEFT', 'BOTTOM_CENTER', 'BOTTOM_RIGHT'</param>
        /// <param name="url">The relative or absolute url of the icon. A
        /// relative url refers to the configured icon folder. An absolute url
        /// must be an http url in order to download the icon from another
        /// server. If this represents a file name relative to the configured
        /// bitmap path, it must be encoded, i.e. special characters such as
        /// white spaces must be represented by %20. It is recommended to use
        /// only alphanumeric characters. If the icon exceeds the maximum
        /// height or width of 50 pixels, the default icon is rendered
        /// instead.</param>
        /// <param name="displayRange">The zoom range in which the specified
        /// style should be applied.</param>
        public IconStyle(RenderLevel renderLevel = default(RenderLevel), IconAnchor anchor = default(IconAnchor), Alignment? alignment = default(Alignment?), string url = default(string), string displayRange = default(string))
        {
            RenderLevel = renderLevel;
            Anchor = anchor;
            Alignment = alignment;
            Url = url;
            DisplayRange = displayRange;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the level on which the icon is rendered, i.e.
        /// on top or below what other objects.
        /// </summary>
        [JsonProperty(PropertyName = "renderLevel")]
        public RenderLevel RenderLevel { get; set; }

        /// <summary>
        /// Gets or sets defines the anchor point of the icon in pixels, i.e.
        /// the position of the icon which is placed on the geographical
        /// reference point on the map. If this field is specified, the
        /// alignment is ignored. It's also allowed to define an anchor point
        /// which is outside of the icon itself by using negative values. The
        /// minimal allowed values are (-16,-16) The maximum values are (66,
        /// 66) due to the maximum icon size of (50, 50)
        /// </summary>
        [JsonProperty(PropertyName = "anchor")]
        public IconAnchor Anchor { get; set; }

        /// <summary>
        /// Gets or sets the alignment of the icon. The specified position
        /// within the icon is placed at its geographic reference point on the
        /// map. This setting can be overridden by specifying an anchor point.
        /// Possible values include: 'TOP_LEFT', 'TOP_CENTER', 'TOP_RIGHT',
        /// 'LEFT_CENTER', 'CENTER', 'RIGHT_CENTER', 'BOTTOM_LEFT',
        /// 'BOTTOM_CENTER', 'BOTTOM_RIGHT'
        /// </summary>
        [JsonProperty(PropertyName = "alignment")]
        public Alignment? Alignment { get; set; }

        /// <summary>
        /// Gets or sets the relative or absolute url of the icon. A relative
        /// url refers to the configured icon folder. An absolute url must be
        /// an http url in order to download the icon from another server. If
        /// this represents a file name relative to the configured bitmap path,
        /// it must be encoded, i.e. special characters such as white spaces
        /// must be represented by %20. It is recommended to use only
        /// alphanumeric characters. If the icon exceeds the maximum height or
        /// width of 50 pixels, the default icon is rendered instead.
        /// </summary>
        [JsonProperty(PropertyName = "url")]
        public string Url { get; set; }

        /// <summary>
        /// Gets or sets the zoom range in which the specified style should be
        /// applied.
        /// </summary>
        [JsonProperty(PropertyName = "displayRange")]
        public string DisplayRange { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Anchor != null)
            {
                Anchor.Validate();
            }
        }
    }
}
