// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class InvalidTaskSequenceFault : StopStructureFault
    {
        /// <summary>
        /// Initializes a new instance of the InvalidTaskSequenceFault class.
        /// </summary>
        public InvalidTaskSequenceFault()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InvalidTaskSequenceFault class.
        /// </summary>
        /// <param name="vehicleId">ID of the vehicle serving the input tour
        /// with invalid structure in case of a PlanToursRequest. In case of a
        /// ChangeToursRequest this parameter contains the ID of the vehicle
        /// that would serve a tour with invalid structure.</param>
        /// <param name="tripId">ID of the input trip with invalid structure in
        /// case of a PlanToursRequest. In case of a ChangeToursRequest this
        /// parameter contains the ID of the trip that would have an invalid
        /// structure.</param>
        /// <param name="stopIndex">Index of the stop in stops of the trip
        /// containing the wrong structure.</param>
        /// <param name="orderId">ID of the transport order causing the
        /// exception.</param>
        /// <param name="taskType">Task type of the task causing the exception.
        /// Possible values include: 'PICKUP', 'DELIVERY', 'VISIT'</param>
        /// <param name="taskIndex">Index of the task in tasks causing the
        /// wrong order sequence structure.</param>
        /// <param name="hint">A free-text hint what to do to fix the
        /// problem.</param>
        public InvalidTaskSequenceFault(string vehicleId, string tripId, int stopIndex, string orderId, TaskType taskType, int taskIndex, string hint = default(string))
            : base(vehicleId, tripId, stopIndex, hint)
        {
            OrderId = orderId;
            TaskType = taskType;
            TaskIndex = taskIndex;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the transport order causing the exception.
        /// </summary>
        [JsonProperty(PropertyName = "orderId")]
        public string OrderId { get; set; }

        /// <summary>
        /// Gets or sets task type of the task causing the exception. Possible
        /// values include: 'PICKUP', 'DELIVERY', 'VISIT'
        /// </summary>
        [JsonProperty(PropertyName = "taskType")]
        public TaskType TaskType { get; set; }

        /// <summary>
        /// Gets or sets index of the task in tasks causing the wrong order
        /// sequence structure.
        /// </summary>
        [JsonProperty(PropertyName = "taskIndex")]
        public int TaskIndex { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (OrderId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OrderId");
            }
        }
    }
}
