// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the position of an item in a bin. The coordinate system is
    /// right-handed with x extending to the right, y pointing up and z
    /// pointing towards you. In terms of a truck (0,0,0) would be at the
    /// lower-left-corner of the opposing wall when looking through the back
    /// doors. An item, for example a palette, placed there would be on the
    /// ground. It would also touch the left wall as well as the wall towards
    /// the drivers cabin.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xload.ItemPosition
    /// </summary>
    public partial class ItemPosition
    {
        /// <summary>
        /// Initializes a new instance of the ItemPosition class.
        /// </summary>
        public ItemPosition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ItemPosition class.
        /// </summary>
        /// <param name="x">Offset along x-axis. Equal to the shift along the
        /// width of the bin from left to right. Rounded to nearest full
        /// centimeter internally.</param>
        /// <param name="y">Offset along y-axis. Equal to the height from the
        /// floor of the bin. Rounded to nearest full centimeter
        /// internally.</param>
        /// <param name="z">Offset along z-axis. Equal to the shift along the
        /// length of the bin from back to front. Rounded to nearest full
        /// centimeter internally.</param>
        public ItemPosition(double x, double y, double z)
        {
            X = x;
            Y = y;
            Z = z;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets offset along x-axis. Equal to the shift along the
        /// width of the bin from left to right. Rounded to nearest full
        /// centimeter internally.
        /// </summary>
        [JsonProperty(PropertyName = "x")]
        public double X { get; set; }

        /// <summary>
        /// Gets or sets offset along y-axis. Equal to the height from the
        /// floor of the bin. Rounded to nearest full centimeter internally.
        /// </summary>
        [JsonProperty(PropertyName = "y")]
        public double Y { get; set; }

        /// <summary>
        /// Gets or sets offset along z-axis. Equal to the shift along the
        /// length of the bin from back to front. Rounded to nearest full
        /// centimeter internally.
        /// </summary>
        [JsonProperty(PropertyName = "z")]
        public double Z { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
