// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes a cuboid item which is to be packed into a bin. If there are
    /// many identical items that do not have to be differentiated by
    /// individual ItemType.id you should use the ItemType.numberOfItems field.
    /// This provides better performance and packing than specifying each item
    /// on its own when this is not needed.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xload.ItemType
    /// </summary>
    public partial class ItemType
    {
        /// <summary>
        /// Initializes a new instance of the ItemType class.
        /// </summary>
        public ItemType()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ItemType class.
        /// </summary>
        /// <param name="id">User provided ID for this item type. Must be
        /// unique.</param>
        /// <param name="dimensions">Outer dimensions of this item. Please note
        /// that the sum of each dimension (i.e. x+y+z) should be greater than
        /// 50 cm.</param>
        /// <param name="weight">Weight of this item. Internally rounded to
        /// nearest full gram.</param>
        /// <param name="maximumSurfaceLoads">Maximum allowable load on this
        /// item. An item experiences load when other items are stacked on top
        /// of it. The load limit is defined for each axis as the item might be
        /// re-oriented. If not given no limitation based on surface load is
        /// made.</param>
        /// <param name="allowedOrientations">Allowed ways to orient this item
        /// when packing it into a bin. If not given all orientations will be
        /// allowed.</param>
        /// <param name="numberOfItems">Number of items of this type that
        /// should be packed. Maximum number is 10000.</param>
        public ItemType(string id, BoxDimensions dimensions, double weight, ItemSurfaceLoads maximumSurfaceLoads = default(ItemSurfaceLoads), AllowedItemOrientations allowedOrientations = default(AllowedItemOrientations), int? numberOfItems = default(int?))
        {
            Id = id;
            Dimensions = dimensions;
            Weight = weight;
            MaximumSurfaceLoads = maximumSurfaceLoads;
            AllowedOrientations = allowedOrientations;
            NumberOfItems = numberOfItems;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets user provided ID for this item type. Must be unique.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets outer dimensions of this item. Please note that the
        /// sum of each dimension (i.e. x+y+z) should be greater than 50 cm.
        /// </summary>
        [JsonProperty(PropertyName = "dimensions")]
        public BoxDimensions Dimensions { get; set; }

        /// <summary>
        /// Gets or sets weight of this item. Internally rounded to nearest
        /// full gram.
        /// </summary>
        [JsonProperty(PropertyName = "weight")]
        public double Weight { get; set; }

        /// <summary>
        /// Gets or sets maximum allowable load on this item. An item
        /// experiences load when other items are stacked on top of it. The
        /// load limit is defined for each axis as the item might be
        /// re-oriented. If not given no limitation based on surface load is
        /// made.
        /// </summary>
        [JsonProperty(PropertyName = "maximumSurfaceLoads")]
        public ItemSurfaceLoads MaximumSurfaceLoads { get; set; }

        /// <summary>
        /// Gets or sets allowed ways to orient this item when packing it into
        /// a bin. If not given all orientations will be allowed.
        /// </summary>
        [JsonProperty(PropertyName = "allowedOrientations")]
        public AllowedItemOrientations AllowedOrientations { get; set; }

        /// <summary>
        /// Gets or sets number of items of this type that should be packed.
        /// Maximum number is 10000.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfItems")]
        public int? NumberOfItems { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (Dimensions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Dimensions");
            }
            if (Dimensions != null)
            {
                Dimensions.Validate();
            }
        }
    }
}
