// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Contains information for the route between two successive sites of a
    /// tour. A leg is either between two stops of a trip, between two trips,
    /// between the vehicle start location and the first stop of the tour or
    /// between the last stop of a tour and the vehicle end location. For
    /// further information please have a look at the technical concept Tours
    /// and Trips.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.LegReport
    /// </summary>
    public partial class LegReport
    {
        /// <summary>
        /// Initializes a new instance of the LegReport class.
        /// </summary>
        public LegReport()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LegReport class.
        /// </summary>
        /// <param name="startTourEventIndex">References the first driving
        /// event of this leg.</param>
        /// <param name="endTourEventIndex">References the last driving event
        /// of this leg.</param>
        /// <param name="drivingTime">The driving time between start and end
        /// location.</param>
        /// <param name="distance">The driven distance between start and end
        /// location.</param>
        /// <param name="estimatedByDirectDistance">True if the driving time of
        /// this leg is estimated by direct distance.
        ///
        /// Possible causes:
        ///
        /// *  start or end not within boundaries of map,
        /// *  start or end too far from next road,
        /// *  no route found between start and end.
        ///
        /// If EstimateByReferenceMatrix is used as distance mode, the leg is
        /// estimated by direct distance if and only if the according reference
        /// locations are estimated by direct distance.</param>
        /// <param name="routeViolated">True if the leg is calculated on the
        /// road network, but with route violations such as weight or height
        /// violations. If EstimateByReferenceMatrix is used as distance mode,
        /// the route is violated if and only if the route between the
        /// according reference locations is violated.</param>
        public LegReport(int? startTourEventIndex = default(int?), int? endTourEventIndex = default(int?), double? drivingTime = default(double?), double? distance = default(double?), bool? estimatedByDirectDistance = default(bool?), bool? routeViolated = default(bool?), IList<double?> transportQuantities = default(IList<double?>))
        {
            StartTourEventIndex = startTourEventIndex;
            EndTourEventIndex = endTourEventIndex;
            DrivingTime = drivingTime;
            Distance = distance;
            EstimatedByDirectDistance = estimatedByDirectDistance;
            RouteViolated = routeViolated;
            TransportQuantities = transportQuantities;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets references the first driving event of this leg.
        /// </summary>
        [JsonProperty(PropertyName = "startTourEventIndex")]
        public int? StartTourEventIndex { get; set; }

        /// <summary>
        /// Gets or sets references the last driving event of this leg.
        /// </summary>
        [JsonProperty(PropertyName = "endTourEventIndex")]
        public int? EndTourEventIndex { get; set; }

        /// <summary>
        /// Gets or sets the driving time between start and end location.
        /// </summary>
        [JsonProperty(PropertyName = "drivingTime")]
        public double? DrivingTime { get; set; }

        /// <summary>
        /// Gets or sets the driven distance between start and end location.
        /// </summary>
        [JsonProperty(PropertyName = "distance")]
        public double? Distance { get; set; }

        /// <summary>
        /// Gets or sets true if the driving time of this leg is estimated by
        /// direct distance.
        ///
        /// Possible causes:
        ///
        /// *  start or end not within boundaries of map,
        /// *  start or end too far from next road,
        /// *  no route found between start and end.
        ///
        /// If EstimateByReferenceMatrix is used as distance mode, the leg is
        /// estimated by direct distance if and only if the according reference
        /// locations are estimated by direct distance.
        /// </summary>
        [JsonProperty(PropertyName = "estimatedByDirectDistance")]
        public bool? EstimatedByDirectDistance { get; set; }

        /// <summary>
        /// Gets or sets true if the leg is calculated on the road network, but
        /// with route violations such as weight or height violations. If
        /// EstimateByReferenceMatrix is used as distance mode, the route is
        /// violated if and only if the route between the according reference
        /// locations is violated.
        /// </summary>
        [JsonProperty(PropertyName = "routeViolated")]
        public bool? RouteViolated { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "transportQuantities")]
        public IList<double?> TransportQuantities { get; set; }

    }
}
