// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines a legal condition of the vehicle, e.g. whether the vehicle is
    /// delivering goods or is an emergency vehicle.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.vehicleprofile.LegalCondition
    /// </summary>
    public partial class LegalCondition
    {
        /// <summary>
        /// Initializes a new instance of the LegalCondition class.
        /// </summary>
        public LegalCondition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the LegalCondition class.
        /// </summary>
        /// <param name="isEmergency">True for emergency vehicles. If this
        /// condition is set to true, certain parts of the road network that
        /// are prohibited except that emergency vehicles are accessible for
        /// the routing algorithm, and these parts are then treated exactly the
        /// same way as normal parts of the road network that are not
        /// prohibited. This setting affects segments which have set
        /// segments.RoadAttributes.allowedForEmergency. (1)</param>
        /// <param name="isDelivery">True for vehicles which are intended to
        /// deliver something. If this condition is set to true, certain parts
        /// of the road network that are prohibited except for delivery
        /// vehicles are accessible for the routing algorithm. The treatment of
        /// such parts can be configured in the routing profile using the
        /// parameters SpecialAreas.deliveryOnlyPenalty and
        /// SpecialAreas.deliveryOnlyGateCost. These settings affect segments
        /// which have set segments.RoadAttributes.deliveryOnly. (1,4)</param>
        public LegalCondition(bool? isEmergency = default(bool?), bool? isDelivery = default(bool?))
        {
            IsEmergency = isEmergency;
            IsDelivery = isDelivery;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets true for emergency vehicles. If this condition is set
        /// to true, certain parts of the road network that are prohibited
        /// except that emergency vehicles are accessible for the routing
        /// algorithm, and these parts are then treated exactly the same way as
        /// normal parts of the road network that are not prohibited. This
        /// setting affects segments which have set
        /// segments.RoadAttributes.allowedForEmergency. (1)
        /// </summary>
        [JsonProperty(PropertyName = "isEmergency")]
        public bool? IsEmergency { get; set; }

        /// <summary>
        /// Gets or sets true for vehicles which are intended to deliver
        /// something. If this condition is set to true, certain parts of the
        /// road network that are prohibited except for delivery vehicles are
        /// accessible for the routing algorithm. The treatment of such parts
        /// can be configured in the routing profile using the parameters
        /// SpecialAreas.deliveryOnlyPenalty and
        /// SpecialAreas.deliveryOnlyGateCost. These settings affect segments
        /// which have set segments.RoadAttributes.deliveryOnly. (1,4)
        /// </summary>
        [JsonProperty(PropertyName = "isDelivery")]
        public bool? IsDelivery { get; set; }

    }
}
