// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the current load of the vehicle
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.vehicleprofile.Load
    /// </summary>
    public partial class Load
    {
        /// <summary>
        /// Initializes a new instance of the Load class.
        /// </summary>
        public Load()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Load class.
        /// </summary>
        /// <param name="hazardousGoodsTypes">Specifies the hazardous goods
        /// types of the load as a comma-separated list (only if the feature
        /// layer PTV\_TruckAttributes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_TruckAttributes. (4)</param>
        /// <param name="loadType">The load type of the vehicle, e.g.
        /// passengers or goods, etc. This parameter is important to derive the
        /// type of the vehicle. For example, if the vehicle's weight is about
        /// 10 tons, then the load type can help to determine whether the
        /// vehicle is a truck or a bus. (1,2,3,4). Possible values include:
        /// 'PASSENGER', 'GOODS'</param>
        /// <param name="tunnelRestrictionCode">The tunnel restriction code for
        /// dangerous load. (4). Possible values include: 'NONE', 'B', 'C',
        /// 'D', 'E'</param>
        public Load(string hazardousGoodsTypes = default(string), LoadType? loadType = default(LoadType?), TunnelRestrictionCode? tunnelRestrictionCode = default(TunnelRestrictionCode?))
        {
            HazardousGoodsTypes = hazardousGoodsTypes;
            LoadType = loadType;
            TunnelRestrictionCode = tunnelRestrictionCode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies the hazardous goods types of the load as a
        /// comma-separated list (only if the feature layer
        /// PTV\_TruckAttributes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_TruckAttributes. (4)
        /// </summary>
        [JsonProperty(PropertyName = "hazardousGoodsTypes")]
        public string HazardousGoodsTypes { get; set; }

        /// <summary>
        /// Gets or sets the load type of the vehicle, e.g. passengers or
        /// goods, etc. This parameter is important to derive the type of the
        /// vehicle. For example, if the vehicle's weight is about 10 tons,
        /// then the load type can help to determine whether the vehicle is a
        /// truck or a bus. (1,2,3,4). Possible values include: 'PASSENGER',
        /// 'GOODS'
        /// </summary>
        [JsonProperty(PropertyName = "loadType")]
        public LoadType? LoadType { get; set; }

        /// <summary>
        /// Gets or sets the tunnel restriction code for dangerous load. (4).
        /// Possible values include: 'NONE', 'B', 'C', 'D', 'E'
        /// </summary>
        [JsonProperty(PropertyName = "tunnelRestrictionCode")]
        public TunnelRestrictionCode? TunnelRestrictionCode { get; set; }

    }
}
