// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the parameters that control how special maneuvers (turns)
    /// affect the route calculation.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.routingprofile.Maneuver
    /// </summary>
    public partial class Maneuver
    {
        /// <summary>
        /// Initializes a new instance of the Maneuver class.
        /// </summary>
        public Maneuver()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Maneuver class.
        /// </summary>
        /// <param name="uTurnCost">The additional cost for U-turns when the
        /// routing type CONVENTIONAL is used. Because of turning bans in the
        /// road network U-turns have to be considered. However, the U-turn is
        /// usually not the best alternative: in most cases it is better to
        /// accept a short detour instead (e.g. drive around the block). With
        /// the parameter uTurnCost the trade-off between U-turn and detour can
        /// be adjusted.</param>
        /// <param name="highPerformanceRoutingUTurnCost">The additional cost
        /// for U-turns when the routing type HIGH\_PERFORMANCE\_ROUTING is
        /// used. The value of this paramer is used for the creation of
        /// high-performance routing networks and their selection for uses in
        /// xdima or xroute. For conventional routing the default uTurnCost is
        /// 5000, however for high-performance routing we recommend a uTurnCost
        /// of 500, hence the additional parameter to use the default values
        /// for conventional routing and high-performance routing
        /// seamlessly.</param>
        /// <param name="considerTurningBans">The consideration of turning
        /// bans.</param>
        /// <param name="useFastTurningBanHeuristic">The fast turning ban
        /// heuristic is used by default. This heuristic can cause in rare
        /// cases suboptimal routes because then driving in both directions of
        /// roads is not always considered by the algorithm. Switching off the
        /// heuristic by setting this attribute to false yields better routes
        /// but can increase the runtime of the routing algorithm.</param>
        public Maneuver(int? uTurnCost = default(int?), int? highPerformanceRoutingUTurnCost = default(int?), bool? considerTurningBans = default(bool?), bool? useFastTurningBanHeuristic = default(bool?))
        {
            UTurnCost = uTurnCost;
            HighPerformanceRoutingUTurnCost = highPerformanceRoutingUTurnCost;
            ConsiderTurningBans = considerTurningBans;
            UseFastTurningBanHeuristic = useFastTurningBanHeuristic;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the additional cost for U-turns when the routing type
        /// CONVENTIONAL is used. Because of turning bans in the road network
        /// U-turns have to be considered. However, the U-turn is usually not
        /// the best alternative: in most cases it is better to accept a short
        /// detour instead (e.g. drive around the block). With the parameter
        /// uTurnCost the trade-off between U-turn and detour can be adjusted.
        /// </summary>
        [JsonProperty(PropertyName = "uTurnCost")]
        public int? UTurnCost { get; set; }

        /// <summary>
        /// Gets or sets the additional cost for U-turns when the routing type
        /// HIGH\_PERFORMANCE\_ROUTING is used. The value of this paramer is
        /// used for the creation of high-performance routing networks and
        /// their selection for uses in xdima or xroute. For conventional
        /// routing the default uTurnCost is 5000, however for high-performance
        /// routing we recommend a uTurnCost of 500, hence the additional
        /// parameter to use the default values for conventional routing and
        /// high-performance routing seamlessly.
        /// </summary>
        [JsonProperty(PropertyName = "highPerformanceRoutingUTurnCost")]
        public int? HighPerformanceRoutingUTurnCost { get; set; }

        /// <summary>
        /// Gets or sets the consideration of turning bans.
        /// </summary>
        [JsonProperty(PropertyName = "considerTurningBans")]
        public bool? ConsiderTurningBans { get; set; }

        /// <summary>
        /// Gets or sets the fast turning ban heuristic is used by default.
        /// This heuristic can cause in rare cases suboptimal routes because
        /// then driving in both directions of roads is not always considered
        /// by the algorithm. Switching off the heuristic by setting this
        /// attribute to false yields better routes but can increase the
        /// runtime of the routing algorithm.
        /// </summary>
        [JsonProperty(PropertyName = "useFastTurningBanHeuristic")]
        public bool? UseFastTurningBanHeuristic { get; set; }

    }
}
