// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    public partial class ManeuverEvent : RouteEvent
    {
        /// <summary>
        /// Initializes a new instance of the ManeuverEvent class.
        /// </summary>
        public ManeuverEvent()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManeuverEvent class.
        /// </summary>
        /// <param name="eventType">The type of the current route event.
        /// Possible values include: 'MANEUVER_EVENT', 'TOUR_EVENT',
        /// 'TOLL_EVENT', 'WAYPOINT_EVENT', 'ROUTE_VIOLATION_EVENT',
        /// 'UTC_OFFSET_EVENT', 'COUNTRY_EVENT'</param>
        /// <param name="startsAt">The point in time at which the event starts.
        /// This field is only present if a time-consideration scenario with a
        /// reference time is given in the request. The time zone is that of
        /// the reference time. Use the UTCOffsetEvent to derive the local
        /// time.</param>
        /// <param name="coordinate">The location at which the event occurs.
        /// This coordinate is not necessarily the coordinate of the related
        /// node. The event such as a traffic incident can, for example, occur
        /// in the middle of a long segment. This coordinate is designed to
        /// draw an icon on a map to mark the event.</param>
        /// <param name="nodeIndex">The index of the node in the
        /// RouteResponse.nodes list. As every segment starts at the node with
        /// the same index, it is also equal to the segment in the
        /// RouteResponse.segments list, if present, except for the very last
        /// index. This field is only present if the list of nodes is
        /// present.</param>
        /// <param name="distanceFromStart">The distance of the route from the
        /// start up to this event.</param>
        /// <param name="travelTimeFromStart">The travel time for the route
        /// from the start up to this event.</param>
        /// <param name="maneuverType">The high-level type of the current
        /// maneuver, e.g. turning or entering / exiting a highway. Possible
        /// values include: 'START', 'START_LEFT', 'START_RIGHT', 'ARRIVE',
        /// 'ARRIVE_LEFT', 'ARRIVE_RIGHT', 'CONTINUE', 'KEEP_STRAIGHT',
        /// 'KEEP_LEFT', 'KEEP_RIGHT', 'TURN_HALF_LEFT', 'TURN_LEFT',
        /// 'TURN_SHARP_LEFT', 'TURN_HALF_RIGHT', 'TURN_RIGHT',
        /// 'TURN_SHARP_RIGHT', 'MAKE_U_TURN', 'TAKE_ROUNDABOUT_LEFT',
        /// 'TAKE_ROUNDABOUT_RIGHT', 'TAKE_COMBINED_TRANSPORT', 'ENTER',
        /// 'ENTER_LEFT', 'ENTER_RIGHT', 'EXIT', 'EXIT_LEFT', 'EXIT_RIGHT',
        /// 'CHANGE', 'CHANGE_LEFT', 'CHANGE_RIGHT'</param>
        /// <param name="relativeDirection">The direction of the outgoing road
        /// relative to continuing in the same direction as the incoming road
        /// (clockwise).</param>
        /// <param name="absoluteDirection">The absolute direction of the
        /// outgoing road (clockwise). North represents 0 degrees.</param>
        /// <param name="directionDescription">A descriptive text for the
        /// current maneuver. The language can be specified by
        /// profile.RequestProfile.userLanguage. The
        /// profile.RequestProfile.mapLanguage will not be considered,
        /// geographical names such as road names are always given in the local
        /// language.</param>
        /// <param name="directionDescriptionLanguage">The language of the
        /// direction description. It is only populated if different from the
        /// requested profile.RequestProfile.userLanguage.</param>
        /// <param name="roadAhead">The description of the road to which the
        /// current maneuver finally leads. This is not necessarily the name of
        /// the road segment right after the maneuver. Especially when exiting
        /// a highway there are ramps or distributor roads which do not have a
        /// description. This field is not present if there is no road
        /// description available (usually for the very last maneuver).</param>
        /// <param name="directionSignText">The city names and road numbers on
        /// a signpost at the current location to follow for the current
        /// maneuver. Empty if no signpost is present or the data is not
        /// available.</param>
        /// <param name="exitNumber">The number of an exit or interchange of a
        /// highway or a freeway-like road. Only present if the maneuver type
        /// is CHANGE or EXIT. Empty if the data does not contain an exit
        /// number.</param>
        /// <param name="exitName">The name of an exit or interchange of a
        /// highway or a freeway-like road. Only present if the maneuver type
        /// is CHANGE or EXIT. Empty if the data does not contain an exit
        /// name.</param>
        /// <param name="roundaboutExit">The exit number at a roundabout. Only
        /// drivable roads are counted. Only present if the maneuver type is
        /// TAKE\_ROUNDABOUT.</param>
        /// <param name="combinedTransportName">The name of the combined
        /// transport to take a the current location. Only present if the
        /// maneuver type is TAKE\_COMBINED\_TRANSPORT.</param>
        /// <param name="combinedTransportType">The type of the combined
        /// transport to take a the current location. Only present if the
        /// maneuver type is TAKE\_COMBINED\_TRANSPORT. Possible values
        /// include: 'BOAT', 'RAIL'</param>
        /// <param name="crossingRoadName">The name of the crossing road at
        /// which a U-turn has to be made. Only present if the maneuver type is
        /// MAKE\_U\_TURN and if the U-turn takes place at a crossing.</param>
        public ManeuverEvent(RouteEventType? eventType = default(RouteEventType?), System.DateTime? startsAt = default(System.DateTime?), Coordinate coordinate = default(Coordinate), int? nodeIndex = default(int?), double? distanceFromStart = default(double?), double? travelTimeFromStart = default(double?), ManeuverType? maneuverType = default(ManeuverType?), int? relativeDirection = default(int?), int? absoluteDirection = default(int?), string directionDescription = default(string), string directionDescriptionLanguage = default(string), RoadDescriptor roadAhead = default(RoadDescriptor), string directionSignText = default(string), string exitNumber = default(string), string exitName = default(string), int? roundaboutExit = default(int?), string combinedTransportName = default(string), CombinedTransportType? combinedTransportType = default(CombinedTransportType?), string crossingRoadName = default(string))
            : base(eventType, startsAt, coordinate, nodeIndex, distanceFromStart, travelTimeFromStart)
        {
            ManeuverType = maneuverType;
            RelativeDirection = relativeDirection;
            AbsoluteDirection = absoluteDirection;
            DirectionDescription = directionDescription;
            DirectionDescriptionLanguage = directionDescriptionLanguage;
            RoadAhead = roadAhead;
            DirectionSignText = directionSignText;
            ExitNumber = exitNumber;
            ExitName = exitName;
            RoundaboutExit = roundaboutExit;
            CombinedTransportName = combinedTransportName;
            CombinedTransportType = combinedTransportType;
            CrossingRoadName = crossingRoadName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the high-level type of the current maneuver, e.g.
        /// turning or entering / exiting a highway. Possible values include:
        /// 'START', 'START_LEFT', 'START_RIGHT', 'ARRIVE', 'ARRIVE_LEFT',
        /// 'ARRIVE_RIGHT', 'CONTINUE', 'KEEP_STRAIGHT', 'KEEP_LEFT',
        /// 'KEEP_RIGHT', 'TURN_HALF_LEFT', 'TURN_LEFT', 'TURN_SHARP_LEFT',
        /// 'TURN_HALF_RIGHT', 'TURN_RIGHT', 'TURN_SHARP_RIGHT', 'MAKE_U_TURN',
        /// 'TAKE_ROUNDABOUT_LEFT', 'TAKE_ROUNDABOUT_RIGHT',
        /// 'TAKE_COMBINED_TRANSPORT', 'ENTER', 'ENTER_LEFT', 'ENTER_RIGHT',
        /// 'EXIT', 'EXIT_LEFT', 'EXIT_RIGHT', 'CHANGE', 'CHANGE_LEFT',
        /// 'CHANGE_RIGHT'
        /// </summary>
        [JsonProperty(PropertyName = "maneuverType")]
        public ManeuverType? ManeuverType { get; set; }

        /// <summary>
        /// Gets or sets the direction of the outgoing road relative to
        /// continuing in the same direction as the incoming road (clockwise).
        /// </summary>
        [JsonProperty(PropertyName = "relativeDirection")]
        public int? RelativeDirection { get; set; }

        /// <summary>
        /// Gets or sets the absolute direction of the outgoing road
        /// (clockwise). North represents 0 degrees.
        /// </summary>
        [JsonProperty(PropertyName = "absoluteDirection")]
        public int? AbsoluteDirection { get; set; }

        /// <summary>
        /// Gets or sets a descriptive text for the current maneuver. The
        /// language can be specified by profile.RequestProfile.userLanguage.
        /// The profile.RequestProfile.mapLanguage will not be considered,
        /// geographical names such as road names are always given in the local
        /// language.
        /// </summary>
        [JsonProperty(PropertyName = "directionDescription")]
        public string DirectionDescription { get; set; }

        /// <summary>
        /// Gets or sets the language of the direction description. It is only
        /// populated if different from the requested
        /// profile.RequestProfile.userLanguage.
        /// </summary>
        [JsonProperty(PropertyName = "directionDescriptionLanguage")]
        public string DirectionDescriptionLanguage { get; set; }

        /// <summary>
        /// Gets or sets the description of the road to which the current
        /// maneuver finally leads. This is not necessarily the name of the
        /// road segment right after the maneuver. Especially when exiting a
        /// highway there are ramps or distributor roads which do not have a
        /// description. This field is not present if there is no road
        /// description available (usually for the very last maneuver).
        /// </summary>
        [JsonProperty(PropertyName = "roadAhead")]
        public RoadDescriptor RoadAhead { get; set; }

        /// <summary>
        /// Gets or sets the city names and road numbers on a signpost at the
        /// current location to follow for the current maneuver. Empty if no
        /// signpost is present or the data is not available.
        /// </summary>
        [JsonProperty(PropertyName = "directionSignText")]
        public string DirectionSignText { get; set; }

        /// <summary>
        /// Gets or sets the number of an exit or interchange of a highway or a
        /// freeway-like road. Only present if the maneuver type is CHANGE or
        /// EXIT. Empty if the data does not contain an exit number.
        /// </summary>
        [JsonProperty(PropertyName = "exitNumber")]
        public string ExitNumber { get; set; }

        /// <summary>
        /// Gets or sets the name of an exit or interchange of a highway or a
        /// freeway-like road. Only present if the maneuver type is CHANGE or
        /// EXIT. Empty if the data does not contain an exit name.
        /// </summary>
        [JsonProperty(PropertyName = "exitName")]
        public string ExitName { get; set; }

        /// <summary>
        /// Gets or sets the exit number at a roundabout. Only drivable roads
        /// are counted. Only present if the maneuver type is TAKE\_ROUNDABOUT.
        /// </summary>
        [JsonProperty(PropertyName = "roundaboutExit")]
        public int? RoundaboutExit { get; set; }

        /// <summary>
        /// Gets or sets the name of the combined transport to take a the
        /// current location. Only present if the maneuver type is
        /// TAKE\_COMBINED\_TRANSPORT.
        /// </summary>
        [JsonProperty(PropertyName = "combinedTransportName")]
        public string CombinedTransportName { get; set; }

        /// <summary>
        /// Gets or sets the type of the combined transport to take a the
        /// current location. Only present if the maneuver type is
        /// TAKE\_COMBINED\_TRANSPORT. Possible values include: 'BOAT', 'RAIL'
        /// </summary>
        [JsonProperty(PropertyName = "combinedTransportType")]
        public CombinedTransportType? CombinedTransportType { get; set; }

        /// <summary>
        /// Gets or sets the name of the crossing road at which a U-turn has to
        /// be made. Only present if the maneuver type is MAKE\_U\_TURN and if
        /// the U-turn takes place at a crossing.
        /// </summary>
        [JsonProperty(PropertyName = "crossingRoadName")]
        public string CrossingRoadName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
