// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This type holds meta information on the installed map.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xruntime.MapDescription
    /// </summary>
    public partial class MapDescription
    {
        /// <summary>
        /// Initializes a new instance of the MapDescription class.
        /// </summary>
        public MapDescription()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MapDescription class.
        /// </summary>
        /// <param name="displayName">The display name of the map, e.g. PTV
        /// Europe City Map Premium 2017.1H.</param>
        /// <param name="providerInformation">Display information on the data
        /// providers of the map. This string consists of a comma-separated
        /// list of pairs of data provider name and provider version number,
        /// e.g. TomTom 2016.12. The string format can be changed at any time,
        /// it is for display purposes only. In order to obtain the provider
        /// names and data versions separately, use the entity
        /// RegionDescription.</param>
        /// <param name="detailLevel">The detail level of the map. According to
        /// this level, some data may not be available. Possible values
        /// include: 'DETAILED', 'EXTRACTED', 'TRANSIT', 'MIXED',
        /// 'UNSPECIFIED'</param>
        /// <param name="copyright">The text fragments of the copyright text to
        /// be displayed on maps.</param>
        /// <param name="dataCompatibilityVersion">The data compatibility
        /// version of the map. An exception is thrown if the stored profile
        /// defined in the request doesn't contain the same
        /// dataCompatibilityVersion. See Profile &amp; Map Versions for
        /// details.</param>
        public MapDescription(string displayName = default(string), string providerInformation = default(string), MapDetailLevel? detailLevel = default(MapDetailLevel?), Copyright copyright = default(Copyright), int? dataCompatibilityVersion = default(int?))
        {
            DisplayName = displayName;
            ProviderInformation = providerInformation;
            DetailLevel = detailLevel;
            Copyright = copyright;
            DataCompatibilityVersion = dataCompatibilityVersion;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the display name of the map, e.g. PTV Europe City Map
        /// Premium 2017.1H.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets display information on the data providers of the map.
        /// This string consists of a comma-separated list of pairs of data
        /// provider name and provider version number, e.g. TomTom 2016.12. The
        /// string format can be changed at any time, it is for display
        /// purposes only. In order to obtain the provider names and data
        /// versions separately, use the entity RegionDescription.
        /// </summary>
        [JsonProperty(PropertyName = "providerInformation")]
        public string ProviderInformation { get; set; }

        /// <summary>
        /// Gets or sets the detail level of the map. According to this level,
        /// some data may not be available. Possible values include:
        /// 'DETAILED', 'EXTRACTED', 'TRANSIT', 'MIXED', 'UNSPECIFIED'
        /// </summary>
        [JsonProperty(PropertyName = "detailLevel")]
        public MapDetailLevel? DetailLevel { get; set; }

        /// <summary>
        /// Gets or sets the text fragments of the copyright text to be
        /// displayed on maps.
        /// </summary>
        [JsonProperty(PropertyName = "copyright")]
        public Copyright Copyright { get; set; }

        /// <summary>
        /// Gets or sets the data compatibility version of the map. An
        /// exception is thrown if the stored profile defined in the request
        /// doesn't contain the same dataCompatibilityVersion. See Profile
        /// &amp;amp; Map Versions for details.
        /// </summary>
        [JsonProperty(PropertyName = "dataCompatibilityVersion")]
        public int? DataCompatibilityVersion { get; set; }

    }
}
