// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Contains all Feature Layer attributes of a road segment rendered in the
    /// map.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xmap.Feature
    /// </summary>
    public partial class MapFeature
    {
        /// <summary>
        /// Initializes a new instance of the MapFeature class.
        /// </summary>
        public MapFeature()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MapFeature class.
        /// </summary>
        /// <param name="themeId">The ID of the Feature Layer theme to which
        /// this feature belongs to.</param>
        /// <param name="id">The ID of the feature, if present.</param>
        /// <param name="referenceCoordinate">The reference point of the road
        /// segment in real world coordinates.</param>
        /// <param name="referencePixelPoint">The reference point of the road
        /// segment in pixel coordinates.</param>
        /// <param name="pixelBoundingBox">The bounding box of the icon(s) in
        /// pixel coordinates. Empty if there is no icon.</param>
        public MapFeature(string themeId, string id = default(string), Coordinate referenceCoordinate = default(Coordinate), PixelPoint referencePixelPoint = default(PixelPoint), PixelBoundingBox pixelBoundingBox = default(PixelBoundingBox), IList<KeyValuePair> attributes = default(IList<KeyValuePair>))
        {
            Id = id;
            ReferenceCoordinate = referenceCoordinate;
            ReferencePixelPoint = referencePixelPoint;
            PixelBoundingBox = pixelBoundingBox;
            ThemeId = themeId;
            Attributes = attributes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the ID of the feature, if present.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the reference point of the road segment in real world
        /// coordinates.
        /// </summary>
        [JsonProperty(PropertyName = "referenceCoordinate")]
        public Coordinate ReferenceCoordinate { get; set; }

        /// <summary>
        /// Gets or sets the reference point of the road segment in pixel
        /// coordinates.
        /// </summary>
        [JsonProperty(PropertyName = "referencePixelPoint")]
        public PixelPoint ReferencePixelPoint { get; set; }

        /// <summary>
        /// Gets or sets the bounding box of the icon(s) in pixel coordinates.
        /// Empty if there is no icon.
        /// </summary>
        [JsonProperty(PropertyName = "pixelBoundingBox")]
        public PixelBoundingBox PixelBoundingBox { get; set; }

        /// <summary>
        /// Gets or sets the ID of the Feature Layer theme to which this
        /// feature belongs to.
        /// </summary>
        [JsonProperty(PropertyName = "themeId")]
        public string ThemeId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "attributes")]
        public IList<KeyValuePair> Attributes { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ThemeId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ThemeId");
            }
            if (ReferenceCoordinate != null)
            {
                ReferenceCoordinate.Validate();
            }
            if (ReferencePixelPoint != null)
            {
                ReferencePixelPoint.Validate();
            }
            if (PixelBoundingBox != null)
            {
                PixelBoundingBox.Validate();
            }
            if (Attributes != null)
            {
                foreach (var element in Attributes)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
