// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Configures further parameters of the map.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xmap.MapOptions
    /// </summary>
    public partial class MapOptions
    {
        /// <summary>
        /// Initializes a new instance of the MapOptions class.
        /// </summary>
        public MapOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MapOptions class.
        /// </summary>
        /// <param name="timeConsideration">Specifies how to evaluate data
        /// which contain time restrictions. For the use cases see time
        /// consideration. If the object is NULL, all data which have time
        /// restrictions are not considered. For some scenarios a reference
        /// time is needed to match properties with a time domain against this
        /// reference time. If for this time no time zone is defined, i.e. it
        /// represents a local time, some exposed map locations are checked for
        /// their time zone offsets. If a time zone cannot be determined for
        /// such a location, this location is not taken into further
        /// consideration. So, in a first step a set of locations with
        /// calculated time zones is determined. If this set contains no
        /// elements, an exception is thrown. When the time zones differ for
        /// some locations, then the time zone containing most locations is
        /// used and a result limitation is added to the result. If all
        /// locations are in the same time zone, then this time zone is used
        /// and the result is calculated as usual.</param>
        /// <param name="contentSnapshotId">Specifies the content snapshot to
        /// use. If no snapshot ID is set, the most recent content is
        /// used.</param>
        /// <param name="showOnlyRelevantByTime">Specifies if the map show all
        /// attributes regardless of referenceTime (default), or only the
        /// attributes which are relevant for this referenceTime. For further
        /// details, see Relevance of Feature Layer attributes.</param>
        /// <param name="showCopyright">If showCopyright is true then it shows
        /// the copyright text in the lower right corner of the image. If
        /// showCopyright is false then no copyright text is shown.</param>
        public MapOptions(TimeConsideration timeConsideration = default(TimeConsideration), string contentSnapshotId = default(string), bool? showOnlyRelevantByTime = default(bool?), IList<string> layers = default(IList<string>), IList<string> preferredRouteTypes = default(IList<string>), bool? showCopyright = default(bool?))
        {
            TimeConsideration = timeConsideration;
            ContentSnapshotId = contentSnapshotId;
            ShowOnlyRelevantByTime = showOnlyRelevantByTime;
            Layers = layers;
            PreferredRouteTypes = preferredRouteTypes;
            ShowCopyright = showCopyright;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies how to evaluate data which contain time
        /// restrictions. For the use cases see time consideration. If the
        /// object is NULL, all data which have time restrictions are not
        /// considered. For some scenarios a reference time is needed to match
        /// properties with a time domain against this reference time. If for
        /// this time no time zone is defined, i.e. it represents a local time,
        /// some exposed map locations are checked for their time zone offsets.
        /// If a time zone cannot be determined for such a location, this
        /// location is not taken into further consideration. So, in a first
        /// step a set of locations with calculated time zones is determined.
        /// If this set contains no elements, an exception is thrown. When the
        /// time zones differ for some locations, then the time zone containing
        /// most locations is used and a result limitation is added to the
        /// result. If all locations are in the same time zone, then this time
        /// zone is used and the result is calculated as usual.
        /// </summary>
        [JsonProperty(PropertyName = "timeConsideration")]
        public TimeConsideration TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets specifies the content snapshot to use. If no snapshot
        /// ID is set, the most recent content is used.
        /// </summary>
        [JsonProperty(PropertyName = "contentSnapshotId")]
        public string ContentSnapshotId { get; set; }

        /// <summary>
        /// Gets or sets specifies if the map show all attributes regardless of
        /// referenceTime (default), or only the attributes which are relevant
        /// for this referenceTime. For further details, see Relevance of
        /// Feature Layer attributes.
        /// </summary>
        [JsonProperty(PropertyName = "showOnlyRelevantByTime")]
        public bool? ShowOnlyRelevantByTime { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "layers")]
        public IList<string> Layers { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "preferredRouteTypes")]
        public IList<string> PreferredRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets if showCopyright is true then it shows the copyright
        /// text in the lower right corner of the image. If showCopyright is
        /// false then no copyright text is shown.
        /// </summary>
        [JsonProperty(PropertyName = "showCopyright")]
        public bool? ShowCopyright { get; set; }

    }
}
