// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class MapRequest : RequestBase
    {
        /// <summary>
        /// Initializes a new instance of the MapRequest class.
        /// </summary>
        public MapRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MapRequest class.
        /// </summary>
        /// <param name="mapSection">Map section to be rendered.</param>
        /// <param name="scope">A user defined scope for persistent data like
        /// distance matrices.</param>
        /// <param name="storedProfile">The URL of the stored profile used by
        /// this request. The following types of URLs are supported:
        ///
        /// *  The name of the profile without its extension, e.g. `bicycle`.
        /// The corresponding file `bicycle.xml` must be available in the
        /// folder `conf/profiles`. Parent profiles must be located in the same
        /// folder. Profile names must not contain the special characters '-'
        /// and '+' and must not be called 'transport', 'labels', or
        /// 'background'.
        /// *  An http url, e.g. `http://localhost:8080/profiles/bicycle.xml`
        /// from which the profile must be available. In order to limit the
        /// access to outside servers, a whitelist can be configured in
        /// `xserver.conf` (see here). Parent profiles are not allowed for http
        /// urls.
        ///
        /// The URL is case-sensitive, although Microsoft Windows also accepts
        /// case-insensitive file names.</param>
        /// <param name="requestProfile">The profile used by this request
        /// (parameters override those from storedProfile).</param>
        /// <param name="coordinateFormat">The coordinate format of all
        /// geometries in request and response. The default of EPSG:4326
        /// represents WGS84. For more information see here.</param>
        /// <param name="geometryOptions">The target encodings of geometries,
        /// PLAIN if empty.</param>
        /// <param name="timeouts">timeout settings</param>
        /// <param name="mapOptions">Map options not contained in the
        /// profile.</param>
        /// <param name="imageOptions">Options of the rendered image.</param>
        /// <param name="resultFields">Options to configure the result fields
        /// available in the response.</param>
        public MapRequest(MapSection mapSection, string scope = default(string), string storedProfile = default(string), RequestProfile requestProfile = default(RequestProfile), string coordinateFormat = default(string), GeometryOptions geometryOptions = default(GeometryOptions), Timeouts timeouts = default(Timeouts), IList<string> userLogs = default(IList<string>), MapOptions mapOptions = default(MapOptions), ImageOptions imageOptions = default(ImageOptions), RenderingResultFields resultFields = default(RenderingResultFields))
            : base(scope, storedProfile, requestProfile, coordinateFormat, geometryOptions, timeouts, userLogs)
        {
            MapSection = mapSection;
            MapOptions = mapOptions;
            ImageOptions = imageOptions;
            ResultFields = resultFields;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets map section to be rendered.
        /// </summary>
        [JsonProperty(PropertyName = "mapSection")]
        public MapSection MapSection { get; set; }

        /// <summary>
        /// Gets or sets map options not contained in the profile.
        /// </summary>
        [JsonProperty(PropertyName = "mapOptions")]
        public MapOptions MapOptions { get; set; }

        /// <summary>
        /// Gets or sets options of the rendered image.
        /// </summary>
        [JsonProperty(PropertyName = "imageOptions")]
        public ImageOptions ImageOptions { get; set; }

        /// <summary>
        /// Gets or sets options to configure the result fields available in
        /// the response.
        /// </summary>
        [JsonProperty(PropertyName = "resultFields")]
        public RenderingResultFields ResultFields { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MapSection == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MapSection");
            }
        }
    }
}
