// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class MoveOrdersAction : ChangeToursAction
    {
        /// <summary>
        /// Initializes a new instance of the MoveOrdersAction class.
        /// </summary>
        public MoveOrdersAction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MoveOrdersAction class.
        /// </summary>
        /// <param name="storedRequestId">ID of the stored PlanToursRequest
        /// that contains all information about the tours to be changed as
        /// input plan. This request with changed input plan containing the
        /// tours information after the ChangeToursAction will be again stored
        /// in the session storage and the ID of the stored request will be
        /// returned as stored request.</param>
        /// <param name="targetTripId">ID of the trip to insert the orders
        /// into.</param>
        /// <param name="visitInsertionPosition">Insertion position for visit
        /// orders. Currently this should be set if and only if all referenced
        /// orders in orderIds are visit orders.</param>
        /// <param name="pickupInsertionPosition">Insertion position for pickup
        /// tasks of transport orders. Currently this should be set if and only
        /// if all referenced orders in orderIds are transport orders.</param>
        /// <param name="deliveryInsertionPosition">Insertion position for
        /// delivery tasks of transport orders. Currently this should be set if
        /// and only if all referenced orders in orderIds are transport
        /// orders.</param>
        public MoveOrdersAction(string storedRequestId, string targetTripId, IList<string> orderIds = default(IList<string>), InsertionPosition visitInsertionPosition = default(InsertionPosition), InsertionPosition pickupInsertionPosition = default(InsertionPosition), InsertionPosition deliveryInsertionPosition = default(InsertionPosition))
            : base(storedRequestId)
        {
            OrderIds = orderIds;
            TargetTripId = targetTripId;
            VisitInsertionPosition = visitInsertionPosition;
            PickupInsertionPosition = pickupInsertionPosition;
            DeliveryInsertionPosition = deliveryInsertionPosition;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "orderIds")]
        public IList<string> OrderIds { get; set; }

        /// <summary>
        /// Gets or sets ID of the trip to insert the orders into.
        /// </summary>
        [JsonProperty(PropertyName = "targetTripId")]
        public string TargetTripId { get; set; }

        /// <summary>
        /// Gets or sets insertion position for visit orders. Currently this
        /// should be set if and only if all referenced orders in orderIds are
        /// visit orders.
        /// </summary>
        [JsonProperty(PropertyName = "visitInsertionPosition")]
        public InsertionPosition VisitInsertionPosition { get; set; }

        /// <summary>
        /// Gets or sets insertion position for pickup tasks of transport
        /// orders. Currently this should be set if and only if all referenced
        /// orders in orderIds are transport orders.
        /// </summary>
        [JsonProperty(PropertyName = "pickupInsertionPosition")]
        public InsertionPosition PickupInsertionPosition { get; set; }

        /// <summary>
        /// Gets or sets insertion position for delivery tasks of transport
        /// orders. Currently this should be set if and only if all referenced
        /// orders in orderIds are transport orders.
        /// </summary>
        [JsonProperty(PropertyName = "deliveryInsertionPosition")]
        public InsertionPosition DeliveryInsertionPosition { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (TargetTripId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetTripId");
            }
        }
    }
}
