// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class MoveStopsAction : ChangeToursAction
    {
        /// <summary>
        /// Initializes a new instance of the MoveStopsAction class.
        /// </summary>
        public MoveStopsAction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MoveStopsAction class.
        /// </summary>
        /// <param name="storedRequestId">ID of the stored PlanToursRequest
        /// that contains all information about the tours to be changed as
        /// input plan. This request with changed input plan containing the
        /// tours information after the ChangeToursAction will be again stored
        /// in the session storage and the ID of the stored request will be
        /// returned as stored request.</param>
        /// <param name="targetTripId">ID of the trip to insert the stop
        /// into.</param>
        /// <param name="insertionPosition">Insertion position of the stop in
        /// the trip. InsertionAtBestPosition is not supported for this
        /// ChangeToursAction yet and its usage causes an exception.</param>
        public MoveStopsAction(string storedRequestId, string targetTripId, InsertionPosition insertionPosition, IList<StopIdentifier> stopIdentifiers = default(IList<StopIdentifier>))
            : base(storedRequestId)
        {
            StopIdentifiers = stopIdentifiers;
            TargetTripId = targetTripId;
            InsertionPosition = insertionPosition;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "stopIdentifiers")]
        public IList<StopIdentifier> StopIdentifiers { get; set; }

        /// <summary>
        /// Gets or sets ID of the trip to insert the stop into.
        /// </summary>
        [JsonProperty(PropertyName = "targetTripId")]
        public string TargetTripId { get; set; }

        /// <summary>
        /// Gets or sets insertion position of the stop in the trip.
        /// InsertionAtBestPosition is not supported for this ChangeToursAction
        /// yet and its usage causes an exception.
        /// </summary>
        [JsonProperty(PropertyName = "insertionPosition")]
        public InsertionPosition InsertionPosition { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (TargetTripId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetTripId");
            }
            if (InsertionPosition == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "InsertionPosition");
            }
            if (StopIdentifiers != null)
            {
                foreach (var element in StopIdentifiers)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
