// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class MoveTripsAction : ChangeToursAction
    {
        /// <summary>
        /// Initializes a new instance of the MoveTripsAction class.
        /// </summary>
        public MoveTripsAction()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MoveTripsAction class.
        /// </summary>
        /// <param name="storedRequestId">ID of the stored PlanToursRequest
        /// that contains all information about the tours to be changed as
        /// input plan. This request with changed input plan containing the
        /// tours information after the ChangeToursAction will be again stored
        /// in the session storage and the ID of the stored request will be
        /// returned as stored request.</param>
        /// <param name="targetVehicleId">ID of the vehicle corresponding to
        /// the tour to insert the trip into or ID of an unused vehicle to move
        /// the trip onto. At the moment, only one trip is supported.</param>
        /// <param name="insertionPosition">Insertion position of the trip in
        /// the tour. If InsertionPosition is of type InsertionAtBestPosition,
        /// a trip is only moved if the target vehicle is different from the
        /// vehicle that currently serves the trip. Trips in tripIds that can
        /// not be moved to the target vehicle are not changed and are listed
        /// in a NoValidInsertionPositionFoundLimitation as objectIds.</param>
        public MoveTripsAction(string storedRequestId, string targetVehicleId, InsertionPosition insertionPosition, IList<string> tripIds = default(IList<string>))
            : base(storedRequestId)
        {
            TripIds = tripIds;
            TargetVehicleId = targetVehicleId;
            InsertionPosition = insertionPosition;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tripIds")]
        public IList<string> TripIds { get; set; }

        /// <summary>
        /// Gets or sets ID of the vehicle corresponding to the tour to insert
        /// the trip into or ID of an unused vehicle to move the trip onto. At
        /// the moment, only one trip is supported.
        /// </summary>
        [JsonProperty(PropertyName = "targetVehicleId")]
        public string TargetVehicleId { get; set; }

        /// <summary>
        /// Gets or sets insertion position of the trip in the tour. If
        /// InsertionPosition is of type InsertionAtBestPosition, a trip is
        /// only moved if the target vehicle is different from the vehicle that
        /// currently serves the trip. Trips in tripIds that can not be moved
        /// to the target vehicle are not changed and are listed in a
        /// NoValidInsertionPositionFoundLimitation as objectIds.
        /// </summary>
        [JsonProperty(PropertyName = "insertionPosition")]
        public InsertionPosition InsertionPosition { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (TargetVehicleId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TargetVehicleId");
            }
            if (InsertionPosition == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "InsertionPosition");
            }
        }
    }
}
