// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents a real or virtual node along a route. See NodeType for the
    /// possible types.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.Node
    /// </summary>
    public partial class Node
    {
        /// <summary>
        /// Initializes a new instance of the Node class.
        /// </summary>
        public Node()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Node class.
        /// </summary>
        /// <param name="coordinate">Location of the node. It never contains
        /// the z-coordinate, refer to the polyline instead to obtain the
        /// z-coordinate.</param>
        /// <param name="type">Type of the node (e.g. NodeType.NETWORK\_NODE).
        /// Possible values include: 'NETWORK_NODE', 'LINK_NODE',
        /// 'INPUT_NODE'</param>
        /// <param name="polylineIndex">Index of the polyline point
        /// corresponding to this node in RouteResponse.polyline. Only
        /// available if a polyline is requested using
        /// ResultFields.polyline.</param>
        /// <param name="violated">If set to true, indicates that this node
        /// contains a violation for the chosen vehicle.</param>
        public Node(Coordinate coordinate, NodeType type, IList<int?> eventIndices = default(IList<int?>), int? polylineIndex = default(int?), bool? violated = default(bool?))
        {
            Coordinate = coordinate;
            Type = type;
            EventIndices = eventIndices;
            PolylineIndex = polylineIndex;
            Violated = violated;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets location of the node. It never contains the
        /// z-coordinate, refer to the polyline instead to obtain the
        /// z-coordinate.
        /// </summary>
        [JsonProperty(PropertyName = "coordinate")]
        public Coordinate Coordinate { get; set; }

        /// <summary>
        /// Gets or sets type of the node (e.g. NodeType.NETWORK\_NODE).
        /// Possible values include: 'NETWORK_NODE', 'LINK_NODE', 'INPUT_NODE'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public NodeType Type { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "eventIndices")]
        public IList<int?> EventIndices { get; set; }

        /// <summary>
        /// Gets or sets index of the polyline point corresponding to this node
        /// in RouteResponse.polyline. Only available if a polyline is
        /// requested using ResultFields.polyline.
        /// </summary>
        [JsonProperty(PropertyName = "polylineIndex")]
        public int? PolylineIndex { get; set; }

        /// <summary>
        /// Gets or sets if set to true, indicates that this node contains a
        /// violation for the chosen vehicle.
        /// </summary>
        [JsonProperty(PropertyName = "violated")]
        public bool? Violated { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Coordinate == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Coordinate");
            }
            if (Coordinate != null)
            {
                Coordinate.Validate();
            }
        }
    }
}
