// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines strong preferences concerning order groups. They are considered
    /// in automatic planning. If these preferences are not met for an input
    /// plan or for a change tours action, they are not reported as a
    /// violation. For further information please have a look at the technical
    /// concept Order Groups. Currently, oneTripPerGroup can only be activated
    /// if oneGroupPerTrip is also activated, otherwise an exception is thrown.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.OrderGroupConsideration
    /// </summary>
    public partial class OrderGroupConsideration
    {
        /// <summary>
        /// Initializes a new instance of the OrderGroupConsideration class.
        /// </summary>
        public OrderGroupConsideration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OrderGroupConsideration class.
        /// </summary>
        /// <param name="oneGroupPerTrip">If set to true, orders of a specific
        /// group cannot be planned together with orders of another group into
        /// a trip and orders without groupIds remain unplanned.</param>
        /// <param name="oneTripPerGroup">If set to true, orders of a specific
        /// group must be planned together in one trip.</param>
        public OrderGroupConsideration(bool? oneGroupPerTrip = default(bool?), bool? oneTripPerGroup = default(bool?))
        {
            OneGroupPerTrip = oneGroupPerTrip;
            OneTripPerGroup = oneTripPerGroup;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets if set to true, orders of a specific group cannot be
        /// planned together with orders of another group into a trip and
        /// orders without groupIds remain unplanned.
        /// </summary>
        [JsonProperty(PropertyName = "oneGroupPerTrip")]
        public bool? OneGroupPerTrip { get; set; }

        /// <summary>
        /// Gets or sets if set to true, orders of a specific group must be
        /// planned together in one trip.
        /// </summary>
        [JsonProperty(PropertyName = "oneTripPerGroup")]
        public bool? OneTripPerGroup { get; set; }

    }
}
