// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class OrderWithAlternativeDeliveryDepots : TransportOrder
    {
        /// <summary>
        /// Initializes a new instance of the
        /// OrderWithAlternativeDeliveryDepots class.
        /// </summary>
        public OrderWithAlternativeDeliveryDepots()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// OrderWithAlternativeDeliveryDepots class.
        /// </summary>
        /// <param name="id">An unique ID used to identify the order.</param>
        /// <param name="pickupLocationId">ID of the location where the goods
        /// should be picked up. Only a customer site is allowed as pickup
        /// location.</param>
        /// <param name="groupId">The unique identifier of an order group. The
        /// preferences that apply to orders with the same group ID are
        /// specified in the order group consideration. Order groups may be
        /// referenced in the order group IDs of a vehicle.</param>
        /// <param name="serviceTimeForPickup">Overall service time at the site
        /// required to pick up the order. Additionally there may be a site
        /// dependent or vehicle dependent service time of the stop. See
        /// Service time calculation.</param>
        /// <param name="serviceTimeForDelivery">Overall service time at the
        /// site required to deliver the order. Additionally there may be a
        /// site dependent or vehicle dependent service time of the stop. See
        /// Service time calculation.</param>
        public OrderWithAlternativeDeliveryDepots(string id, string pickupLocationId, string groupId = default(string), IList<string> requiredVehicleEquipment = default(IList<string>), IList<double?> quantities = default(IList<double?>), double? serviceTimeForPickup = default(double?), double? serviceTimeForDelivery = default(double?), IList<string> deliveryLocationIds = default(IList<string>))
            : base(id, groupId, requiredVehicleEquipment, quantities, serviceTimeForPickup, serviceTimeForDelivery)
        {
            PickupLocationId = pickupLocationId;
            DeliveryLocationIds = deliveryLocationIds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the location where the goods should be picked
        /// up. Only a customer site is allowed as pickup location.
        /// </summary>
        [JsonProperty(PropertyName = "pickupLocationId")]
        public string PickupLocationId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "deliveryLocationIds")]
        public IList<string> DeliveryLocationIds { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (PickupLocationId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PickupLocationId");
            }
        }
    }
}
