// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Options influencing the choice of overnight stays in visit planning.
    /// This feature is only available with the Gurobi solver type. It can be
    /// enabled by allowing one or more overnights per week using
    /// maximumOvernightStaysPerWeek. This will implicitely enable
    /// determineShortestVisitSequencePerDay. Considering overnights will
    /// impact calculation time and can not be combined with
    /// improveDailyWorkloadBalance at this point in time.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.OvernightStayOptions
    /// </summary>
    public partial class OvernightStayOptions
    {
        /// <summary>
        /// Initializes a new instance of the OvernightStayOptions class.
        /// </summary>
        public OvernightStayOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OvernightStayOptions class.
        /// </summary>
        /// <param name="minimumTravelTimeToFieldWorkerLocation">The minimum
        /// travel time from the overnight location to the field worker
        /// location in seconds. Prevents overnight stays "too close to home".
        /// Zero means the field worker can stay overnight at any of the given
        /// locations.</param>
        /// <param name="maximumOvernightStaysPerWeek">Maximum number of
        /// overnight stays per week. Overnight stays will be disabled if zero
        /// is given here.</param>
        /// <param name="minimumTimeSavingPerOvernightStay">Minimum travel time
        /// in seconds saved by the overnight stay before it may be considered.
        /// This is a soft constraint and might not be fully satisfied in all
        /// situations.</param>
        /// <param name="maximumTravelTimeBetweenDays">Maximum time we may take
        /// to travel to reach the visits for the next day after an overnight
        /// stay. This is a soft constraint and might not be fully satisfied in
        /// all situations.</param>
        public OvernightStayOptions(double? minimumTravelTimeToFieldWorkerLocation = default(double?), int? maximumOvernightStaysPerWeek = default(int?), IList<System.DateTime?> forbiddenDays = default(IList<System.DateTime?>), double? minimumTimeSavingPerOvernightStay = default(double?), double? maximumTravelTimeBetweenDays = default(double?))
        {
            MinimumTravelTimeToFieldWorkerLocation = minimumTravelTimeToFieldWorkerLocation;
            MaximumOvernightStaysPerWeek = maximumOvernightStaysPerWeek;
            ForbiddenDays = forbiddenDays;
            MinimumTimeSavingPerOvernightStay = minimumTimeSavingPerOvernightStay;
            MaximumTravelTimeBetweenDays = maximumTravelTimeBetweenDays;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the minimum travel time from the overnight location to
        /// the field worker location in seconds. Prevents overnight stays "too
        /// close to home". Zero means the field worker can stay overnight at
        /// any of the given locations.
        /// </summary>
        [JsonProperty(PropertyName = "minimumTravelTimeToFieldWorkerLocation")]
        public double? MinimumTravelTimeToFieldWorkerLocation { get; set; }

        /// <summary>
        /// Gets or sets maximum number of overnight stays per week. Overnight
        /// stays will be disabled if zero is given here.
        /// </summary>
        [JsonProperty(PropertyName = "maximumOvernightStaysPerWeek")]
        public int? MaximumOvernightStaysPerWeek { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "forbiddenDays")]
        public IList<System.DateTime?> ForbiddenDays { get; set; }

        /// <summary>
        /// Gets or sets minimum travel time in seconds saved by the overnight
        /// stay before it may be considered. This is a soft constraint and
        /// might not be fully satisfied in all situations.
        /// </summary>
        [JsonProperty(PropertyName = "minimumTimeSavingPerOvernightStay")]
        public double? MinimumTimeSavingPerOvernightStay { get; set; }

        /// <summary>
        /// Gets or sets maximum time we may take to travel to reach the visits
        /// for the next day after an overnight stay. This is a soft constraint
        /// and might not be fully satisfied in all situations.
        /// </summary>
        [JsonProperty(PropertyName = "maximumTravelTimeBetweenDays")]
        public double? MaximumTravelTimeBetweenDays { get; set; }

    }
}
