// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes a bin packed with items. If BinType.numberOfBins is greater
    /// than one, multiple packed bins with the same PackedBin.binTypeId might
    /// be part of a response.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xload.PackedBin
    /// </summary>
    public partial class PackedBin
    {
        /// <summary>
        /// Initializes a new instance of the PackedBin class.
        /// </summary>
        public PackedBin()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PackedBin class.
        /// </summary>
        /// <param name="binTypeId">ID of the BinType</param>
        /// <param name="totalItemsVolume">Accumulated volume of the items
        /// packed into the bin. This is the raw sum and does not try to
        /// capture wasted volume (e.g. gaps).</param>
        /// <param name="totalItemsWeight">Accumulated weight of items packed
        /// into this bin.</param>
        /// <param name="usedVolumeCapacity">Percent of
        /// BinType.maximumVolumeCapacity used by PackedBin.totalItemsVolume.
        /// If no explicit maximum volume is given it is calculated from the
        /// container dimensions.</param>
        /// <param name="loadingMeters">Item extent along the z-axis (length)
        /// from the back wall of the bin. When looking through the back doors
        /// of a truck this is the distance from the opposing wall to the end
        /// of the load closest to the doors.</param>
        /// <param name="usedWeightCapacity">Percent of
        /// BinType.maximumWeightCapacity used by PackedBin.totalItemsWeight.
        /// Not returned if no maximumWeightCapacity was given for bin.</param>
        public PackedBin(string binTypeId, double totalItemsVolume, double totalItemsWeight, double usedVolumeCapacity, double loadingMeters, IList<PackedItem> packedItems = default(IList<PackedItem>), double? usedWeightCapacity = default(double?))
        {
            BinTypeId = binTypeId;
            PackedItems = packedItems;
            TotalItemsVolume = totalItemsVolume;
            TotalItemsWeight = totalItemsWeight;
            UsedWeightCapacity = usedWeightCapacity;
            UsedVolumeCapacity = usedVolumeCapacity;
            LoadingMeters = loadingMeters;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the BinType
        /// </summary>
        [JsonProperty(PropertyName = "binTypeId")]
        public string BinTypeId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "packedItems")]
        public IList<PackedItem> PackedItems { get; set; }

        /// <summary>
        /// Gets or sets accumulated volume of the items packed into the bin.
        /// This is the raw sum and does not try to capture wasted volume (e.g.
        /// gaps).
        /// </summary>
        [JsonProperty(PropertyName = "totalItemsVolume")]
        public double TotalItemsVolume { get; set; }

        /// <summary>
        /// Gets or sets accumulated weight of items packed into this bin.
        /// </summary>
        [JsonProperty(PropertyName = "totalItemsWeight")]
        public double TotalItemsWeight { get; set; }

        /// <summary>
        /// Gets or sets percent of BinType.maximumWeightCapacity used by
        /// PackedBin.totalItemsWeight. Not returned if no
        /// maximumWeightCapacity was given for bin.
        /// </summary>
        [JsonProperty(PropertyName = "usedWeightCapacity")]
        public double? UsedWeightCapacity { get; set; }

        /// <summary>
        /// Gets or sets percent of BinType.maximumVolumeCapacity used by
        /// PackedBin.totalItemsVolume. If no explicit maximum volume is given
        /// it is calculated from the container dimensions.
        /// </summary>
        [JsonProperty(PropertyName = "usedVolumeCapacity")]
        public double UsedVolumeCapacity { get; set; }

        /// <summary>
        /// Gets or sets item extent along the z-axis (length) from the back
        /// wall of the bin. When looking through the back doors of a truck
        /// this is the distance from the opposing wall to the end of the load
        /// closest to the doors.
        /// </summary>
        [JsonProperty(PropertyName = "loadingMeters")]
        public double LoadingMeters { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (BinTypeId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "BinTypeId");
            }
            if (PackedItems != null)
            {
                foreach (var element in PackedItems)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
