// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes one item of a type that was packed into a PackedBin. If
    /// ItemType.numberOfItems is greater than one, multiple packed items with
    /// the same PackedItem.itemTypeId might be in a PackedBin.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xload.PackedItem
    /// </summary>
    public partial class PackedItem
    {
        /// <summary>
        /// Initializes a new instance of the PackedItem class.
        /// </summary>
        public PackedItem()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PackedItem class.
        /// </summary>
        /// <param name="itemTypeId">ID of the ItemType.</param>
        /// <param name="position">ItemPosition of the item in the bin.</param>
        /// <param name="dimensions">Packed item dimensions after
        /// orientation.</param>
        /// <param name="orientation">ItemOrientation with which the item was
        /// placed in the bin. Possible values include: 'ORIGINAL', 'X', 'Y',
        /// 'Z', 'XZ', 'YZ'</param>
        public PackedItem(string itemTypeId, ItemPosition position, BoxDimensions dimensions, ItemOrientation orientation)
        {
            ItemTypeId = itemTypeId;
            Position = position;
            Dimensions = dimensions;
            Orientation = orientation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the ItemType.
        /// </summary>
        [JsonProperty(PropertyName = "itemTypeId")]
        public string ItemTypeId { get; set; }

        /// <summary>
        /// Gets or sets itemPosition of the item in the bin.
        /// </summary>
        [JsonProperty(PropertyName = "position")]
        public ItemPosition Position { get; set; }

        /// <summary>
        /// Gets or sets packed item dimensions after orientation.
        /// </summary>
        [JsonProperty(PropertyName = "dimensions")]
        public BoxDimensions Dimensions { get; set; }

        /// <summary>
        /// Gets or sets itemOrientation with which the item was placed in the
        /// bin. Possible values include: 'ORIGINAL', 'X', 'Y', 'Z', 'XZ', 'YZ'
        /// </summary>
        [JsonProperty(PropertyName = "orientation")]
        public ItemOrientation Orientation { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ItemTypeId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ItemTypeId");
            }
            if (Position == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Position");
            }
            if (Dimensions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Dimensions");
            }
            if (Position != null)
            {
                Position.Validate();
            }
            if (Dimensions != null)
            {
                Dimensions.Validate();
            }
        }
    }
}
