// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Input parameters for the planning algorithm.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.PlanClustersOptions
    /// </summary>
    public partial class PlanClustersOptions
    {
        /// <summary>
        /// Initializes a new instance of the PlanClustersOptions class.
        /// </summary>
        public PlanClustersOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlanClustersOptions class.
        /// </summary>
        /// <param name="numberOfClusters">The number of clusters that should
        /// be returned by the planning algorithm. If this parameter differs
        /// from the number of clusters that are set in the request, the number
        /// of clusters is changed to the value specified here.</param>
        /// <param name="ignoreImbalanceTolerance">If false, the
        /// imbalanceTolerance parameter will be considered by the planning
        /// algorithm. If true, the imbalanceTolerance will be ignored and a
        /// probably imbalanced solution is returned.</param>
        /// <param name="imbalanceTolerance">Represents the maximal deviation
        /// from the average total activity per cluster which is tolerated for
        /// each cluster. The imbalanceTolerance is used as exit criterion for
        /// the algorithm: as soon as all clusters are sufficiently balanced,
        /// the algorithm stops. For CalculationMode PERFORMANCE this value is
        /// more a guidance level than a maximal value. Locations may be
        /// assigned to a cluster after the algorithm stops. Therefore it
        /// cannot be guaranteed that the actual imbalance lies within the
        /// value set as imbalanceTolerance.</param>
        /// <param name="reduceOverlappingInClusters">Clusters are always
        /// optimized towards compactness and towards minimal driving times
        /// from the reference point to each location. Depending on the routing
        /// profile used for driving time calculation, clusters may be
        /// stretched along major roads and it is possible that two clusters
        /// visually overlap. Furthermore, a high variance among activities
        /// might also lead to overlaps. If reduceOverlappingInClusters is set
        /// to true, the algorithm tries to reduce overlapping among clusters.
        /// If there is no valid solution that avoids overlapping clusters, a
        /// valid solution with overlapping clusters is returned. Setting this
        /// parameter to true usually increases runtime because additional
        /// steps have to be executed. In addition, the activity-imbalance
        /// among clusters and the overall driving time per cluster may
        /// increase.</param>
        /// <param name="considerActivitiesAsServiceTimes">If this parameter is
        /// set to true, all activity values set at a location are considered
        /// to be service times in seconds. Using service periods as activity
        /// means that estimated tour durations are balanced for each cluster
        /// instead of the total sum of activity. Therefore the value of
        /// ClusterReport.totalActivity represents the estimated tour duration
        /// for the corresponding cluster.</param>
        /// <param name="calculationMode">Required solution quality of the
        /// calculation. Possible values include: 'PERFORMANCE',
        /// 'QUALITY'</param>
        public PlanClustersOptions(int numberOfClusters, bool? ignoreImbalanceTolerance = default(bool?), double? imbalanceTolerance = default(double?), IList<string> optionalClusterIds = default(IList<string>), bool? reduceOverlappingInClusters = default(bool?), bool? considerActivitiesAsServiceTimes = default(bool?), IList<ActivityCapacity> activityCapacities = default(IList<ActivityCapacity>), ClusterPlanningCalculationMode? calculationMode = default(ClusterPlanningCalculationMode?))
        {
            NumberOfClusters = numberOfClusters;
            IgnoreImbalanceTolerance = ignoreImbalanceTolerance;
            ImbalanceTolerance = imbalanceTolerance;
            OptionalClusterIds = optionalClusterIds;
            ReduceOverlappingInClusters = reduceOverlappingInClusters;
            ConsiderActivitiesAsServiceTimes = considerActivitiesAsServiceTimes;
            ActivityCapacities = activityCapacities;
            CalculationMode = calculationMode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the number of clusters that should be returned by the
        /// planning algorithm. If this parameter differs from the number of
        /// clusters that are set in the request, the number of clusters is
        /// changed to the value specified here.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfClusters")]
        public int NumberOfClusters { get; set; }

        /// <summary>
        /// Gets or sets if false, the imbalanceTolerance parameter will be
        /// considered by the planning algorithm. If true, the
        /// imbalanceTolerance will be ignored and a probably imbalanced
        /// solution is returned.
        /// </summary>
        [JsonProperty(PropertyName = "ignoreImbalanceTolerance")]
        public bool? IgnoreImbalanceTolerance { get; set; }

        /// <summary>
        /// Gets or sets represents the maximal deviation from the average
        /// total activity per cluster which is tolerated for each cluster. The
        /// imbalanceTolerance is used as exit criterion for the algorithm: as
        /// soon as all clusters are sufficiently balanced, the algorithm
        /// stops. For CalculationMode PERFORMANCE this value is more a
        /// guidance level than a maximal value. Locations may be assigned to a
        /// cluster after the algorithm stops. Therefore it cannot be
        /// guaranteed that the actual imbalance lies within the value set as
        /// imbalanceTolerance.
        /// </summary>
        [JsonProperty(PropertyName = "imbalanceTolerance")]
        public double? ImbalanceTolerance { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "optionalClusterIds")]
        public IList<string> OptionalClusterIds { get; set; }

        /// <summary>
        /// Gets or sets clusters are always optimized towards compactness and
        /// towards minimal driving times from the reference point to each
        /// location. Depending on the routing profile used for driving time
        /// calculation, clusters may be stretched along major roads and it is
        /// possible that two clusters visually overlap. Furthermore, a high
        /// variance among activities might also lead to overlaps. If
        /// reduceOverlappingInClusters is set to true, the algorithm tries to
        /// reduce overlapping among clusters. If there is no valid solution
        /// that avoids overlapping clusters, a valid solution with overlapping
        /// clusters is returned. Setting this parameter to true usually
        /// increases runtime because additional steps have to be executed. In
        /// addition, the activity-imbalance among clusters and the overall
        /// driving time per cluster may increase.
        /// </summary>
        [JsonProperty(PropertyName = "reduceOverlappingInClusters")]
        public bool? ReduceOverlappingInClusters { get; set; }

        /// <summary>
        /// Gets or sets if this parameter is set to true, all activity values
        /// set at a location are considered to be service times in seconds.
        /// Using service periods as activity means that estimated tour
        /// durations are balanced for each cluster instead of the total sum of
        /// activity. Therefore the value of ClusterReport.totalActivity
        /// represents the estimated tour duration for the corresponding
        /// cluster.
        /// </summary>
        [JsonProperty(PropertyName = "considerActivitiesAsServiceTimes")]
        public bool? ConsiderActivitiesAsServiceTimes { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "activityCapacities")]
        public IList<ActivityCapacity> ActivityCapacities { get; set; }

        /// <summary>
        /// Gets or sets required solution quality of the calculation. Possible
        /// values include: 'PERFORMANCE', 'QUALITY'
        /// </summary>
        [JsonProperty(PropertyName = "calculationMode")]
        public ClusterPlanningCalculationMode? CalculationMode { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ActivityCapacities != null)
            {
                foreach (var element in ActivityCapacities)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
