// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class PlanClustersRequest : RequestBase
    {
        /// <summary>
        /// Initializes a new instance of the PlanClustersRequest class.
        /// </summary>
        public PlanClustersRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlanClustersRequest class.
        /// </summary>
        /// <param name="planClustersOptions">Parameters for the planning
        /// algorithm.</param>
        /// <param name="distanceMode">Contains settings that specify how
        /// distances between locations are retrieved. When using direct
        /// distance the driven distances are estimated with a detour factor of
        /// 1.38 and for the duration a speed of 60 km/h is assumed. Only the
        /// following distance modes are supported: DirectDistance and
        /// ExistingDistanceMatrix.</param>
        /// <param name="scope">A user defined scope for persistent data like
        /// distance matrices.</param>
        /// <param name="storedProfile">The URL of the stored profile used by
        /// this request. The following types of URLs are supported:
        ///
        /// *  The name of the profile without its extension, e.g. `bicycle`.
        /// The corresponding file `bicycle.xml` must be available in the
        /// folder `conf/profiles`. Parent profiles must be located in the same
        /// folder. Profile names must not contain the special characters '-'
        /// and '+' and must not be called 'transport', 'labels', or
        /// 'background'.
        /// *  An http url, e.g. `http://localhost:8080/profiles/bicycle.xml`
        /// from which the profile must be available. In order to limit the
        /// access to outside servers, a whitelist can be configured in
        /// `xserver.conf` (see here). Parent profiles are not allowed for http
        /// urls.
        ///
        /// The URL is case-sensitive, although Microsoft Windows also accepts
        /// case-insensitive file names.</param>
        /// <param name="requestProfile">The profile used by this request
        /// (parameters override those from storedProfile).</param>
        /// <param name="coordinateFormat">The coordinate format of all
        /// geometries in request and response. The default of EPSG:4326
        /// represents WGS84. For more information see here.</param>
        /// <param name="geometryOptions">The target encodings of geometries,
        /// PLAIN if empty.</param>
        /// <param name="timeouts">timeout settings</param>
        public PlanClustersRequest(PlanClustersOptions planClustersOptions, DistanceMode distanceMode, string scope = default(string), string storedProfile = default(string), RequestProfile requestProfile = default(RequestProfile), string coordinateFormat = default(string), GeometryOptions geometryOptions = default(GeometryOptions), Timeouts timeouts = default(Timeouts), IList<string> userLogs = default(IList<string>), IList<PlanningLocation> planningLocations = default(IList<PlanningLocation>), IList<Cluster> clusters = default(IList<Cluster>))
            : base(scope, storedProfile, requestProfile, coordinateFormat, geometryOptions, timeouts, userLogs)
        {
            PlanningLocations = planningLocations;
            Clusters = clusters;
            PlanClustersOptions = planClustersOptions;
            DistanceMode = distanceMode;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "planningLocations")]
        public IList<PlanningLocation> PlanningLocations { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "clusters")]
        public IList<Cluster> Clusters { get; set; }

        /// <summary>
        /// Gets or sets parameters for the planning algorithm.
        /// </summary>
        [JsonProperty(PropertyName = "planClustersOptions")]
        public PlanClustersOptions PlanClustersOptions { get; set; }

        /// <summary>
        /// Gets or sets contains settings that specify how distances between
        /// locations are retrieved. When using direct distance the driven
        /// distances are estimated with a detour factor of 1.38 and for the
        /// duration a speed of 60 km/h is assumed. Only the following distance
        /// modes are supported: DirectDistance and ExistingDistanceMatrix.
        /// </summary>
        [JsonProperty(PropertyName = "distanceMode")]
        public DistanceMode DistanceMode { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PlanClustersOptions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PlanClustersOptions");
            }
            if (DistanceMode == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DistanceMode");
            }
            if (PlanningLocations != null)
            {
                foreach (var element in PlanningLocations)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (Clusters != null)
            {
                foreach (var element1 in Clusters)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
            if (PlanClustersOptions != null)
            {
                PlanClustersOptions.Validate();
            }
        }
    }
}
