// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contains global planning settings.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.PlanToursOptions
    /// </summary>
    public partial class PlanToursOptions
    {
        /// <summary>
        /// Initializes a new instance of the PlanToursOptions class.
        /// </summary>
        public PlanToursOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlanToursOptions class.
        /// </summary>
        /// <param name="planningHorizon">Defines the planning horizon for this
        /// request, described by start and end date. It restricts all tours
        /// which means their beginning and end need to be in this planning
        /// horizon. All opening intervals outside of this planning horizon are
        /// not considered during the tour planning process. If the opening
        /// intervals contain GDF time domains, the planning horizon is a
        /// required parameter to limit the number of recurring intervals of
        /// the time domains. The planning horizon is restricted to a maximum
        /// duration of two weeks.</param>
        /// <param name="restrictions">Defines restrictions for the planning
        /// algorithm.</param>
        /// <param name="calculationMode">Defines the calculation mode of the
        /// planning algorithm. Possible values include: 'PERFORMANCE',
        /// 'STANDARD', 'QUALITY', 'AVOID_INTERSECTIONS', 'CUSTOM',
        /// 'EVALUATE'</param>
        /// <param name="customCalculationModeConfiguration">Defines a specific
        /// configuration for calculation mode CUSTOM in an encoded
        /// form.</param>
        /// <param name="orderGroupConsideration">Defines strong preferences
        /// concerning order groups. They are considered in automatic planning.
        /// If these preferences are not met for an input plan or for a change
        /// tours action, they are not reported as a violation.</param>
        /// <param name="singleStopPerCustomerSite">Defines a strong preference
        /// that all tasks of orders for the same customer site are carried out
        /// at the same stop if possible. If this is not possible, all
        /// unplanned orders for that customer site remain unplanned. Transport
        /// orders between two customer sites are ignored here. This preference
        /// is only considered in automatic planning. If this preference is not
        /// met for an input plan or for a change tours action, it is not
        /// reported as a violation.</param>
        public PlanToursOptions(StartEndInterval planningHorizon = default(StartEndInterval), TourRestrictions restrictions = default(TourRestrictions), TourPlanningCalculationMode? calculationMode = default(TourPlanningCalculationMode?), string customCalculationModeConfiguration = default(string), OrderGroupConsideration orderGroupConsideration = default(OrderGroupConsideration), bool? singleStopPerCustomerSite = default(bool?))
        {
            PlanningHorizon = planningHorizon;
            Restrictions = restrictions;
            CalculationMode = calculationMode;
            CustomCalculationModeConfiguration = customCalculationModeConfiguration;
            OrderGroupConsideration = orderGroupConsideration;
            SingleStopPerCustomerSite = singleStopPerCustomerSite;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the planning horizon for this request,
        /// described by start and end date. It restricts all tours which means
        /// their beginning and end need to be in this planning horizon. All
        /// opening intervals outside of this planning horizon are not
        /// considered during the tour planning process. If the opening
        /// intervals contain GDF time domains, the planning horizon is a
        /// required parameter to limit the number of recurring intervals of
        /// the time domains. The planning horizon is restricted to a maximum
        /// duration of two weeks.
        /// </summary>
        [JsonProperty(PropertyName = "planningHorizon")]
        public StartEndInterval PlanningHorizon { get; set; }

        /// <summary>
        /// Gets or sets defines restrictions for the planning algorithm.
        /// </summary>
        [JsonProperty(PropertyName = "restrictions")]
        public TourRestrictions Restrictions { get; set; }

        /// <summary>
        /// Gets or sets defines the calculation mode of the planning
        /// algorithm. Possible values include: 'PERFORMANCE', 'STANDARD',
        /// 'QUALITY', 'AVOID_INTERSECTIONS', 'CUSTOM', 'EVALUATE'
        /// </summary>
        [JsonProperty(PropertyName = "calculationMode")]
        public TourPlanningCalculationMode? CalculationMode { get; set; }

        /// <summary>
        /// Gets or sets defines a specific configuration for calculation mode
        /// CUSTOM in an encoded form.
        /// </summary>
        [JsonProperty(PropertyName = "customCalculationModeConfiguration")]
        public string CustomCalculationModeConfiguration { get; set; }

        /// <summary>
        /// Gets or sets defines strong preferences concerning order groups.
        /// They are considered in automatic planning. If these preferences are
        /// not met for an input plan or for a change tours action, they are
        /// not reported as a violation.
        /// </summary>
        [JsonProperty(PropertyName = "orderGroupConsideration")]
        public OrderGroupConsideration OrderGroupConsideration { get; set; }

        /// <summary>
        /// Gets or sets defines a strong preference that all tasks of orders
        /// for the same customer site are carried out at the same stop if
        /// possible. If this is not possible, all unplanned orders for that
        /// customer site remain unplanned. Transport orders between two
        /// customer sites are ignored here. This preference is only considered
        /// in automatic planning. If this preference is not met for an input
        /// plan or for a change tours action, it is not reported as a
        /// violation.
        /// </summary>
        [JsonProperty(PropertyName = "singleStopPerCustomerSite")]
        public bool? SingleStopPerCustomerSite { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PlanningHorizon != null)
            {
                PlanningHorizon.Validate();
            }
        }
    }
}
