// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class PlanToursRequest : RequestBase
    {
        /// <summary>
        /// Initializes a new instance of the PlanToursRequest class.
        /// </summary>
        public PlanToursRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlanToursRequest class.
        /// </summary>
        /// <param name="fleet">The fleet that should be used to conduct the
        /// planned tours.</param>
        /// <param name="distanceMode">Contains settings that specify how
        /// distances are retrieved for tour planning. These settings apply to
        /// all vehicles in the request. When using direct distance the driven
        /// distances are estimated with a detour factor of 1.38 and for the
        /// duration a speed of 60 km/h is assumed. Time dependent and non time
        /// dependent distance matrices must not be used together in a request.
        /// If time dependent distance matrices are used, no driving time
        /// regulation must be set.</param>
        /// <param name="scope">A user defined scope for persistent data like
        /// distance matrices.</param>
        /// <param name="storedProfile">The URL of the stored profile used by
        /// this request. The following types of URLs are supported:
        ///
        /// *  The name of the profile without its extension, e.g. `bicycle`.
        /// The corresponding file `bicycle.xml` must be available in the
        /// folder `conf/profiles`. Parent profiles must be located in the same
        /// folder. Profile names must not contain the special characters '-'
        /// and '+' and must not be called 'transport', 'labels', or
        /// 'background'.
        /// *  An http url, e.g. `http://localhost:8080/profiles/bicycle.xml`
        /// from which the profile must be available. In order to limit the
        /// access to outside servers, a whitelist can be configured in
        /// `xserver.conf` (see here). Parent profiles are not allowed for http
        /// urls.
        ///
        /// The URL is case-sensitive, although Microsoft Windows also accepts
        /// case-insensitive file names.</param>
        /// <param name="requestProfile">The profile used by this request
        /// (parameters override those from storedProfile).</param>
        /// <param name="coordinateFormat">The coordinate format of all
        /// geometries in request and response. The default of EPSG:4326
        /// represents WGS84. For more information see here.</param>
        /// <param name="geometryOptions">The target encodings of geometries,
        /// PLAIN if empty.</param>
        /// <param name="timeouts">timeout settings</param>
        /// <param name="inputPlan">A list of tours that serves the algorithm
        /// as start solution (e.g. tours of previous responses). The input
        /// tours can generally be changed or dissolved except when they are
        /// fixed. To evaluate an input plan without changing it, use
        /// calculation mode EVALUATE.</param>
        /// <param name="planToursOptions">Contains planning options.</param>
        /// <param name="storeRequest">Defines if the request should be stored
        /// in the session storage. Note that if there occur problems with the
        /// session storage, an ObjectNotStoredLimitation is generated and the
        /// stored request ID in the response is null.</param>
        public PlanToursRequest(Fleet fleet, DistanceMode distanceMode, string scope = default(string), string storedProfile = default(string), RequestProfile requestProfile = default(RequestProfile), string coordinateFormat = default(string), GeometryOptions geometryOptions = default(GeometryOptions), Timeouts timeouts = default(Timeouts), IList<string> userLogs = default(IList<string>), IList<TourPlanningLocation> locations = default(IList<TourPlanningLocation>), IList<Order> orders = default(IList<Order>), InputPlan inputPlan = default(InputPlan), PlanToursOptions planToursOptions = default(PlanToursOptions), bool? storeRequest = default(bool?))
            : base(scope, storedProfile, requestProfile, coordinateFormat, geometryOptions, timeouts, userLogs)
        {
            Locations = locations;
            Orders = orders;
            Fleet = fleet;
            InputPlan = inputPlan;
            PlanToursOptions = planToursOptions;
            DistanceMode = distanceMode;
            StoreRequest = storeRequest;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "locations")]
        public IList<TourPlanningLocation> Locations { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "orders")]
        public IList<Order> Orders { get; set; }

        /// <summary>
        /// Gets or sets the fleet that should be used to conduct the planned
        /// tours.
        /// </summary>
        [JsonProperty(PropertyName = "fleet")]
        public Fleet Fleet { get; set; }

        /// <summary>
        /// Gets or sets a list of tours that serves the algorithm as start
        /// solution (e.g. tours of previous responses). The input tours can
        /// generally be changed or dissolved except when they are fixed. To
        /// evaluate an input plan without changing it, use calculation mode
        /// EVALUATE.
        /// </summary>
        [JsonProperty(PropertyName = "inputPlan")]
        public InputPlan InputPlan { get; set; }

        /// <summary>
        /// Gets or sets contains planning options.
        /// </summary>
        [JsonProperty(PropertyName = "planToursOptions")]
        public PlanToursOptions PlanToursOptions { get; set; }

        /// <summary>
        /// Gets or sets contains settings that specify how distances are
        /// retrieved for tour planning. These settings apply to all vehicles
        /// in the request. When using direct distance the driven distances are
        /// estimated with a detour factor of 1.38 and for the duration a speed
        /// of 60 km/h is assumed. Time dependent and non time dependent
        /// distance matrices must not be used together in a request. If time
        /// dependent distance matrices are used, no driving time regulation
        /// must be set.
        /// </summary>
        [JsonProperty(PropertyName = "distanceMode")]
        public DistanceMode DistanceMode { get; set; }

        /// <summary>
        /// Gets or sets defines if the request should be stored in the session
        /// storage. Note that if there occur problems with the session
        /// storage, an ObjectNotStoredLimitation is generated and the stored
        /// request ID in the response is null.
        /// </summary>
        [JsonProperty(PropertyName = "storeRequest")]
        public bool? StoreRequest { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Fleet == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Fleet");
            }
            if (DistanceMode == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DistanceMode");
            }
            if (Locations != null)
            {
                foreach (var element in Locations)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (Orders != null)
            {
                foreach (var element1 in Orders)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
            if (PlanToursOptions != null)
            {
                PlanToursOptions.Validate();
            }
        }
    }
}
