// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Input parameters for the visit planning algorithm.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.PlanVisitsOptions
    /// </summary>
    public partial class PlanVisitsOptions
    {
        /// <summary>
        /// Initializes a new instance of the PlanVisitsOptions class.
        /// </summary>
        public PlanVisitsOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PlanVisitsOptions class.
        /// </summary>
        /// <param name="planningPeriod">Planning period of the request. The
        /// start date of this period defines the first day of a work week. For
        /// example, if the start date is a saturday and the workdays are set
        /// to monday, wednesday and saturday, a work week is considered in the
        /// order saturday, monday, wednesday.</param>
        /// <param name="workDays">Work days of a week.</param>
        /// <param name="ignoreWeeklyImbalanceTolerance">If false, the
        /// weeklyImbalanceTolerance parameter will be considered by the
        /// planning algorithm. If true, the weeklyImbalanceTolerance will be
        /// ignored and a probably imbalanced solution is returned. This
        /// parameter is ignored if workLoadOptions are used.</param>
        /// <param name="weeklyImbalanceTolerance">Maximal deviation from the
        /// average weekly service workload of the field worker. The average
        /// workload is thereby determined from the given service times of the
        /// orders. This parameter is ignored if workLoadOptions are
        /// used.</param>
        /// <param name="ignoreDailyImbalanceTolerance">If false, the
        /// dailyImbalanceTolerance parameter will be considered by the
        /// planning algorithm. If true, the dailyImbalanceTolerance will be
        /// ignored and a probably imbalanced solution is returned. This
        /// parameter is ignored if workLoadOptions are used.</param>
        /// <param name="dailyImbalanceTolerance">Maximal deviation from the
        /// average daily service workload of the field worker. The average
        /// workload is thereby determined from the given service times of the
        /// orders. This parameter is ignored if workLoadOptions are
        /// used.</param>
        /// <param name="determineShortestVisitSequencePerDay">If true, the
        /// visits are returned in a sequence that forms an optimal or shortest
        /// tour with respect to travel time for that particular day. The
        /// calculation of these shortest tours is allowed to take up to 100
        /// seconds of calculation time on top of the configured
        /// solverTimeLimit per day in the result but is usually much quicker.
        /// If the parameter is false, the sequence of visits has no special
        /// meaning.</param>
        /// <param name="improveDailyWorkloadBalance">This option is only
        /// available for the Gurobi solver type. If true, xcluster attempts to
        /// further minimize workload imbalances between days. In contrast to
        /// the dailyImbalanceTolerance this option considers the workload to
        /// not only consist of service time, but also of the travel time
        /// between customers on the day. This additional improvement may take
        /// up to solverTimeLimit of additional processing time. As the daily
        /// workload is calculated based on the shortest visit sequence for the
        /// day, determineShortestVisitSequencePerDay is implied to be true. If
        /// improveDailyWorkloadBalance is false, balancing will only be
        /// performed based on service time according to the given tolerances.
        /// This parameter is ignored if workLoadOptions are used.</param>
        /// <param name="overnightStayOptions">Options to control overnight
        /// stays. This feature is currently not available combined with
        /// workloadOptions. This feature is only available for the Gurobi
        /// solver type.</param>
        public PlanVisitsOptions(PlanningPeriod planningPeriod, Week workDays, bool? ignoreWeeklyImbalanceTolerance = default(bool?), double? weeklyImbalanceTolerance = default(double?), bool? ignoreDailyImbalanceTolerance = default(bool?), double? dailyImbalanceTolerance = default(double?), bool? determineShortestVisitSequencePerDay = default(bool?), bool? improveDailyWorkloadBalance = default(bool?), OvernightStayOptions overnightStayOptions = default(OvernightStayOptions))
        {
            PlanningPeriod = planningPeriod;
            WorkDays = workDays;
            IgnoreWeeklyImbalanceTolerance = ignoreWeeklyImbalanceTolerance;
            WeeklyImbalanceTolerance = weeklyImbalanceTolerance;
            IgnoreDailyImbalanceTolerance = ignoreDailyImbalanceTolerance;
            DailyImbalanceTolerance = dailyImbalanceTolerance;
            DetermineShortestVisitSequencePerDay = determineShortestVisitSequencePerDay;
            ImproveDailyWorkloadBalance = improveDailyWorkloadBalance;
            OvernightStayOptions = overnightStayOptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets planning period of the request. The start date of this
        /// period defines the first day of a work week. For example, if the
        /// start date is a saturday and the workdays are set to monday,
        /// wednesday and saturday, a work week is considered in the order
        /// saturday, monday, wednesday.
        /// </summary>
        [JsonProperty(PropertyName = "planningPeriod")]
        public PlanningPeriod PlanningPeriod { get; set; }

        /// <summary>
        /// Gets or sets work days of a week.
        /// </summary>
        [JsonProperty(PropertyName = "workDays")]
        public Week WorkDays { get; set; }

        /// <summary>
        /// Gets or sets if false, the weeklyImbalanceTolerance parameter will
        /// be considered by the planning algorithm. If true, the
        /// weeklyImbalanceTolerance will be ignored and a probably imbalanced
        /// solution is returned. This parameter is ignored if workLoadOptions
        /// are used.
        /// </summary>
        [JsonProperty(PropertyName = "ignoreWeeklyImbalanceTolerance")]
        public bool? IgnoreWeeklyImbalanceTolerance { get; set; }

        /// <summary>
        /// Gets or sets maximal deviation from the average weekly service
        /// workload of the field worker. The average workload is thereby
        /// determined from the given service times of the orders. This
        /// parameter is ignored if workLoadOptions are used.
        /// </summary>
        [JsonProperty(PropertyName = "weeklyImbalanceTolerance")]
        public double? WeeklyImbalanceTolerance { get; set; }

        /// <summary>
        /// Gets or sets if false, the dailyImbalanceTolerance parameter will
        /// be considered by the planning algorithm. If true, the
        /// dailyImbalanceTolerance will be ignored and a probably imbalanced
        /// solution is returned. This parameter is ignored if workLoadOptions
        /// are used.
        /// </summary>
        [JsonProperty(PropertyName = "ignoreDailyImbalanceTolerance")]
        public bool? IgnoreDailyImbalanceTolerance { get; set; }

        /// <summary>
        /// Gets or sets maximal deviation from the average daily service
        /// workload of the field worker. The average workload is thereby
        /// determined from the given service times of the orders. This
        /// parameter is ignored if workLoadOptions are used.
        /// </summary>
        [JsonProperty(PropertyName = "dailyImbalanceTolerance")]
        public double? DailyImbalanceTolerance { get; set; }

        /// <summary>
        /// Gets or sets if true, the visits are returned in a sequence that
        /// forms an optimal or shortest tour with respect to travel time for
        /// that particular day. The calculation of these shortest tours is
        /// allowed to take up to 100 seconds of calculation time on top of the
        /// configured solverTimeLimit per day in the result but is usually
        /// much quicker. If the parameter is false, the sequence of visits has
        /// no special meaning.
        /// </summary>
        [JsonProperty(PropertyName = "determineShortestVisitSequencePerDay")]
        public bool? DetermineShortestVisitSequencePerDay { get; set; }

        /// <summary>
        /// Gets or sets this option is only available for the Gurobi solver
        /// type. If true, xcluster attempts to further minimize workload
        /// imbalances between days. In contrast to the dailyImbalanceTolerance
        /// this option considers the workload to not only consist of service
        /// time, but also of the travel time between customers on the day.
        /// This additional improvement may take up to solverTimeLimit of
        /// additional processing time. As the daily workload is calculated
        /// based on the shortest visit sequence for the day,
        /// determineShortestVisitSequencePerDay is implied to be true. If
        /// improveDailyWorkloadBalance is false, balancing will only be
        /// performed based on service time according to the given tolerances.
        /// This parameter is ignored if workLoadOptions are used.
        /// </summary>
        [JsonProperty(PropertyName = "improveDailyWorkloadBalance")]
        public bool? ImproveDailyWorkloadBalance { get; set; }

        /// <summary>
        /// Gets or sets options to control overnight stays. This feature is
        /// currently not available combined with workloadOptions. This feature
        /// is only available for the Gurobi solver type.
        /// </summary>
        [JsonProperty(PropertyName = "overnightStayOptions")]
        public OvernightStayOptions OvernightStayOptions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PlanningPeriod == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PlanningPeriod");
            }
            if (WorkDays == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "WorkDays");
            }
            if (PlanningPeriod != null)
            {
                PlanningPeriod.Validate();
            }
        }
    }
}
