// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Specifies the options for a reachable areas caluclation.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.ReachableAreasOptions
    /// </summary>
    public partial class ReachableAreasOptions
    {
        /// <summary>
        /// Initializes a new instance of the ReachableAreasOptions class.
        /// </summary>
        public ReachableAreasOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ReachableAreasOptions class.
        /// </summary>
        /// <param name="calculationMode">Defines the focus of the algorithm,
        /// either quality or performance. Possible values include:
        /// 'PERFORMANCE', 'QUALITY'</param>
        /// <param name="drivingDirection">Defines whether to calculate the
        /// areas which can be reached from the location within the horizons or
        /// to calculate the areas from which the location can be reached
        /// within the horizons. If exact time consideration is used, use
        /// OUTBOUND only with timeconsideration.ExactTimeConsiderationAtStart
        /// and INBOUND only with
        /// timeconsideration.ExactTimeConsiderationAtArrival. Otherwise a
        /// exceptions.ParameterConflictException is thrown. Possible values
        /// include: 'INBOUND', 'OUTBOUND'</param>
        /// <param name="timeConsideration">Specifies how to evaluate data
        /// which contain time restrictions. For the use cases see time
        /// consideration. If the object is NULL, all data which have time
        /// restrictions are not considered. For some scenarios a reference
        /// time is needed to match properties with a time domain against this
        /// reference time. If for this time no time zone is defined, i.e. it
        /// represents a local time, all waypoints with their dedicated
        /// locations are checked for their time zone offsets. If a time zone
        /// cannot be determined for such a location, this location is not
        /// taken into further consideration. So, in a first step a set of
        /// locations with calculated time zones is determined. If this set
        /// contains no elements, an exception is thrown. When the time zones
        /// differ for some locations, then the time zone containing most
        /// locations is used and a result limitation is added to the result.
        /// If all locations are in the same time zone, then this time zone is
        /// used and the result is calculated as usual.</param>
        /// <param name="contentSnapshotId">Speficies the content snapshot to
        /// use. If no snapshot ID is set, the latest content is used.</param>
        public ReachableAreasOptions(IList<Horizon> horizons = default(IList<Horizon>), ReachableAreasCalculationMode? calculationMode = default(ReachableAreasCalculationMode?), ReachableAreasDrivingDirection? drivingDirection = default(ReachableAreasDrivingDirection?), TimeConsideration timeConsideration = default(TimeConsideration), string contentSnapshotId = default(string))
        {
            Horizons = horizons;
            CalculationMode = calculationMode;
            DrivingDirection = drivingDirection;
            TimeConsideration = timeConsideration;
            ContentSnapshotId = contentSnapshotId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "horizons")]
        public IList<Horizon> Horizons { get; set; }

        /// <summary>
        /// Gets or sets defines the focus of the algorithm, either quality or
        /// performance. Possible values include: 'PERFORMANCE', 'QUALITY'
        /// </summary>
        [JsonProperty(PropertyName = "calculationMode")]
        public ReachableAreasCalculationMode? CalculationMode { get; set; }

        /// <summary>
        /// Gets or sets defines whether to calculate the areas which can be
        /// reached from the location within the horizons or to calculate the
        /// areas from which the location can be reached within the horizons.
        /// If exact time consideration is used, use OUTBOUND only with
        /// timeconsideration.ExactTimeConsiderationAtStart and INBOUND only
        /// with timeconsideration.ExactTimeConsiderationAtArrival. Otherwise a
        /// exceptions.ParameterConflictException is thrown. Possible values
        /// include: 'INBOUND', 'OUTBOUND'
        /// </summary>
        [JsonProperty(PropertyName = "drivingDirection")]
        public ReachableAreasDrivingDirection? DrivingDirection { get; set; }

        /// <summary>
        /// Gets or sets specifies how to evaluate data which contain time
        /// restrictions. For the use cases see time consideration. If the
        /// object is NULL, all data which have time restrictions are not
        /// considered. For some scenarios a reference time is needed to match
        /// properties with a time domain against this reference time. If for
        /// this time no time zone is defined, i.e. it represents a local time,
        /// all waypoints with their dedicated locations are checked for their
        /// time zone offsets. If a time zone cannot be determined for such a
        /// location, this location is not taken into further consideration.
        /// So, in a first step a set of locations with calculated time zones
        /// is determined. If this set contains no elements, an exception is
        /// thrown. When the time zones differ for some locations, then the
        /// time zone containing most locations is used and a result limitation
        /// is added to the result. If all locations are in the same time zone,
        /// then this time zone is used and the result is calculated as usual.
        /// </summary>
        [JsonProperty(PropertyName = "timeConsideration")]
        public TimeConsideration TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets speficies the content snapshot to use. If no snapshot
        /// ID is set, the latest content is used.
        /// </summary>
        [JsonProperty(PropertyName = "contentSnapshotId")]
        public string ContentSnapshotId { get; set; }

    }
}
