// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A mapping of a location that is part of the request to a route
    /// location. The route location is used as a reference, e.g. for distance
    /// calculation.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.ReferenceLocationMapping
    /// </summary>
    public partial class ReferenceLocationMapping
    {
        /// <summary>
        /// Initializes a new instance of the ReferenceLocationMapping class.
        /// </summary>
        public ReferenceLocationMapping()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ReferenceLocationMapping class.
        /// </summary>
        /// <param name="locationId">The unique identifier of a location that
        /// is part of the request. It is checked case sensitively.</param>
        /// <param name="referenceLocation">The route location that is used as
        /// a reference for the location in a distance matrix. It may be equal
        /// to the location's route location.</param>
        public ReferenceLocationMapping(string locationId, RouteLocation referenceLocation)
        {
            LocationId = locationId;
            ReferenceLocation = referenceLocation;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique identifier of a location that is part of
        /// the request. It is checked case sensitively.
        /// </summary>
        [JsonProperty(PropertyName = "locationId")]
        public string LocationId { get; set; }

        /// <summary>
        /// Gets or sets the route location that is used as a reference for the
        /// location in a distance matrix. It may be equal to the location's
        /// route location.
        /// </summary>
        [JsonProperty(PropertyName = "referenceLocation")]
        public RouteLocation ReferenceLocation { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (LocationId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LocationId");
            }
            if (ReferenceLocation == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ReferenceLocation");
            }
        }
    }
}
