// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Defines the style for a class of objects of a Feature Layer theme. The
    /// class of objects is defined by specifying displayClass, ranges,
    /// timeRestriction, and roadTypes.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.renderingprofile.RenderingStyle
    /// </summary>
    public partial class RenderingStyle
    {
        /// <summary>
        /// Initializes a new instance of the RenderingStyle class.
        /// </summary>
        public RenderingStyle()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RenderingStyle class.
        /// </summary>
        /// <param name="displayClass">The display class of the corresponding
        /// Feature Layer theme for which this style shall apply. The list of
        /// available display classes can be found in the documentation of the
        /// Feature Layer theme. Use '\*' to specify the fallback style which
        /// is used if there is no style defined for a display class.</param>
        /// <param name="timeRestriction">The time restriction for which this
        /// style shall apply. Possible values include: 'ALL', 'UNRESTRICTED',
        /// 'RESTRICTED'</param>
        public RenderingStyle(string displayClass, IList<Range> ranges = default(IList<Range>), IList<RoadType?> roadTypes = default(IList<RoadType?>), IList<GeometryStyle> geometries = default(IList<GeometryStyle>), IList<IconStyle> icons = default(IList<IconStyle>), TimeRestriction? timeRestriction = default(TimeRestriction?))
        {
            Ranges = ranges;
            RoadTypes = roadTypes;
            Geometries = geometries;
            Icons = icons;
            DisplayClass = displayClass;
            TimeRestriction = timeRestriction;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "ranges")]
        public IList<Range> Ranges { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "roadTypes")]
        public IList<RoadType?> RoadTypes { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "geometries")]
        public IList<GeometryStyle> Geometries { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "icons")]
        public IList<IconStyle> Icons { get; set; }

        /// <summary>
        /// Gets or sets the display class of the corresponding Feature Layer
        /// theme for which this style shall apply. The list of available
        /// display classes can be found in the documentation of the Feature
        /// Layer theme. Use '\*' to specify the fallback style which is used
        /// if there is no style defined for a display class.
        /// </summary>
        [JsonProperty(PropertyName = "displayClass")]
        public string DisplayClass { get; set; }

        /// <summary>
        /// Gets or sets the time restriction for which this style shall apply.
        /// Possible values include: 'ALL', 'UNRESTRICTED', 'RESTRICTED'
        /// </summary>
        [JsonProperty(PropertyName = "timeRestriction")]
        public TimeRestriction? TimeRestriction { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (DisplayClass == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "DisplayClass");
            }
            if (Ranges != null)
            {
                foreach (var element in Ranges)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (Icons != null)
            {
                foreach (var element1 in Icons)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
        }
    }
}
