// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Base type for any xServer request type. Contains a RequestProfile.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.service.RequestBase
    /// </summary>
    public partial class RequestBase
    {
        /// <summary>
        /// Initializes a new instance of the RequestBase class.
        /// </summary>
        public RequestBase()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RequestBase class.
        /// </summary>
        /// <param name="scope">A user defined scope for persistent data like
        /// distance matrices.</param>
        /// <param name="storedProfile">The URL of the stored profile used by
        /// this request. The following types of URLs are supported:
        ///
        /// *  The name of the profile without its extension, e.g. `bicycle`.
        /// The corresponding file `bicycle.xml` must be available in the
        /// folder `conf/profiles`. Parent profiles must be located in the same
        /// folder. Profile names must not contain the special characters '-'
        /// and '+' and must not be called 'transport', 'labels', or
        /// 'background'.
        /// *  An http url, e.g. `http://localhost:8080/profiles/bicycle.xml`
        /// from which the profile must be available. In order to limit the
        /// access to outside servers, a whitelist can be configured in
        /// `xserver.conf` (see here). Parent profiles are not allowed for http
        /// urls.
        ///
        /// The URL is case-sensitive, although Microsoft Windows also accepts
        /// case-insensitive file names.</param>
        /// <param name="requestProfile">The profile used by this request
        /// (parameters override those from storedProfile).</param>
        /// <param name="coordinateFormat">The coordinate format of all
        /// geometries in request and response. The default of EPSG:4326
        /// represents WGS84. For more information see here.</param>
        /// <param name="geometryOptions">The target encodings of geometries,
        /// PLAIN if empty.</param>
        /// <param name="timeouts">timeout settings</param>
        public RequestBase(string scope = default(string), string storedProfile = default(string), RequestProfile requestProfile = default(RequestProfile), string coordinateFormat = default(string), GeometryOptions geometryOptions = default(GeometryOptions), Timeouts timeouts = default(Timeouts), IList<string> userLogs = default(IList<string>))
        {
            Scope = scope;
            StoredProfile = storedProfile;
            RequestProfile = requestProfile;
            CoordinateFormat = coordinateFormat;
            GeometryOptions = geometryOptions;
            Timeouts = timeouts;
            UserLogs = userLogs;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a user defined scope for persistent data like distance
        /// matrices.
        /// </summary>
        [JsonProperty(PropertyName = "scope")]
        public string Scope { get; set; }

        /// <summary>
        /// Gets or sets the URL of the stored profile used by this request.
        /// The following types of URLs are supported:
        ///
        /// *  The name of the profile without its extension, e.g. `bicycle`.
        /// The corresponding file `bicycle.xml` must be available in the
        /// folder `conf/profiles`. Parent profiles must be located in the same
        /// folder. Profile names must not contain the special characters '-'
        /// and '+' and must not be called 'transport', 'labels', or
        /// 'background'.
        /// *  An http url, e.g. `http://localhost:8080/profiles/bicycle.xml`
        /// from which the profile must be available. In order to limit the
        /// access to outside servers, a whitelist can be configured in
        /// `xserver.conf` (see here). Parent profiles are not allowed for http
        /// urls.
        ///
        /// The URL is case-sensitive, although Microsoft Windows also accepts
        /// case-insensitive file names.
        /// </summary>
        [JsonProperty(PropertyName = "storedProfile")]
        public string StoredProfile { get; set; }

        /// <summary>
        /// Gets or sets the profile used by this request (parameters override
        /// those from storedProfile).
        /// </summary>
        [JsonProperty(PropertyName = "requestProfile")]
        public RequestProfile RequestProfile { get; set; }

        /// <summary>
        /// Gets or sets the coordinate format of all geometries in request and
        /// response. The default of EPSG:4326 represents WGS84. For more
        /// information see here.
        /// </summary>
        [JsonProperty(PropertyName = "coordinateFormat")]
        public string CoordinateFormat { get; set; }

        /// <summary>
        /// Gets or sets the target encodings of geometries, PLAIN if empty.
        /// </summary>
        [JsonProperty(PropertyName = "geometryOptions")]
        public GeometryOptions GeometryOptions { get; set; }

        /// <summary>
        /// Gets or sets timeout settings
        /// </summary>
        [JsonProperty(PropertyName = "timeouts")]
        public Timeouts Timeouts { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "userLogs")]
        public IList<string> UserLogs { get; set; }

    }
}
