// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Legal and physical attributes which describe the road segment in
    /// detail.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.segments.RoadAttributes
    /// </summary>
    public partial class RoadAttributes
    {
        /// <summary>
        /// Initializes a new instance of the RoadAttributes class.
        /// </summary>
        public RoadAttributes()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RoadAttributes class.
        /// </summary>
        /// <param name="prohibited">This segment is usually prohibited for the
        /// selected vehicle.</param>
        /// <param name="toll">The segment is part of a toll road. This
        /// attribute does not reflect the specific toll pricing conditions, so
        /// it is not guaranteed that the selected vehicle has to pay toll for
        /// this segment.</param>
        /// <param name="urban">The segment is within an urban, i.e. built-up
        /// area. It can be avoided or prohibited during route calculation
        /// using the parameter
        /// routingprofile.SpecialAreas.urbanPenalty.</param>
        /// <param name="residentsOnly">The segment is within a residents only
        /// area. It can be avoided, or prohibited during route calculation
        /// using the parameters
        /// routingprofile.SpecialAreas.residentsOnlyPenalty.</param>
        /// <param name="pedestrianZone">The segment is within a pedestrian
        /// zone. To open, avoid, or block it during route calculation see
        /// attribute prohibited.</param>
        /// <param name="oneWay">The segment is a one-way street.</param>
        /// <param name="roundabout">The segment is part of a
        /// roundabout.</param>
        /// <param name="ramp">The segment is part of a ramp. It can be avoided
        /// or prohibited during route calculation using the parameter
        /// routingprofile.Network.rampPenalty.</param>
        /// <param name="bridge">The segment is a bridge.</param>
        /// <param name="tunnel">The segment is a tunnel.</param>
        /// <param name="deliveryOnly">The segment is in a delivery only area.
        /// It can be allowed, avoided, or prohibited during route calculation
        /// using the parameters
        /// routingprofile.SpecialAreas.deliveryOnlyPenalty and
        /// vehicleprofile.LegalCondition.isDelivery.</param>
        /// <param name="allowedForEmergency">The segment is allowed for
        /// emergency vehicles (see
        /// vehicleprofile.LegalCondition.isEmergency).</param>
        /// <param name="lowEmissionZoneType">The low-emission zone types the
        /// selected vehicle must have to travel this segment. It can be
        /// opened, avoided, or prohibited during route calculation using the
        /// parameters
        /// routingprofile.SpecialAreas.forbiddenLowEmissionZonePenalty and
        /// vehicleprofile.Engine.lowEmissionZoneTypes. The available types can
        /// be requested through the xRuntime service, e.g. DE\_GREEN,
        /// DE\_YELLOW, DE\_RED for Germany.</param>
        public RoadAttributes(bool prohibited, bool toll, bool urban, bool residentsOnly, bool pedestrianZone, bool oneWay, bool roundabout, bool ramp, bool bridge, bool tunnel, bool deliveryOnly, bool allowedForEmergency, string lowEmissionZoneType = default(string))
        {
            Prohibited = prohibited;
            Toll = toll;
            Urban = urban;
            ResidentsOnly = residentsOnly;
            PedestrianZone = pedestrianZone;
            OneWay = oneWay;
            Roundabout = roundabout;
            Ramp = ramp;
            Bridge = bridge;
            Tunnel = tunnel;
            DeliveryOnly = deliveryOnly;
            AllowedForEmergency = allowedForEmergency;
            LowEmissionZoneType = lowEmissionZoneType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets this segment is usually prohibited for the selected
        /// vehicle.
        /// </summary>
        [JsonProperty(PropertyName = "prohibited")]
        public bool Prohibited { get; set; }

        /// <summary>
        /// Gets or sets the segment is part of a toll road. This attribute
        /// does not reflect the specific toll pricing conditions, so it is not
        /// guaranteed that the selected vehicle has to pay toll for this
        /// segment.
        /// </summary>
        [JsonProperty(PropertyName = "toll")]
        public bool Toll { get; set; }

        /// <summary>
        /// Gets or sets the segment is within an urban, i.e. built-up area. It
        /// can be avoided or prohibited during route calculation using the
        /// parameter routingprofile.SpecialAreas.urbanPenalty.
        /// </summary>
        [JsonProperty(PropertyName = "urban")]
        public bool Urban { get; set; }

        /// <summary>
        /// Gets or sets the segment is within a residents only area. It can be
        /// avoided, or prohibited during route calculation using the
        /// parameters routingprofile.SpecialAreas.residentsOnlyPenalty.
        /// </summary>
        [JsonProperty(PropertyName = "residentsOnly")]
        public bool ResidentsOnly { get; set; }

        /// <summary>
        /// Gets or sets the segment is within a pedestrian zone. To open,
        /// avoid, or block it during route calculation see attribute
        /// prohibited.
        /// </summary>
        [JsonProperty(PropertyName = "pedestrianZone")]
        public bool PedestrianZone { get; set; }

        /// <summary>
        /// Gets or sets the segment is a one-way street.
        /// </summary>
        [JsonProperty(PropertyName = "oneWay")]
        public bool OneWay { get; set; }

        /// <summary>
        /// Gets or sets the segment is part of a roundabout.
        /// </summary>
        [JsonProperty(PropertyName = "roundabout")]
        public bool Roundabout { get; set; }

        /// <summary>
        /// Gets or sets the segment is part of a ramp. It can be avoided or
        /// prohibited during route calculation using the parameter
        /// routingprofile.Network.rampPenalty.
        /// </summary>
        [JsonProperty(PropertyName = "ramp")]
        public bool Ramp { get; set; }

        /// <summary>
        /// Gets or sets the segment is a bridge.
        /// </summary>
        [JsonProperty(PropertyName = "bridge")]
        public bool Bridge { get; set; }

        /// <summary>
        /// Gets or sets the segment is a tunnel.
        /// </summary>
        [JsonProperty(PropertyName = "tunnel")]
        public bool Tunnel { get; set; }

        /// <summary>
        /// Gets or sets the segment is in a delivery only area. It can be
        /// allowed, avoided, or prohibited during route calculation using the
        /// parameters routingprofile.SpecialAreas.deliveryOnlyPenalty and
        /// vehicleprofile.LegalCondition.isDelivery.
        /// </summary>
        [JsonProperty(PropertyName = "deliveryOnly")]
        public bool DeliveryOnly { get; set; }

        /// <summary>
        /// Gets or sets the segment is allowed for emergency vehicles (see
        /// vehicleprofile.LegalCondition.isEmergency).
        /// </summary>
        [JsonProperty(PropertyName = "allowedForEmergency")]
        public bool AllowedForEmergency { get; set; }

        /// <summary>
        /// Gets or sets the low-emission zone types the selected vehicle must
        /// have to travel this segment. It can be opened, avoided, or
        /// prohibited during route calculation using the parameters
        /// routingprofile.SpecialAreas.forbiddenLowEmissionZonePenalty and
        /// vehicleprofile.Engine.lowEmissionZoneTypes. The available types can
        /// be requested through the xRuntime service, e.g. DE\_GREEN,
        /// DE\_YELLOW, DE\_RED for Germany.
        /// </summary>
        [JsonProperty(PropertyName = "lowEmissionZoneType")]
        public string LowEmissionZoneType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
