// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Base type for all route events which can appear in the RouteResponse.
    /// It contains information common to all event types. See the technical
    /// concept for more information.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.RouteEvent
    /// </summary>
    public partial class RouteEvent
    {
        /// <summary>
        /// Initializes a new instance of the RouteEvent class.
        /// </summary>
        public RouteEvent()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RouteEvent class.
        /// </summary>
        /// <param name="eventType">The type of the current route event.
        /// Possible values include: 'MANEUVER_EVENT', 'TOUR_EVENT',
        /// 'TOLL_EVENT', 'WAYPOINT_EVENT', 'ROUTE_VIOLATION_EVENT',
        /// 'UTC_OFFSET_EVENT', 'COUNTRY_EVENT'</param>
        /// <param name="startsAt">The point in time at which the event starts.
        /// This field is only present if a time-consideration scenario with a
        /// reference time is given in the request. The time zone is that of
        /// the reference time. Use the UTCOffsetEvent to derive the local
        /// time.</param>
        /// <param name="coordinate">The location at which the event occurs.
        /// This coordinate is not necessarily the coordinate of the related
        /// node. The event such as a traffic incident can, for example, occur
        /// in the middle of a long segment. This coordinate is designed to
        /// draw an icon on a map to mark the event.</param>
        /// <param name="nodeIndex">The index of the node in the
        /// RouteResponse.nodes list. As every segment starts at the node with
        /// the same index, it is also equal to the segment in the
        /// RouteResponse.segments list, if present, except for the very last
        /// index. This field is only present if the list of nodes is
        /// present.</param>
        /// <param name="distanceFromStart">The distance of the route from the
        /// start up to this event.</param>
        /// <param name="travelTimeFromStart">The travel time for the route
        /// from the start up to this event.</param>
        public RouteEvent(RouteEventType? eventType = default(RouteEventType?), System.DateTime? startsAt = default(System.DateTime?), Coordinate coordinate = default(Coordinate), int? nodeIndex = default(int?), double? distanceFromStart = default(double?), double? travelTimeFromStart = default(double?))
        {
            EventType = eventType;
            StartsAt = startsAt;
            Coordinate = coordinate;
            NodeIndex = nodeIndex;
            DistanceFromStart = distanceFromStart;
            TravelTimeFromStart = travelTimeFromStart;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the type of the current route event. Possible values
        /// include: 'MANEUVER_EVENT', 'TOUR_EVENT', 'TOLL_EVENT',
        /// 'WAYPOINT_EVENT', 'ROUTE_VIOLATION_EVENT', 'UTC_OFFSET_EVENT',
        /// 'COUNTRY_EVENT'
        /// </summary>
        [JsonProperty(PropertyName = "eventType")]
        public RouteEventType? EventType { get; set; }

        /// <summary>
        /// Gets or sets the point in time at which the event starts. This
        /// field is only present if a time-consideration scenario with a
        /// reference time is given in the request. The time zone is that of
        /// the reference time. Use the UTCOffsetEvent to derive the local
        /// time.
        /// </summary>
        [JsonProperty(PropertyName = "startsAt")]
        public System.DateTime? StartsAt { get; set; }

        /// <summary>
        /// Gets or sets the location at which the event occurs. This
        /// coordinate is not necessarily the coordinate of the related node.
        /// The event such as a traffic incident can, for example, occur in the
        /// middle of a long segment. This coordinate is designed to draw an
        /// icon on a map to mark the event.
        /// </summary>
        [JsonProperty(PropertyName = "coordinate")]
        public Coordinate Coordinate { get; set; }

        /// <summary>
        /// Gets or sets the index of the node in the RouteResponse.nodes list.
        /// As every segment starts at the node with the same index, it is also
        /// equal to the segment in the RouteResponse.segments list, if
        /// present, except for the very last index. This field is only present
        /// if the list of nodes is present.
        /// </summary>
        [JsonProperty(PropertyName = "nodeIndex")]
        public int? NodeIndex { get; set; }

        /// <summary>
        /// Gets or sets the distance of the route from the start up to this
        /// event.
        /// </summary>
        [JsonProperty(PropertyName = "distanceFromStart")]
        public double? DistanceFromStart { get; set; }

        /// <summary>
        /// Gets or sets the travel time for the route from the start up to
        /// this event.
        /// </summary>
        [JsonProperty(PropertyName = "travelTimeFromStart")]
        public double? TravelTimeFromStart { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Coordinate != null)
            {
                Coordinate.Validate();
            }
        }
    }
}
