// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Specifies how to calculate the route and how to fill the ResultFields
    /// which are enabled.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.RouteOptions
    /// </summary>
    public partial class RouteOptions
    {
        /// <summary>
        /// Initializes a new instance of the RouteOptions class.
        /// </summary>
        public RouteOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RouteOptions class.
        /// </summary>
        /// <param name="timeConsideration">Specifies how to evaluate data
        /// which contain time restrictions. For the use cases see time
        /// consideration. If the object is NULL, all data which have time
        /// restrictions are not considered. For some scenarios a reference
        /// time is needed to match properties with a time domain against this
        /// reference time. If for this time no time zone is defined, i.e. it
        /// represents a local time, all waypoints with their dedicated
        /// locations are checked for their time zone offsets. If a time zone
        /// cannot be determined for such a location, this location is not
        /// taken into further consideration. So, in a first step a set of
        /// locations with calculated time zones is determined. If this set
        /// contains no elements, an exception is thrown. When the time zones
        /// differ for some locations, then the time zone containing most
        /// locations is used and a result limitation is added to the result.
        /// If all locations are in the same time zone, then this time zone is
        /// used and the result is calculated as usual. Please note that the
        /// time consideration values ExactTimeConsiderationAtStart and
        /// ExactTimeConsiderationAtArrival are not applicable in combination
        /// with routing types RoutingType.HIGH\_PERFORMANCE\_ROUTING and
        /// RoutingType.HIGH\_PERFORMANCE\_ROUTING\_WITH\_FALLBACK\_CONVENTIONAL
        /// and will result respectively in an exception and a result
        /// limitation.</param>
        /// <param name="contentSnapshotId">Specifies the content snapshot to
        /// use. If no snapshot ID is set, the most recent content is
        /// used.</param>
        /// <param name="highPerformanceRoutingNetworkId">Specifies the
        /// high-performance routing network to use. Besides, the routing type
        /// must be explicitly set to RoutingType.HIGH\_PERFORMANCE\_ROUTING
        /// otherwise a exceptions.ParameterConflictException is thrown. The
        /// profile and request parameters of the high-performance routing
        /// network are used for linking and routing. The stored profile of the
        /// service.RequestBase will be ignored. Throws a
        /// exceptions.DataNotAvailableException if the high-performance
        /// routing network with the given id does not exist.</param>
        /// <param name="geographicRestrictions">Specifies geographic
        /// restrictions that are considered during the route
        /// calculation.</param>
        /// <param name="polylineOptions">Specifies how the polyline shall be
        /// calculated.</param>
        /// <param name="emissionOptions">Specifies what emissions shall be
        /// calculated.</param>
        /// <param name="effectiveFuelConsumption">Specifies the fuel
        /// consumption values.</param>
        /// <param name="routingType">Strategy to decide if high-performance
        /// routing or conventional routing is used. For further explanation
        /// see the definition of RoutingType. Possible values include:
        /// 'CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING_WITH_FALLBACK_CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING'</param>
        /// <param name="tourRestrictions">Specifies how to calculate the tour
        /// information.</param>
        public RouteOptions(TimeConsideration timeConsideration = default(TimeConsideration), string contentSnapshotId = default(string), string highPerformanceRoutingNetworkId = default(string), GeographicRestrictions geographicRestrictions = default(GeographicRestrictions), PolylineOptions polylineOptions = default(PolylineOptions), EmissionOptions emissionOptions = default(EmissionOptions), EffectiveFuelConsumption effectiveFuelConsumption = default(EffectiveFuelConsumption), RoutingType? routingType = default(RoutingType?), RoutingTourRestrictions tourRestrictions = default(RoutingTourRestrictions))
        {
            TimeConsideration = timeConsideration;
            ContentSnapshotId = contentSnapshotId;
            HighPerformanceRoutingNetworkId = highPerformanceRoutingNetworkId;
            GeographicRestrictions = geographicRestrictions;
            PolylineOptions = polylineOptions;
            EmissionOptions = emissionOptions;
            EffectiveFuelConsumption = effectiveFuelConsumption;
            RoutingType = routingType;
            TourRestrictions = tourRestrictions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies how to evaluate data which contain time
        /// restrictions. For the use cases see time consideration. If the
        /// object is NULL, all data which have time restrictions are not
        /// considered. For some scenarios a reference time is needed to match
        /// properties with a time domain against this reference time. If for
        /// this time no time zone is defined, i.e. it represents a local time,
        /// all waypoints with their dedicated locations are checked for their
        /// time zone offsets. If a time zone cannot be determined for such a
        /// location, this location is not taken into further consideration.
        /// So, in a first step a set of locations with calculated time zones
        /// is determined. If this set contains no elements, an exception is
        /// thrown. When the time zones differ for some locations, then the
        /// time zone containing most locations is used and a result limitation
        /// is added to the result. If all locations are in the same time zone,
        /// then this time zone is used and the result is calculated as usual.
        /// Please note that the time consideration values
        /// ExactTimeConsiderationAtStart and ExactTimeConsiderationAtArrival
        /// are not applicable in combination with routing types
        /// RoutingType.HIGH\_PERFORMANCE\_ROUTING and
        /// RoutingType.HIGH\_PERFORMANCE\_ROUTING\_WITH\_FALLBACK\_CONVENTIONAL
        /// and will result respectively in an exception and a result
        /// limitation.
        /// </summary>
        [JsonProperty(PropertyName = "timeConsideration")]
        public TimeConsideration TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets specifies the content snapshot to use. If no snapshot
        /// ID is set, the most recent content is used.
        /// </summary>
        [JsonProperty(PropertyName = "contentSnapshotId")]
        public string ContentSnapshotId { get; set; }

        /// <summary>
        /// Gets or sets specifies the high-performance routing network to use.
        /// Besides, the routing type must be explicitly set to
        /// RoutingType.HIGH\_PERFORMANCE\_ROUTING otherwise a
        /// exceptions.ParameterConflictException is thrown. The profile and
        /// request parameters of the high-performance routing network are used
        /// for linking and routing. The stored profile of the
        /// service.RequestBase will be ignored. Throws a
        /// exceptions.DataNotAvailableException if the high-performance
        /// routing network with the given id does not exist.
        /// </summary>
        [JsonProperty(PropertyName = "highPerformanceRoutingNetworkId")]
        public string HighPerformanceRoutingNetworkId { get; set; }

        /// <summary>
        /// Gets or sets specifies geographic restrictions that are considered
        /// during the route calculation.
        /// </summary>
        [JsonProperty(PropertyName = "geographicRestrictions")]
        public GeographicRestrictions GeographicRestrictions { get; set; }

        /// <summary>
        /// Gets or sets specifies how the polyline shall be calculated.
        /// </summary>
        [JsonProperty(PropertyName = "polylineOptions")]
        public PolylineOptions PolylineOptions { get; set; }

        /// <summary>
        /// Gets or sets specifies what emissions shall be calculated.
        /// </summary>
        [JsonProperty(PropertyName = "emissionOptions")]
        public EmissionOptions EmissionOptions { get; set; }

        /// <summary>
        /// Gets or sets specifies the fuel consumption values.
        /// </summary>
        [JsonProperty(PropertyName = "effectiveFuelConsumption")]
        public EffectiveFuelConsumption EffectiveFuelConsumption { get; set; }

        /// <summary>
        /// Gets or sets strategy to decide if high-performance routing or
        /// conventional routing is used. For further explanation see the
        /// definition of RoutingType. Possible values include: 'CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING_WITH_FALLBACK_CONVENTIONAL',
        /// 'HIGH_PERFORMANCE_ROUTING'
        /// </summary>
        [JsonProperty(PropertyName = "routingType")]
        public RoutingType? RoutingType { get; set; }

        /// <summary>
        /// Gets or sets specifies how to calculate the tour information.
        /// </summary>
        [JsonProperty(PropertyName = "tourRestrictions")]
        public RoutingTourRestrictions TourRestrictions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (GeographicRestrictions != null)
            {
                GeographicRestrictions.Validate();
            }
            if (TourRestrictions != null)
            {
                TourRestrictions.Validate();
            }
        }
    }
}
