// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Additional parameters for Route operation.
    /// </summary>
    public partial class RouteParameters
    {
        /// <summary>
        /// Initializes a new instance of the RouteParameters class.
        /// </summary>
        public RouteParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RouteParameters class.
        /// </summary>
        /// <param name="storedProfile">The name of the stored profile to use
        /// without its extension, e.g. `bicycle`. The corresponding file
        /// `bicycle.xml` must be available in the folder `conf/profiles`.
        /// Parent profiles must be located in the same folder.</param>
        /// <param name="polyline">Specifies if the RouteResponse.polyline
        /// shall be returned for the complete route.</param>
        /// <param name="themeIds">A comma-separated list of Feature Layer
        /// theme IDs which will be considered. If this parameter is specified,
        /// themes enabled in the stored profile are ignored. These themes can
        /// be any of the supported Feature Layer themes, such as
        /// `PTV_TruckAttributes`. If this parameter is not present, the themes
        /// defined by the stored profile are used. A trailing comma is
        /// permitted. For more information see Calculating the Best Route for
        /// Rush Hour Traffic and Considering Long-term Blockings.</param>
        /// <param name="preferredRouteTypes">The road networks to be preferred
        /// by the routing algorithm as a comma-separated list (only if the
        /// feature layer PTV\_PreferredRoutes is enabled). The available types
        /// can be requested through the xRuntime service and are documented in
        /// the manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. If this parameter is not present, all types
        /// of PTV\_PreferredRoutes are displayed.</param>
        /// <param name="timeConsideration">Specifies how to evaluate Feature
        /// Layer attributes which contain time restrictions. For time
        /// consideration scenario `NONE` the parameters for reference time and
        /// timespan are not evaluated. For `SNAPSHOT`, `TIME_SPAN`,
        /// `EXACT_TIME_AT_START` and `EXACT_TIME_AT_ARRIVAL` the reference
        /// time is required. The time span is needed for the `TIME_SPAN`
        /// scenarios. For detailed information about time consideration
        /// scenarios see time consideration. Possible values include: 'NONE',
        /// 'SNAPSHOT', 'TIME_SPAN', 'EXACT_TIME_AT_START',
        /// 'EXACT_TIME_AT_ARRIVAL', 'OPTIMISTIC'</param>
        /// <param name="referenceTime">The reference time at which Feature
        /// Layer attributes with time restrictions will be evaluated. The time
        /// format either has to conform to the notation of xs:dateTime such as
        /// 2015-12-24T12:00:00+01:00, or it has to be a datetime sequence
        /// without any delimiters nor time zone specification such as
        /// 20151224T120000. If the time-zone offset is missing, the
        /// corresponding service tries to detect it by means of information
        /// available in the calling context. A detailed description of this
        /// behavior can be found in the technical concept time zones. It is
        /// recommended to always specify the time zone. If no reference time
        /// is set, the current UTC time is used.</param>
        /// <param name="timeSpan">The duration of time (in combination with
        /// reference time as start) at which Feature Layer attributes with
        /// time restrictions will be evaluated, defined in \[s\]. The value is
        /// rounded to whole seconds.</param>
        /// <param name="contentSnapshotId">Specifies the content snapshot to
        /// use. If no snapshot ID is set, the most recent content is
        /// used.</param>
        public RouteParameters(string storedProfile = default(string), bool? polyline = default(bool?), string themeIds = default(string), string preferredRouteTypes = default(string), TimeConsiderationScenario? timeConsideration = default(TimeConsiderationScenario?), System.DateTime? referenceTime = default(System.DateTime?), double? timeSpan = default(double?), string contentSnapshotId = default(string))
        {
            StoredProfile = storedProfile;
            Polyline = polyline;
            ThemeIds = themeIds;
            PreferredRouteTypes = preferredRouteTypes;
            TimeConsideration = timeConsideration;
            ReferenceTime = referenceTime;
            TimeSpan = timeSpan;
            ContentSnapshotId = contentSnapshotId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the stored profile to use without its
        /// extension, e.g. `bicycle`. The corresponding file `bicycle.xml`
        /// must be available in the folder `conf/profiles`. Parent profiles
        /// must be located in the same folder.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string StoredProfile { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.polyline shall be
        /// returned for the complete route.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public bool? Polyline { get; set; }

        /// <summary>
        /// Gets or sets a comma-separated list of Feature Layer theme IDs
        /// which will be considered. If this parameter is specified, themes
        /// enabled in the stored profile are ignored. These themes can be any
        /// of the supported Feature Layer themes, such as
        /// `PTV_TruckAttributes`. If this parameter is not present, the themes
        /// defined by the stored profile are used. A trailing comma is
        /// permitted. For more information see Calculating the Best Route for
        /// Rush Hour Traffic and Considering Long-term Blockings.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string ThemeIds { get; set; }

        /// <summary>
        /// Gets or sets the road networks to be preferred by the routing
        /// algorithm as a comma-separated list (only if the feature layer
        /// PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. If this parameter is not present, all types
        /// of PTV\_PreferredRoutes are displayed.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string PreferredRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets specifies how to evaluate Feature Layer attributes
        /// which contain time restrictions. For time consideration scenario
        /// `NONE` the parameters for reference time and timespan are not
        /// evaluated. For `SNAPSHOT`, `TIME_SPAN`, `EXACT_TIME_AT_START` and
        /// `EXACT_TIME_AT_ARRIVAL` the reference time is required. The time
        /// span is needed for the `TIME_SPAN` scenarios. For detailed
        /// information about time consideration scenarios see time
        /// consideration. Possible values include: 'NONE', 'SNAPSHOT',
        /// 'TIME_SPAN', 'EXACT_TIME_AT_START', 'EXACT_TIME_AT_ARRIVAL',
        /// 'OPTIMISTIC'
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public TimeConsiderationScenario? TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets the reference time at which Feature Layer attributes
        /// with time restrictions will be evaluated. The time format either
        /// has to conform to the notation of xs:dateTime such as
        /// 2015-12-24T12:00:00+01:00, or it has to be a datetime sequence
        /// without any delimiters nor time zone specification such as
        /// 20151224T120000. If the time-zone offset is missing, the
        /// corresponding service tries to detect it by means of information
        /// available in the calling context. A detailed description of this
        /// behavior can be found in the technical concept time zones. It is
        /// recommended to always specify the time zone. If no reference time
        /// is set, the current UTC time is used.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public System.DateTime? ReferenceTime { get; set; }

        /// <summary>
        /// Gets or sets the duration of time (in combination with reference
        /// time as start) at which Feature Layer attributes with time
        /// restrictions will be evaluated, defined in \[s\]. The value is
        /// rounded to whole seconds.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public double? TimeSpan { get; set; }

        /// <summary>
        /// Gets or sets specifies the content snapshot to use. If no snapshot
        /// ID is set, the most recent content is used.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string ContentSnapshotId { get; set; }

    }
}
