// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class RouteResponse : ResponseBase
    {
        /// <summary>
        /// Initializes a new instance of the RouteResponse class.
        /// </summary>
        public RouteResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RouteResponse class.
        /// </summary>
        /// <param name="distance">The distance of the complete route. It is
        /// the sum of distances of all segments and hence is a whole number
        /// without decimal places (see Segment.distance). It equals the sum of
        /// distances of all legs.</param>
        /// <param name="travelTime">The travel time for the complete route. It
        /// is the sum of travel times of all segments and hence has up to
        /// three decimal places (see Segment.travelTime). It equals the sum of
        /// travel times of all legs.</param>
        /// <param name="violated">If set to true, indicates that this route
        /// contains a violation for the chosen vehicle.</param>
        /// <param name="polyline">The polyline of the complete route. This
        /// polyline consists of all coordinates representing the route and can
        /// be used to draw the route into a map.
        ///
        /// It is only returned if requested by ResultFields.polyline. It
        /// contains elevations only if requested by
        /// PolylineOptions.elevations.
        ///
        /// If the elevations data do not cover the complete polyline, an
        /// ElevationsNotAvailableLimitation will be available which states
        /// which parts of the polyline are not covered.</param>
        /// <param name="toll">The toll information for the complete route.
        ///
        /// It is only returned if requested by ResultFields.toll.</param>
        /// <param name="emissions">The emissions along the route.</param>
        /// <param name="guidedNavigationRoute">A base64 encoded representation
        /// of the route that can be used for guided navigation. Calculating a
        /// guided navigation route requires maneuver events which have to be
        /// requested separately. The base64 binary has to be decoded and saved
        /// as text file and can then be imported in PTV Navigator and used for
        /// navigation.</param>
        /// <param name="tourReport">The report regarding the tour
        /// calculation.</param>
        /// <param name="report">The report regarding the route
        /// calculation.</param>
        public RouteResponse(double distance, double travelTime, bool violated, IList<ResultLimitation> resultLimitations = default(IList<ResultLimitation>), IList<Waypoint> waypoints = default(IList<Waypoint>), IList<Leg> legs = default(IList<Leg>), IList<Segment> segments = default(IList<Segment>), IList<Node> nodes = default(IList<Node>), IList<RouteEvent> events = default(IList<RouteEvent>), EncodedGeometry polyline = default(EncodedGeometry), TollResult toll = default(TollResult), Emissions emissions = default(Emissions), byte[] guidedNavigationRoute = default(byte[]), RoutingTourReport tourReport = default(RoutingTourReport), RouteReport report = default(RouteReport))
            : base(resultLimitations)
        {
            Distance = distance;
            TravelTime = travelTime;
            Waypoints = waypoints;
            Legs = legs;
            Segments = segments;
            Nodes = nodes;
            Events = events;
            Polyline = polyline;
            Toll = toll;
            Emissions = emissions;
            GuidedNavigationRoute = guidedNavigationRoute;
            TourReport = tourReport;
            Violated = violated;
            Report = report;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the distance of the complete route. It is the sum of
        /// distances of all segments and hence is a whole number without
        /// decimal places (see Segment.distance). It equals the sum of
        /// distances of all legs.
        /// </summary>
        [JsonProperty(PropertyName = "distance")]
        public double Distance { get; set; }

        /// <summary>
        /// Gets or sets the travel time for the complete route. It is the sum
        /// of travel times of all segments and hence has up to three decimal
        /// places (see Segment.travelTime). It equals the sum of travel times
        /// of all legs.
        /// </summary>
        [JsonProperty(PropertyName = "travelTime")]
        public double TravelTime { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "waypoints")]
        public IList<Waypoint> Waypoints { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "legs")]
        public IList<Leg> Legs { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "segments")]
        public IList<Segment> Segments { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "nodes")]
        public IList<Node> Nodes { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "events")]
        public IList<RouteEvent> Events { get; set; }

        /// <summary>
        /// Gets or sets the polyline of the complete route. This polyline
        /// consists of all coordinates representing the route and can be used
        /// to draw the route into a map.
        ///
        /// It is only returned if requested by ResultFields.polyline. It
        /// contains elevations only if requested by
        /// PolylineOptions.elevations.
        ///
        /// If the elevations data do not cover the complete polyline, an
        /// ElevationsNotAvailableLimitation will be available which states
        /// which parts of the polyline are not covered.
        /// </summary>
        [JsonProperty(PropertyName = "polyline")]
        public EncodedGeometry Polyline { get; set; }

        /// <summary>
        /// Gets or sets the toll information for the complete route.
        ///
        /// It is only returned if requested by ResultFields.toll.
        /// </summary>
        [JsonProperty(PropertyName = "toll")]
        public TollResult Toll { get; set; }

        /// <summary>
        /// Gets or sets the emissions along the route.
        /// </summary>
        [JsonProperty(PropertyName = "emissions")]
        public Emissions Emissions { get; set; }

        /// <summary>
        /// Gets or sets a base64 encoded representation of the route that can
        /// be used for guided navigation. Calculating a guided navigation
        /// route requires maneuver events which have to be requested
        /// separately. The base64 binary has to be decoded and saved as text
        /// file and can then be imported in PTV Navigator and used for
        /// navigation.
        /// </summary>
        [JsonProperty(PropertyName = "guidedNavigationRoute")]
        public byte[] GuidedNavigationRoute { get; set; }

        /// <summary>
        /// Gets or sets the report regarding the tour calculation.
        /// </summary>
        [JsonProperty(PropertyName = "tourReport")]
        public RoutingTourReport TourReport { get; set; }

        /// <summary>
        /// Gets or sets if set to true, indicates that this route contains a
        /// violation for the chosen vehicle.
        /// </summary>
        [JsonProperty(PropertyName = "violated")]
        public bool Violated { get; set; }

        /// <summary>
        /// Gets or sets the report regarding the route calculation.
        /// </summary>
        [JsonProperty(PropertyName = "report")]
        public RouteReport Report { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Waypoints != null)
            {
                foreach (var element in Waypoints)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (Legs != null)
            {
                foreach (var element1 in Legs)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
            if (Segments != null)
            {
                foreach (var element2 in Segments)
                {
                    if (element2 != null)
                    {
                        element2.Validate();
                    }
                }
            }
            if (Nodes != null)
            {
                foreach (var element3 in Nodes)
                {
                    if (element3 != null)
                    {
                        element3.Validate();
                    }
                }
            }
            if (Events != null)
            {
                foreach (var element4 in Events)
                {
                    if (element4 != null)
                    {
                        element4.Validate();
                    }
                }
            }
            if (Polyline != null)
            {
                Polyline.Validate();
            }
        }
    }
}
