// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Specifies which fields of the RouteResponse shall be returned.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.ResultFields
    /// </summary>
    public partial class RoutingResultFields
    {
        /// <summary>
        /// Initializes a new instance of the RoutingResultFields class.
        /// </summary>
        public RoutingResultFields()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RoutingResultFields class.
        /// </summary>
        /// <param name="waypoints">Specifies if the RouteResponse.waypoints
        /// shall be returned for the complete route.</param>
        /// <param name="legs">Specifies if and to what extent the
        /// RouteResponse.legs shall be returned for the complete
        /// route.</param>
        /// <param name="segments">Specifies if and to what extent the
        /// RouteResponse.segments shall be returned for the complete
        /// route.</param>
        /// <param name="nodes">Specifies if the RouteResponse.nodes shall be
        /// returned for the complete route.</param>
        /// <param name="polyline">Specifies if the RouteResponse.polyline
        /// shall be returned for the complete route. In order to return the
        /// RouteResponse.polyline for legs and segments, enable
        /// LegResultFields.polyline and SegmentResultFields.polyline. In order
        /// to obtain the elevations for the RouteResponse.polyline, enable
        /// PolylineOptions.elevations in RouteOptions.</param>
        /// <param name="toll">Specifies if and to what extent the
        /// RouteResponse.toll shall be returned for the complete
        /// route.</param>
        /// <param name="emissions">Specifies if the RouteResponse.emissions
        /// shall be returned for the complete route.</param>
        /// <param name="report">Specifies if the RouteResponse.report shall be
        /// returned for the complete route.</param>
        /// <param name="tourReport">Specifies if the RouteResponse.tourReport
        /// shall be returned for the complete route.</param>
        /// <param name="guidedNavigationRoute">Specifies if the
        /// RouteResponse.guidedNavigationRoute shall be returned for the
        /// complete route.
        /// Setting this parameter to true requires a detailed list of maneuver
        /// events, which have to be requested separately by adding the
        /// RouteEventType MANEUVER\_EVENT to the list of eventTypes in the
        /// result fields.
        /// This feature therefore may consume some additional computation time
        /// and returns a list of maneuver events in the response.</param>
        public RoutingResultFields(bool? waypoints = default(bool?), LegResultFields legs = default(LegResultFields), SegmentResultFields segments = default(SegmentResultFields), bool? nodes = default(bool?), IList<RouteEventType?> eventTypes = default(IList<RouteEventType?>), bool? polyline = default(bool?), TollResultFields toll = default(TollResultFields), bool? emissions = default(bool?), bool? report = default(bool?), bool? tourReport = default(bool?), bool? guidedNavigationRoute = default(bool?))
        {
            Waypoints = waypoints;
            Legs = legs;
            Segments = segments;
            Nodes = nodes;
            EventTypes = eventTypes;
            Polyline = polyline;
            Toll = toll;
            Emissions = emissions;
            Report = report;
            TourReport = tourReport;
            GuidedNavigationRoute = guidedNavigationRoute;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.waypoints shall be
        /// returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "waypoints")]
        public bool? Waypoints { get; set; }

        /// <summary>
        /// Gets or sets specifies if and to what extent the RouteResponse.legs
        /// shall be returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "legs")]
        public LegResultFields Legs { get; set; }

        /// <summary>
        /// Gets or sets specifies if and to what extent the
        /// RouteResponse.segments shall be returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "segments")]
        public SegmentResultFields Segments { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.nodes shall be returned
        /// for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "nodes")]
        public bool? Nodes { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "eventTypes")]
        public IList<RouteEventType?> EventTypes { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.polyline shall be
        /// returned for the complete route. In order to return the
        /// RouteResponse.polyline for legs and segments, enable
        /// LegResultFields.polyline and SegmentResultFields.polyline. In order
        /// to obtain the elevations for the RouteResponse.polyline, enable
        /// PolylineOptions.elevations in RouteOptions.
        /// </summary>
        [JsonProperty(PropertyName = "polyline")]
        public bool? Polyline { get; set; }

        /// <summary>
        /// Gets or sets specifies if and to what extent the RouteResponse.toll
        /// shall be returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "toll")]
        public TollResultFields Toll { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.emissions shall be
        /// returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "emissions")]
        public bool? Emissions { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.report shall be
        /// returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "report")]
        public bool? Report { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.tourReport shall be
        /// returned for the complete route.
        /// </summary>
        [JsonProperty(PropertyName = "tourReport")]
        public bool? TourReport { get; set; }

        /// <summary>
        /// Gets or sets specifies if the RouteResponse.guidedNavigationRoute
        /// shall be returned for the complete route.
        /// Setting this parameter to true requires a detailed list of maneuver
        /// events, which have to be requested separately by adding the
        /// RouteEventType MANEUVER\_EVENT to the list of eventTypes in the
        /// result fields.
        /// This feature therefore may consume some additional computation time
        /// and returns a list of maneuver events in the response.
        /// </summary>
        [JsonProperty(PropertyName = "guidedNavigationRoute")]
        public bool? GuidedNavigationRoute { get; set; }

    }
}
