// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Specifies the all the information to take into account to calculate the
    /// tour.
    ///
    /// Please note that if tourplanning.MultiDayWorkingHours is selected, the
    /// tourplanning.MultiDayWorkingHours.dailyRestPositions field has to be
    /// set explicitly to tourplanning.RestPositions.ANYWHERE.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.TourRestrictions
    /// </summary>
    public partial class RoutingTourRestrictions
    {
        /// <summary>
        /// Initializes a new instance of the RoutingTourRestrictions class.
        /// </summary>
        public RoutingTourRestrictions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RoutingTourRestrictions class.
        /// </summary>
        /// <param name="maximumTravelTimePerTour">Restricts the maximum
        /// allowed total travel time per tour in seconds. The travel time
        /// contains all waiting, service and driving times. Drivers' working
        /// hours may be more restrictive and enforce a lower limit. Is
        /// infinite if it is not set.</param>
        /// <param name="maximumDrivingTimePerTour">Restricts the maximum
        /// allowed total driving time per tour in seconds. Drivers' working
        /// hours may be more restrictive and enforce a lower limit. Is
        /// infinite if it is not set. Not supported for time dependent driving
        /// times.</param>
        /// <param name="workingHours">Defines the rules regarding drivers'
        /// working hours. Drivers' working hours are only active if this
        /// member is set.</param>
        /// <param name="workLogbookSummary">The summary of a logbook of a
        /// driver. If such a summary is missing, it is assumed that the driver
        /// is fully rested.</param>
        public RoutingTourRestrictions(double? maximumTravelTimePerTour = default(double?), double? maximumDrivingTimePerTour = default(double?), WorkingHours workingHours = default(WorkingHours), WorkLogbookSummary workLogbookSummary = default(WorkLogbookSummary))
        {
            MaximumTravelTimePerTour = maximumTravelTimePerTour;
            MaximumDrivingTimePerTour = maximumDrivingTimePerTour;
            WorkingHours = workingHours;
            WorkLogbookSummary = workLogbookSummary;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets restricts the maximum allowed total travel time per
        /// tour in seconds. The travel time contains all waiting, service and
        /// driving times. Drivers' working hours may be more restrictive and
        /// enforce a lower limit. Is infinite if it is not set.
        /// </summary>
        [JsonProperty(PropertyName = "maximumTravelTimePerTour")]
        public double? MaximumTravelTimePerTour { get; set; }

        /// <summary>
        /// Gets or sets restricts the maximum allowed total driving time per
        /// tour in seconds. Drivers' working hours may be more restrictive and
        /// enforce a lower limit. Is infinite if it is not set. Not supported
        /// for time dependent driving times.
        /// </summary>
        [JsonProperty(PropertyName = "maximumDrivingTimePerTour")]
        public double? MaximumDrivingTimePerTour { get; set; }

        /// <summary>
        /// Gets or sets defines the rules regarding drivers' working hours.
        /// Drivers' working hours are only active if this member is set.
        /// </summary>
        [JsonProperty(PropertyName = "workingHours")]
        public WorkingHours WorkingHours { get; set; }

        /// <summary>
        /// Gets or sets the summary of a logbook of a driver. If such a
        /// summary is missing, it is assumed that the driver is fully rested.
        /// </summary>
        [JsonProperty(PropertyName = "workLogbookSummary")]
        public WorkLogbookSummary WorkLogbookSummary { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (WorkLogbookSummary != null)
            {
                WorkLogbookSummary.Validate();
            }
        }
    }
}
