// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the behavior of heuristics for search space reduction. The
    /// search space is the part of the routing graph that is explored to
    /// answer a route request and thus has a direct impact on the routing
    /// performance and quality.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.routingprofile.SearchSpace
    /// </summary>
    public partial class SearchSpace
    {
        /// <summary>
        /// Initializes a new instance of the SearchSpace class.
        /// </summary>
        public SearchSpace()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SearchSpace class.
        /// </summary>
        /// <param name="excludeByNetworkClass">Defines a heuristic search
        /// space reduction by network class. For more information about
        /// network classes see the type of the segment attribute network
        /// class.</param>
        /// <param name="heuristicAggressiveness">The aggressiveness of
        /// heuristic search space optimization. The aggressiveness represents
        /// the trade-off between the quality of the solution and the
        /// performance of the route calculation. A value of 0% disables the
        /// heuristic search space optimization and guarantees a mathematically
        /// optimal route, whereas with a value of 100% the heuristic is very
        /// aggressive and the probability to get a route that is not optimal
        /// is high. Note that the search space reduction defined in
        /// ExcludeByNetworkClass is not affected by the
        /// heuristicAggressiveness.</param>
        public SearchSpace(ExcludeByNetworkClass excludeByNetworkClass = default(ExcludeByNetworkClass), double? heuristicAggressiveness = default(double?))
        {
            ExcludeByNetworkClass = excludeByNetworkClass;
            HeuristicAggressiveness = heuristicAggressiveness;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines a heuristic search space reduction by network
        /// class. For more information about network classes see the type of
        /// the segment attribute network class.
        /// </summary>
        [JsonProperty(PropertyName = "excludeByNetworkClass")]
        public ExcludeByNetworkClass ExcludeByNetworkClass { get; set; }

        /// <summary>
        /// Gets or sets the aggressiveness of heuristic search space
        /// optimization. The aggressiveness represents the trade-off between
        /// the quality of the solution and the performance of the route
        /// calculation. A value of 0% disables the heuristic search space
        /// optimization and guarantees a mathematically optimal route, whereas
        /// with a value of 100% the heuristic is very aggressive and the
        /// probability to get a route that is not optimal is high. Note that
        /// the search space reduction defined in ExcludeByNetworkClass is not
        /// affected by the heuristicAggressiveness.
        /// </summary>
        [JsonProperty(PropertyName = "heuristicAggressiveness")]
        public double? HeuristicAggressiveness { get; set; }

    }
}
