// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A segment is defined by a start- and an end-node, which in turn will
    /// represent some geographic location. A segment may carry additional
    /// attributes and will add to the duration of a journey.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.Segment
    /// </summary>
    public partial class Segment
    {
        /// <summary>
        /// Initializes a new instance of the Segment class.
        /// </summary>
        public Segment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Segment class.
        /// </summary>
        /// <param name="distance">The travel distance for the segment. It is
        /// always a whole number and depends on the segment type as follows.
        ///
        /// *  segments.SegmentType.NETWORK\_SEGMENT. The distance on the
        /// network segment which is actually driven on.
        /// *  segments.SegmentType.LINK\_SEGMENT. The air-line distance
        /// between input and link node.
        /// *  segments.SegmentType.COMBINED\_TRANSPORT. The travel distance is
        /// always 0.
        /// *  segments.SegmentType.NOT\_DRIVING. The travel distance is always
        /// 0.</param>
        /// <param name="travelTime">The travel time for the segment. It has up
        /// to three decimal places and depends on the segment type as follows.
        ///
        /// *  segments.SegmentType.NETWORK\_SEGMENT. The travel time is
        /// calculated from the segment length and the travel speed (see
        /// below).
        /// *  segments.SegmentType.LINK\_SEGMENT. The travel time is
        /// calculated from the segment length and the travel speed (see
        /// below).
        /// *  segments.SegmentType.COMBINED\_TRANSPORT. The travel time is
        /// taken from the data which does not necessarily equal the actual
        /// time the combined transport takes. In this case the travel time is
        /// always a whole number.
        /// *  segments.SegmentType.NOT\_DRIVING. The travel time is only
        /// grater 0 if there is a waiting time associated.
        ///
        /// If the segment distance is larger than 0 it is guaranteed that also
        /// the travel time is larger than 0. The travel times calculated based
        /// on travel speed are rounded to milliseconds.</param>
        /// <param name="travelSpeed">The travel speed that was used to
        /// calculate the travel time for the segment. It is always a whole
        /// number and depends on the segment type as follows.
        ///
        /// *  segments.SegmentType.NETWORK\_SEGMENT. The travel speed is
        /// determined from the road and speed classification from the data and
        /// from the current vehicle.
        /// *  segments.SegmentType.LINK\_SEGMENT. The travel speed is
        /// vehicle-dependent, the value from
        /// vehicleprofile.Speeds.speedForLinkDistance is used.
        /// *  segments.SegmentType.COMBINED\_TRANSPORT. The travel speed is
        /// always 0.
        /// *  segments.SegmentType.NOT\_DRIVING. The travel speed is always 0.
        ///
        /// Due to the rounding of travel times to milliseconds the speed that
        /// is re-calculated from segment travel time and distance can differ
        /// slightly from the travel speed returned here. For almost all
        /// segments the difference is less than 0.5km/h. Only for very small
        /// segment the difference can be higher - assuming a normal speed of
        /// at most 130km/h even for these small segments the difference does
        /// not exceed 2km/h.</param>
        /// <param name="violated">If set to true, indicates that this segment
        /// contains a violation for the chosen vehicle.</param>
        /// <param name="type">A segment may have different types, e.g. it may
        /// be a "normal" segment between two network nodes, a "link segment",
        /// or a virtual segment which represents a border crossing or a
        /// waiting time. Possible values include: 'NETWORK_SEGMENT',
        /// 'LINK_SEGMENT', 'COMBINED_TRANSPORT', 'NOT_DRIVING'</param>
        /// <param name="startNodeIndex">The index in the list of
        /// RouteResponse.nodes of the start node of the segment. It is
        /// available only if the list of nodes is requested by
        /// ResultFields.nodes.</param>
        /// <param name="endNodeIndex">The index in the list of
        /// RouteResponse.nodes of the end node of the segment. It is available
        /// only if the list of nodes is requested by
        /// ResultFields.nodes.</param>
        /// <param name="emissions">The emissions along the route.</param>
        /// <param name="polyline">The polyline of the segment. This polyline
        /// consists of all coordinates representing the segment and can be
        /// used to draw the segment into a map. Not available for segments of
        /// type SegmentType.NOT\_DRIVING.
        ///
        /// xRoute only: It contains elevations only if requested by
        /// xroute.PolylineOptions.elevations. If the elevations data do not
        /// cover the complete polyline, an
        /// xroute.ElevationsNotAvailableLimitation will be available which
        /// states which parts of the polyline are not covered.</param>
        /// <param name="attributes">A set of attributes belonging to this
        /// segment such as "is this a bridge?" or "road name". Available only
        /// for segments of type SegmentType.NETWORK\_SEGMENT.</param>
        /// <param name="combinedTransport">Attributes which describe the
        /// combined transport this segment represents. Available only for
        /// segments of type SegmentType.COMBINED\_TRANSPORT.</param>
        public Segment(double distance, double travelTime, double travelSpeed, bool violated, SegmentType type, int? startNodeIndex = default(int?), int? endNodeIndex = default(int?), Emissions emissions = default(Emissions), IList<int?> eventIndices = default(IList<int?>), EncodedGeometry polyline = default(EncodedGeometry), SegmentAttributes attributes = default(SegmentAttributes), CombinedTransportAttributes combinedTransport = default(CombinedTransportAttributes))
        {
            StartNodeIndex = startNodeIndex;
            EndNodeIndex = endNodeIndex;
            Distance = distance;
            TravelTime = travelTime;
            TravelSpeed = travelSpeed;
            Emissions = emissions;
            Violated = violated;
            EventIndices = eventIndices;
            Type = type;
            Polyline = polyline;
            Attributes = attributes;
            CombinedTransport = combinedTransport;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the index in the list of RouteResponse.nodes of the
        /// start node of the segment. It is available only if the list of
        /// nodes is requested by ResultFields.nodes.
        /// </summary>
        [JsonProperty(PropertyName = "startNodeIndex")]
        public int? StartNodeIndex { get; set; }

        /// <summary>
        /// Gets or sets the index in the list of RouteResponse.nodes of the
        /// end node of the segment. It is available only if the list of nodes
        /// is requested by ResultFields.nodes.
        /// </summary>
        [JsonProperty(PropertyName = "endNodeIndex")]
        public int? EndNodeIndex { get; set; }

        /// <summary>
        /// Gets or sets the travel distance for the segment. It is always a
        /// whole number and depends on the segment type as follows.
        ///
        /// *  segments.SegmentType.NETWORK\_SEGMENT. The distance on the
        /// network segment which is actually driven on.
        /// *  segments.SegmentType.LINK\_SEGMENT. The air-line distance
        /// between input and link node.
        /// *  segments.SegmentType.COMBINED\_TRANSPORT. The travel distance is
        /// always 0.
        /// *  segments.SegmentType.NOT\_DRIVING. The travel distance is always
        /// 0.
        /// </summary>
        [JsonProperty(PropertyName = "distance")]
        public double Distance { get; set; }

        /// <summary>
        /// Gets or sets the travel time for the segment. It has up to three
        /// decimal places and depends on the segment type as follows.
        ///
        /// *  segments.SegmentType.NETWORK\_SEGMENT. The travel time is
        /// calculated from the segment length and the travel speed (see
        /// below).
        /// *  segments.SegmentType.LINK\_SEGMENT. The travel time is
        /// calculated from the segment length and the travel speed (see
        /// below).
        /// *  segments.SegmentType.COMBINED\_TRANSPORT. The travel time is
        /// taken from the data which does not necessarily equal the actual
        /// time the combined transport takes. In this case the travel time is
        /// always a whole number.
        /// *  segments.SegmentType.NOT\_DRIVING. The travel time is only
        /// grater 0 if there is a waiting time associated.
        ///
        /// If the segment distance is larger than 0 it is guaranteed that also
        /// the travel time is larger than 0. The travel times calculated based
        /// on travel speed are rounded to milliseconds.
        /// </summary>
        [JsonProperty(PropertyName = "travelTime")]
        public double TravelTime { get; set; }

        /// <summary>
        /// Gets or sets the travel speed that was used to calculate the travel
        /// time for the segment. It is always a whole number and depends on
        /// the segment type as follows.
        ///
        /// *  segments.SegmentType.NETWORK\_SEGMENT. The travel speed is
        /// determined from the road and speed classification from the data and
        /// from the current vehicle.
        /// *  segments.SegmentType.LINK\_SEGMENT. The travel speed is
        /// vehicle-dependent, the value from
        /// vehicleprofile.Speeds.speedForLinkDistance is used.
        /// *  segments.SegmentType.COMBINED\_TRANSPORT. The travel speed is
        /// always 0.
        /// *  segments.SegmentType.NOT\_DRIVING. The travel speed is always 0.
        ///
        /// Due to the rounding of travel times to milliseconds the speed that
        /// is re-calculated from segment travel time and distance can differ
        /// slightly from the travel speed returned here. For almost all
        /// segments the difference is less than 0.5km/h. Only for very small
        /// segment the difference can be higher - assuming a normal speed of
        /// at most 130km/h even for these small segments the difference does
        /// not exceed 2km/h.
        /// </summary>
        [JsonProperty(PropertyName = "travelSpeed")]
        public double TravelSpeed { get; set; }

        /// <summary>
        /// Gets or sets the emissions along the route.
        /// </summary>
        [JsonProperty(PropertyName = "emissions")]
        public Emissions Emissions { get; set; }

        /// <summary>
        /// Gets or sets if set to true, indicates that this segment contains a
        /// violation for the chosen vehicle.
        /// </summary>
        [JsonProperty(PropertyName = "violated")]
        public bool Violated { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "eventIndices")]
        public IList<int?> EventIndices { get; set; }

        /// <summary>
        /// Gets or sets a segment may have different types, e.g. it may be a
        /// "normal" segment between two network nodes, a "link segment", or a
        /// virtual segment which represents a border crossing or a waiting
        /// time. Possible values include: 'NETWORK_SEGMENT', 'LINK_SEGMENT',
        /// 'COMBINED_TRANSPORT', 'NOT_DRIVING'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public SegmentType Type { get; set; }

        /// <summary>
        /// Gets or sets the polyline of the segment. This polyline consists of
        /// all coordinates representing the segment and can be used to draw
        /// the segment into a map. Not available for segments of type
        /// SegmentType.NOT\_DRIVING.
        ///
        /// xRoute only: It contains elevations only if requested by
        /// xroute.PolylineOptions.elevations. If the elevations data do not
        /// cover the complete polyline, an
        /// xroute.ElevationsNotAvailableLimitation will be available which
        /// states which parts of the polyline are not covered.
        /// </summary>
        [JsonProperty(PropertyName = "polyline")]
        public EncodedGeometry Polyline { get; set; }

        /// <summary>
        /// Gets or sets a set of attributes belonging to this segment such as
        /// "is this a bridge?" or "road name". Available only for segments of
        /// type SegmentType.NETWORK\_SEGMENT.
        /// </summary>
        [JsonProperty(PropertyName = "attributes")]
        public SegmentAttributes Attributes { get; set; }

        /// <summary>
        /// Gets or sets attributes which describe the combined transport this
        /// segment represents. Available only for segments of type
        /// SegmentType.COMBINED\_TRANSPORT.
        /// </summary>
        [JsonProperty(PropertyName = "combinedTransport")]
        public CombinedTransportAttributes CombinedTransport { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Polyline != null)
            {
                Polyline.Validate();
            }
            if (Attributes != null)
            {
                Attributes.Validate();
            }
            if (CombinedTransport != null)
            {
                CombinedTransport.Validate();
            }
        }
    }
}
