// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the speed values used by the routing algorithm to calculate the
    /// travel time of a road segment. All speed values given here are
    /// internally rounded to km/h.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.vehicleprofile.Speeds
    /// </summary>
    public partial class Speeds
    {
        /// <summary>
        /// Initializes a new instance of the Speeds class.
        /// </summary>
        public Speeds()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Speeds class.
        /// </summary>
        /// <param name="speedRangesByNetworkClass">Defines the speed intervals
        /// for each network class. The road segments of a network class are
        /// classified into subtypes which are automatically assigned a speed
        /// value from the interval. If speed information from a feature layer
        /// such as PTV\_SpeedPatterns or PTV\_TrafficIncidents is available
        /// for a segment it overrides the speed defined here. (1)</param>
        /// <param name="speedForLinkDistance">The notional speed for the
        /// distance from a waypoint to its link point on the road network.
        /// (1)</param>
        /// <param name="maximumSpeed">The absolute maximum speed for all road
        /// segments. The speeds calculated from the interval \[minimumSpeed,
        /// maximumSpeed\] for each network class, will be limited to this
        /// speed value. Note: an interval \[70,135\] for network class 0 with
        /// a maximum speed of 120 km/h is not equal to the interval
        /// \[70,120\]. A maximum speed of 0 is ignored. (1)</param>
        public Speeds(SpeedRangesByNetworkClass speedRangesByNetworkClass = default(SpeedRangesByNetworkClass), double? speedForLinkDistance = default(double?), double? maximumSpeed = default(double?))
        {
            SpeedRangesByNetworkClass = speedRangesByNetworkClass;
            SpeedForLinkDistance = speedForLinkDistance;
            MaximumSpeed = maximumSpeed;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the speed intervals for each network class.
        /// The road segments of a network class are classified into subtypes
        /// which are automatically assigned a speed value from the interval.
        /// If speed information from a feature layer such as
        /// PTV\_SpeedPatterns or PTV\_TrafficIncidents is available for a
        /// segment it overrides the speed defined here. (1)
        /// </summary>
        [JsonProperty(PropertyName = "speedRangesByNetworkClass")]
        public SpeedRangesByNetworkClass SpeedRangesByNetworkClass { get; set; }

        /// <summary>
        /// Gets or sets the notional speed for the distance from a waypoint to
        /// its link point on the road network. (1)
        /// </summary>
        [JsonProperty(PropertyName = "speedForLinkDistance")]
        public double? SpeedForLinkDistance { get; set; }

        /// <summary>
        /// Gets or sets the absolute maximum speed for all road segments. The
        /// speeds calculated from the interval \[minimumSpeed, maximumSpeed\]
        /// for each network class, will be limited to this speed value. Note:
        /// an interval \[70,135\] for network class 0 with a maximum speed of
        /// 120 km/h is not equal to the interval \[70,120\]. A maximum speed
        /// of 0 is ignored. (1)
        /// </summary>
        [JsonProperty(PropertyName = "maximumSpeed")]
        public double? MaximumSpeed { get; set; }

    }
}
