// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Additional parameters for TileBinary operation.
    /// </summary>
    public partial class TileBinaryParameters
    {
        /// <summary>
        /// Initializes a new instance of the TileBinaryParameters class.
        /// </summary>
        public TileBinaryParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TileBinaryParameters class.
        /// </summary>
        /// <param name="storedProfile">The name of the stored profile to use
        /// without its extension, e.g. `silkysand`. The corresponding file
        /// `silkysand.xml` must be available in the folder `conf/profiles`.
        /// Parent profiles must be located in the same folder.</param>
        /// <param name="layers">A comma-separated list of layers which will be
        /// displayed on the map. If this parameter is specified, layers
        /// enabled in the stored profile are ignored. These layers can be the
        /// base layers `labels`, `transport`, and `background`, or any of the
        /// supported Feature Layer themes such as `PTV_TruckAttributes`. If
        /// this parameter is not present, the layers defined by the stored
        /// profile are displayed. For more information see Integration of
        /// custom data and Displaying Feature Layer
        /// PTV\_TruckAttributes.</param>
        /// <param name="imageFormat">Image format of the rendered tile. This
        /// can be `PNG` or `JPG`. In case of `JPG`, the backgrounds (like
        /// oceans and forests) must be part of the image content, because they
        /// guarantee an image without any transparent pixels. This is
        /// important, because for `JPG` semi-transparent pixels would be drawn
        /// in black erroneously. Therefore a ParameterConflictException is
        /// thrown in such a case. Possible values include: 'PNG',
        /// 'JPG'</param>
        /// <param name="size">Width and height of the tile in pixels. The
        /// maximum allowed value is 8192.</param>
        /// <param name="timeConsideration">Specifies how to evaluate Feature
        /// Layer attributes which contain time restrictions. For time
        /// consideration scenario `NONE` the parameters for reference time and
        /// timespan are not evaluated. For `SNAPSHOT` and `TIME_SPAN` the
        /// reference time is required. The time span is needed for the
        /// `TIME_SPAN` scenarios. For detailed information about time
        /// consideration scenarios see time consideration. Possible values
        /// include: 'NONE', 'SNAPSHOT', 'TIME_SPAN', 'EXACT_TIME_AT_START',
        /// 'EXACT_TIME_AT_ARRIVAL', 'OPTIMISTIC'</param>
        /// <param name="referenceTime">The reference time at which Feature
        /// Layer attributes with time restrictions will be evaluated. The time
        /// format either has to conform to the notation of xs:dateTime such as
        /// 2015-12-24T12:00:00+01:00, or it has to be a datetime sequence
        /// without any delimiters nor time-zone specification such as
        /// 20151224T120000. If the time-zone offset is missing, the
        /// corresponding service tries to detect it by means of information
        /// available in the calling context. A detailed description of this
        /// behavior can be found in the technical concept time zones. It is
        /// recommended to always specify the time zone. If no reference time
        /// is set, the current UTC time is used.</param>
        /// <param name="timeSpan">The duration of time (in combination with
        /// reference time as start) at which Feature Layer attributes with
        /// time restrictions will be evaluated, defined in \[s\]. The value is
        /// rounded to whole seconds.</param>
        /// <param name="showOnlyRelevantByTime">Specifies if the map shows all
        /// attributes regardless of relevance for time consideration
        /// (default), or only the attributes which are relevant for this time
        /// consideration scenario. For further details, see Relevance of
        /// Feature Layer attributes.</param>
        /// <param name="showCopyright">If true it shows the copyright text in
        /// the lower right corner of the image. If not defined the default
        /// value is false and no copyright text is shown.</param>
        /// <param name="preferredRouteTypes">The road networks to be preferred
        /// by the routing algorithm as a comma-separated list (only if the
        /// feature layer PTV\_PreferredRoutes is enabled). The available types
        /// can be requested through the xRuntime service and are documented in
        /// the manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. If this parameter is not present, all types
        /// of PTV\_PreferredRoutes are displayed.</param>
        /// <param name="userLanguage">The language of texts such as
        /// traffic-incident descriptions which are returned for *contentType =
        /// JSON*.</param>
        /// <param name="contentSnapshotId">Specifies the content snapshot to
        /// use. If no snapshot ID is set, the most recent content is
        /// used.</param>
        /// <param name="mapLanguage">The language used for geographic names
        /// that are part of the map. The default x-ptv-DFT means that names
        /// are given in the language spoken in that country or region.</param>
        public TileBinaryParameters(string storedProfile = default(string), string layers = default(string), ImageFormat? imageFormat = default(ImageFormat?), int? size = default(int?), TimeConsiderationScenario? timeConsideration = default(TimeConsiderationScenario?), System.DateTime? referenceTime = default(System.DateTime?), double? timeSpan = default(double?), bool? showOnlyRelevantByTime = default(bool?), bool? showCopyright = default(bool?), string preferredRouteTypes = default(string), string userLanguage = default(string), string contentSnapshotId = default(string), string mapLanguage = default(string))
        {
            StoredProfile = storedProfile;
            Layers = layers;
            ImageFormat = imageFormat;
            Size = size;
            TimeConsideration = timeConsideration;
            ReferenceTime = referenceTime;
            TimeSpan = timeSpan;
            ShowOnlyRelevantByTime = showOnlyRelevantByTime;
            ShowCopyright = showCopyright;
            PreferredRouteTypes = preferredRouteTypes;
            UserLanguage = userLanguage;
            ContentSnapshotId = contentSnapshotId;
            MapLanguage = mapLanguage;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the stored profile to use without its
        /// extension, e.g. `silkysand`. The corresponding file `silkysand.xml`
        /// must be available in the folder `conf/profiles`. Parent profiles
        /// must be located in the same folder.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string StoredProfile { get; set; }

        /// <summary>
        /// Gets or sets a comma-separated list of layers which will be
        /// displayed on the map. If this parameter is specified, layers
        /// enabled in the stored profile are ignored. These layers can be the
        /// base layers `labels`, `transport`, and `background`, or any of the
        /// supported Feature Layer themes such as `PTV_TruckAttributes`. If
        /// this parameter is not present, the layers defined by the stored
        /// profile are displayed. For more information see Integration of
        /// custom data and Displaying Feature Layer PTV\_TruckAttributes.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string Layers { get; set; }

        /// <summary>
        /// Gets or sets image format of the rendered tile. This can be `PNG`
        /// or `JPG`. In case of `JPG`, the backgrounds (like oceans and
        /// forests) must be part of the image content, because they guarantee
        /// an image without any transparent pixels. This is important, because
        /// for `JPG` semi-transparent pixels would be drawn in black
        /// erroneously. Therefore a ParameterConflictException is thrown in
        /// such a case. Possible values include: 'PNG', 'JPG'
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public ImageFormat? ImageFormat { get; set; }

        /// <summary>
        /// Gets or sets width and height of the tile in pixels. The maximum
        /// allowed value is 8192.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public int? Size { get; set; }

        /// <summary>
        /// Gets or sets specifies how to evaluate Feature Layer attributes
        /// which contain time restrictions. For time consideration scenario
        /// `NONE` the parameters for reference time and timespan are not
        /// evaluated. For `SNAPSHOT` and `TIME_SPAN` the reference time is
        /// required. The time span is needed for the `TIME_SPAN` scenarios.
        /// For detailed information about time consideration scenarios see
        /// time consideration. Possible values include: 'NONE', 'SNAPSHOT',
        /// 'TIME_SPAN', 'EXACT_TIME_AT_START', 'EXACT_TIME_AT_ARRIVAL',
        /// 'OPTIMISTIC'
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public TimeConsiderationScenario? TimeConsideration { get; set; }

        /// <summary>
        /// Gets or sets the reference time at which Feature Layer attributes
        /// with time restrictions will be evaluated. The time format either
        /// has to conform to the notation of xs:dateTime such as
        /// 2015-12-24T12:00:00+01:00, or it has to be a datetime sequence
        /// without any delimiters nor time-zone specification such as
        /// 20151224T120000. If the time-zone offset is missing, the
        /// corresponding service tries to detect it by means of information
        /// available in the calling context. A detailed description of this
        /// behavior can be found in the technical concept time zones. It is
        /// recommended to always specify the time zone. If no reference time
        /// is set, the current UTC time is used.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public System.DateTime? ReferenceTime { get; set; }

        /// <summary>
        /// Gets or sets the duration of time (in combination with reference
        /// time as start) at which Feature Layer attributes with time
        /// restrictions will be evaluated, defined in \[s\]. The value is
        /// rounded to whole seconds.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public double? TimeSpan { get; set; }

        /// <summary>
        /// Gets or sets specifies if the map shows all attributes regardless
        /// of relevance for time consideration (default), or only the
        /// attributes which are relevant for this time consideration scenario.
        /// For further details, see Relevance of Feature Layer attributes.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public bool? ShowOnlyRelevantByTime { get; set; }

        /// <summary>
        /// Gets or sets if true it shows the copyright text in the lower right
        /// corner of the image. If not defined the default value is false and
        /// no copyright text is shown.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public bool? ShowCopyright { get; set; }

        /// <summary>
        /// Gets or sets the road networks to be preferred by the routing
        /// algorithm as a comma-separated list (only if the feature layer
        /// PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. If this parameter is not present, all types
        /// of PTV\_PreferredRoutes are displayed.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string PreferredRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets the language of texts such as traffic-incident
        /// descriptions which are returned for *contentType = JSON*.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string UserLanguage { get; set; }

        /// <summary>
        /// Gets or sets specifies the content snapshot to use. If no snapshot
        /// ID is set, the most recent content is used.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string ContentSnapshotId { get; set; }

        /// <summary>
        /// Gets or sets the language used for geographic names that are part
        /// of the map. The default x-ptv-DFT means that names are given in the
        /// language spoken in that country or region.
        /// </summary>
        [Newtonsoft.Json.JsonIgnore]
        public string MapLanguage { get; set; }

    }
}
