// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines how to modify the style of restricted features, e.g.
    /// time-dependent features or those not relevant by time.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.renderingprofile.TimeDependencyStyle
    /// </summary>
    public partial class TimeDependencyStyle
    {
        /// <summary>
        /// Initializes a new instance of the TimeDependencyStyle class.
        /// </summary>
        public TimeDependencyStyle()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TimeDependencyStyle class.
        /// </summary>
        /// <param name="iconsWithClock">If true, a small clock is added to the
        /// bottom right corner of every icon representing a time-dependent
        /// feature, i.e. a feature which is not valid 24/7 but only for a
        /// specific time period, e.g. at night or on Sundays. Use this in
        /// order to distinguish time-dependent from time-independent features
        /// within one Feature Layer theme.</param>
        /// <param name="strokesDashed">If true, a stroke representing a
        /// time-dependent feature is drawn dashed instead of solid. Use this
        /// in order to distinguish time-dependent from time-independent
        /// features within one Feature Layer theme.</param>
        /// <param name="irrelevantIconsGrayed">If true, the icon of a feature
        /// which is not valid for the given time-consideration scenario will
        /// be drawn in gray. E.g. when requesting time-consideration scenario
        /// 'snapshot' at 3 p.m., features valid only at night are displayed
        /// with a gray icon. Please make sure to use colored icons when using
        /// this feature. Use this to distinguish relevant features from those
        /// not relevant for the selected time-consideration scenario.</param>
        /// <param name="irrelevantStrokesGrayed">If true, the stroke of a
        /// feature which is not valid for the given time-consideration
        /// scenario will be drawn in gray. Please make sure to use colored
        /// strokes when using this feature. Use this to distinguish relevant
        /// features from those not relevant for the selected
        /// time-consideration scenario.</param>
        /// <param name="irrelevantPolygonsGrayed">If true, the polygon of a
        /// feature which is not valid for the given time-consideration
        /// scenario will be drawn in gray and hatched. Please make sure to use
        /// colored polygons when using this feature. Use this to distinguish
        /// relevant features from those not relevant for the selected
        /// time-consideration scenario.</param>
        public TimeDependencyStyle(bool? iconsWithClock = default(bool?), bool? strokesDashed = default(bool?), bool? irrelevantIconsGrayed = default(bool?), bool? irrelevantStrokesGrayed = default(bool?), bool? irrelevantPolygonsGrayed = default(bool?))
        {
            IconsWithClock = iconsWithClock;
            StrokesDashed = strokesDashed;
            IrrelevantIconsGrayed = irrelevantIconsGrayed;
            IrrelevantStrokesGrayed = irrelevantStrokesGrayed;
            IrrelevantPolygonsGrayed = irrelevantPolygonsGrayed;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets if true, a small clock is added to the bottom right
        /// corner of every icon representing a time-dependent feature, i.e. a
        /// feature which is not valid 24/7 but only for a specific time
        /// period, e.g. at night or on Sundays. Use this in order to
        /// distinguish time-dependent from time-independent features within
        /// one Feature Layer theme.
        /// </summary>
        [JsonProperty(PropertyName = "iconsWithClock")]
        public bool? IconsWithClock { get; set; }

        /// <summary>
        /// Gets or sets if true, a stroke representing a time-dependent
        /// feature is drawn dashed instead of solid. Use this in order to
        /// distinguish time-dependent from time-independent features within
        /// one Feature Layer theme.
        /// </summary>
        [JsonProperty(PropertyName = "strokesDashed")]
        public bool? StrokesDashed { get; set; }

        /// <summary>
        /// Gets or sets if true, the icon of a feature which is not valid for
        /// the given time-consideration scenario will be drawn in gray. E.g.
        /// when requesting time-consideration scenario 'snapshot' at 3 p.m.,
        /// features valid only at night are displayed with a gray icon. Please
        /// make sure to use colored icons when using this feature. Use this to
        /// distinguish relevant features from those not relevant for the
        /// selected time-consideration scenario.
        /// </summary>
        [JsonProperty(PropertyName = "irrelevantIconsGrayed")]
        public bool? IrrelevantIconsGrayed { get; set; }

        /// <summary>
        /// Gets or sets if true, the stroke of a feature which is not valid
        /// for the given time-consideration scenario will be drawn in gray.
        /// Please make sure to use colored strokes when using this feature.
        /// Use this to distinguish relevant features from those not relevant
        /// for the selected time-consideration scenario.
        /// </summary>
        [JsonProperty(PropertyName = "irrelevantStrokesGrayed")]
        public bool? IrrelevantStrokesGrayed { get; set; }

        /// <summary>
        /// Gets or sets if true, the polygon of a feature which is not valid
        /// for the given time-consideration scenario will be drawn in gray and
        /// hatched. Please make sure to use colored polygons when using this
        /// feature. Use this to distinguish relevant features from those not
        /// relevant for the selected time-consideration scenario.
        /// </summary>
        [JsonProperty(PropertyName = "irrelevantPolygonsGrayed")]
        public bool? IrrelevantPolygonsGrayed { get; set; }

    }
}
