// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    public partial class TollEvent : RouteEvent
    {
        /// <summary>
        /// Initializes a new instance of the TollEvent class.
        /// </summary>
        public TollEvent()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TollEvent class.
        /// </summary>
        /// <param name="eventType">The type of the current route event.
        /// Possible values include: 'MANEUVER_EVENT', 'TOUR_EVENT',
        /// 'TOLL_EVENT', 'WAYPOINT_EVENT', 'ROUTE_VIOLATION_EVENT',
        /// 'UTC_OFFSET_EVENT', 'COUNTRY_EVENT'</param>
        /// <param name="startsAt">The point in time at which the event starts.
        /// This field is only present if a time-consideration scenario with a
        /// reference time is given in the request. The time zone is that of
        /// the reference time. Use the UTCOffsetEvent to derive the local
        /// time.</param>
        /// <param name="coordinate">The location at which the event occurs.
        /// This coordinate is not necessarily the coordinate of the related
        /// node. The event such as a traffic incident can, for example, occur
        /// in the middle of a long segment. This coordinate is designed to
        /// draw an icon on a map to mark the event.</param>
        /// <param name="nodeIndex">The index of the node in the
        /// RouteResponse.nodes list. As every segment starts at the node with
        /// the same index, it is also equal to the segment in the
        /// RouteResponse.segments list, if present, except for the very last
        /// index. This field is only present if the list of nodes is
        /// present.</param>
        /// <param name="distanceFromStart">The distance of the route from the
        /// start up to this event.</param>
        /// <param name="travelTimeFromStart">The travel time for the route
        /// from the start up to this event.</param>
        /// <param name="sectionIndex">Index of the corresponding toll section
        /// if toll sections are requested in ResultFields.toll. Because toll
        /// sections can overlap it is not guaranteed that the display names of
        /// the toll event and the toll section match. Instead, the section
        /// indexes of a pair of ENTER and EXIT events define the range of
        /// sections between the two events.</param>
        /// <param name="displayName">The display name of the toll event. It is
        /// only populated if a name is available. For example, this name can
        /// be a toll location name defined by the toll operator.</param>
        /// <param name="accessType">The access type specifies how a toll
        /// section is accessed. Possible values include: 'ENTER', 'EXIT',
        /// 'PASS'</param>
        /// <param name="relatedEventIndex">For accessType ENTER this index
        /// points to the corresponding event with accessType EXIT and
        /// vice-versa. Not present otherwise.</param>
        public TollEvent(RouteEventType? eventType = default(RouteEventType?), System.DateTime? startsAt = default(System.DateTime?), Coordinate coordinate = default(Coordinate), int? nodeIndex = default(int?), double? distanceFromStart = default(double?), double? travelTimeFromStart = default(double?), int? sectionIndex = default(int?), string displayName = default(string), AccessType? accessType = default(AccessType?), int? relatedEventIndex = default(int?))
            : base(eventType, startsAt, coordinate, nodeIndex, distanceFromStart, travelTimeFromStart)
        {
            SectionIndex = sectionIndex;
            DisplayName = displayName;
            AccessType = accessType;
            RelatedEventIndex = relatedEventIndex;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets index of the corresponding toll section if toll
        /// sections are requested in ResultFields.toll. Because toll sections
        /// can overlap it is not guaranteed that the display names of the toll
        /// event and the toll section match. Instead, the section indexes of a
        /// pair of ENTER and EXIT events define the range of sections between
        /// the two events.
        /// </summary>
        [JsonProperty(PropertyName = "sectionIndex")]
        public int? SectionIndex { get; set; }

        /// <summary>
        /// Gets or sets the display name of the toll event. It is only
        /// populated if a name is available. For example, this name can be a
        /// toll location name defined by the toll operator.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the access type specifies how a toll section is
        /// accessed. Possible values include: 'ENTER', 'EXIT', 'PASS'
        /// </summary>
        [JsonProperty(PropertyName = "accessType")]
        public AccessType? AccessType { get; set; }

        /// <summary>
        /// Gets or sets for accessType ENTER this index points to the
        /// corresponding event with accessType EXIT and vice-versa. Not
        /// present otherwise.
        /// </summary>
        [JsonProperty(PropertyName = "relatedEventIndex")]
        public int? RelatedEventIndex { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
