// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents one single section of the route for which the toll operator
    /// has defined toll costs. Besides the toll costs further information is
    /// optionally provided such as alternative costs with different payment
    /// methods or an official distance for the section defined by the toll
    /// operator.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.TollSection
    /// </summary>
    public partial class TollSection
    {
        /// <summary>
        /// Initializes a new instance of the TollSection class.
        /// </summary>
        public TollSection()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TollSection class.
        /// </summary>
        /// <param name="cost">The toll cost of the section. The sum of all
        /// these section costs equals the costs returned in the toll
        /// summary.</param>
        /// <param name="officialDistance">The official distance defined by the
        /// toll operator. It is only populated if the toll operator provides
        /// an official distance.</param>
        /// <param name="tollRoadType">The toll road type refers to the reason
        /// why toll is charged, e.g. tunnel, bridge, or mountain pass.
        /// Possible values include: 'GENERAL', 'CITY', 'BRIDGE', 'TUNNEL',
        /// 'FERRY', 'MOUNTAIN_PASS', 'UNSPECIFIED'</param>
        /// <param name="country">The country in which the costs have to be
        /// paid.</param>
        /// <param name="tollSystemIndex">The index in the list of toll systems
        /// the toll section belongs to. The index is only populated if the
        /// toll systems are requested by TollResultFields.systems.</param>
        /// <param name="startNodeIndex">The index in the list of
        /// RouteResponse.nodes where the toll section begins. It is available
        /// only if the list of nodes is requested by
        /// ResultFields.nodes.</param>
        /// <param name="endNodeIndex">The index in the list of
        /// RouteResponse.nodes where the toll section ends. It is available
        /// only if the list of nodes is requested by
        /// ResultFields.nodes.</param>
        /// <param name="displayName">A name that characterizes the toll
        /// section. For example it can relate to the names of the road
        /// intersections, to the area in general or to the type of
        /// toll.</param>
        public TollSection(TollCost cost = default(TollCost), IList<TollCost> alternativeCosts = default(IList<TollCost>), double? officialDistance = default(double?), TollRoadType? tollRoadType = default(TollRoadType?), string country = default(string), int? tollSystemIndex = default(int?), int? startNodeIndex = default(int?), int? endNodeIndex = default(int?), string displayName = default(string))
        {
            Cost = cost;
            AlternativeCosts = alternativeCosts;
            OfficialDistance = officialDistance;
            TollRoadType = tollRoadType;
            Country = country;
            TollSystemIndex = tollSystemIndex;
            StartNodeIndex = startNodeIndex;
            EndNodeIndex = endNodeIndex;
            DisplayName = displayName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the toll cost of the section. The sum of all these
        /// section costs equals the costs returned in the toll summary.
        /// </summary>
        [JsonProperty(PropertyName = "cost")]
        public TollCost Cost { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "alternativeCosts")]
        public IList<TollCost> AlternativeCosts { get; set; }

        /// <summary>
        /// Gets or sets the official distance defined by the toll operator. It
        /// is only populated if the toll operator provides an official
        /// distance.
        /// </summary>
        [JsonProperty(PropertyName = "officialDistance")]
        public double? OfficialDistance { get; set; }

        /// <summary>
        /// Gets or sets the toll road type refers to the reason why toll is
        /// charged, e.g. tunnel, bridge, or mountain pass. Possible values
        /// include: 'GENERAL', 'CITY', 'BRIDGE', 'TUNNEL', 'FERRY',
        /// 'MOUNTAIN_PASS', 'UNSPECIFIED'
        /// </summary>
        [JsonProperty(PropertyName = "tollRoadType")]
        public TollRoadType? TollRoadType { get; set; }

        /// <summary>
        /// Gets or sets the country in which the costs have to be paid.
        /// </summary>
        [JsonProperty(PropertyName = "country")]
        public string Country { get; set; }

        /// <summary>
        /// Gets or sets the index in the list of toll systems the toll section
        /// belongs to. The index is only populated if the toll systems are
        /// requested by TollResultFields.systems.
        /// </summary>
        [JsonProperty(PropertyName = "tollSystemIndex")]
        public int? TollSystemIndex { get; set; }

        /// <summary>
        /// Gets or sets the index in the list of RouteResponse.nodes where the
        /// toll section begins. It is available only if the list of nodes is
        /// requested by ResultFields.nodes.
        /// </summary>
        [JsonProperty(PropertyName = "startNodeIndex")]
        public int? StartNodeIndex { get; set; }

        /// <summary>
        /// Gets or sets the index in the list of RouteResponse.nodes where the
        /// toll section ends. It is available only if the list of nodes is
        /// requested by ResultFields.nodes.
        /// </summary>
        [JsonProperty(PropertyName = "endNodeIndex")]
        public int? EndNodeIndex { get; set; }

        /// <summary>
        /// Gets or sets a name that characterizes the toll section. For
        /// example it can relate to the names of the road intersections, to
        /// the area in general or to the type of toll.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Cost != null)
            {
                Cost.Validate();
            }
            if (AlternativeCosts != null)
            {
                foreach (var element in AlternativeCosts)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
