// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// As an operation schedule for a single vehicle, a tour provides the
    /// information which tasks are carried out in which order by the specified
    /// vehicle respectively its driver. There is at most one tour per vehicle.
    /// A tour contains a sequence of trips. See Tours and Trips.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.Tour
    /// </summary>
    public partial class Tour
    {
        /// <summary>
        /// Initializes a new instance of the Tour class.
        /// </summary>
        public Tour()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Tour class.
        /// </summary>
        /// <param name="vehicleId">The reference to the specific vehicle that
        /// is used to conduct this tour.</param>
        /// <param name="vehicleStartLocationId">ID of this tour's vehicle's
        /// start location. This is always identical to the start location ID
        /// of the vehicle that is used to conduct this tour.</param>
        /// <param name="vehicleEndLocationId">ID of this tour's vehicle's end
        /// location. This is always identical to the end location ID of the
        /// vehicle that is used to conduct this tour.</param>
        public Tour(string vehicleId, string vehicleStartLocationId = default(string), string vehicleEndLocationId = default(string), IList<Trip> trips = default(IList<Trip>))
        {
            VehicleId = vehicleId;
            VehicleStartLocationId = vehicleStartLocationId;
            VehicleEndLocationId = vehicleEndLocationId;
            Trips = trips;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the reference to the specific vehicle that is used to
        /// conduct this tour.
        /// </summary>
        [JsonProperty(PropertyName = "vehicleId")]
        public string VehicleId { get; set; }

        /// <summary>
        /// Gets or sets ID of this tour's vehicle's start location. This is
        /// always identical to the start location ID of the vehicle that is
        /// used to conduct this tour.
        /// </summary>
        [JsonProperty(PropertyName = "vehicleStartLocationId")]
        public string VehicleStartLocationId { get; set; }

        /// <summary>
        /// Gets or sets ID of this tour's vehicle's end location. This is
        /// always identical to the end location ID of the vehicle that is used
        /// to conduct this tour.
        /// </summary>
        [JsonProperty(PropertyName = "vehicleEndLocationId")]
        public string VehicleEndLocationId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "trips")]
        public IList<Trip> Trips { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VehicleId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VehicleId");
            }
            if (Trips != null)
            {
                foreach (var element in Trips)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
