// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Different kinds of events that can happen during execution of a tour.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.TourEvent
    /// </summary>
    public partial class TourEvent
    {
        /// <summary>
        /// Initializes a new instance of the TourEvent class.
        /// </summary>
        public TourEvent()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TourEvent class.
        /// </summary>
        /// <param name="startTime">Start time of the event. The time zone is
        /// that of the planning horizon (if a planning horizon is defined) or
        /// that of a given location.</param>
        /// <param name="duration">Duration of this event.</param>
        /// <param name="tripId">ID of the trip this event is referring to, for
        /// example for a TRIP\_START event. Not set for events that do not
        /// belong to a specific trip such as DRIVING events between depot
        /// sites of adjacent trips.</param>
        /// <param name="locationId">ID of the location where the vehicle is
        /// stopped during this event. Not set for events that do not belong to
        /// a specific site such as DRIVING events or BREAK events that take
        /// place en route between two stops.</param>
        /// <param name="orderId">ID of the order that is currently carried if
        /// the event is a SERVICE event. Not set for other event
        /// types.</param>
        public TourEvent(System.DateTime startTime, double duration, string tripId = default(string), string locationId = default(string), string orderId = default(string), IList<TourEventType?> eventTypes = default(IList<TourEventType?>), IList<TourViolation> tourViolations = default(IList<TourViolation>))
        {
            StartTime = startTime;
            TripId = tripId;
            LocationId = locationId;
            OrderId = orderId;
            EventTypes = eventTypes;
            TourViolations = tourViolations;
            Duration = duration;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets start time of the event. The time zone is that of the
        /// planning horizon (if a planning horizon is defined) or that of a
        /// given location.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime StartTime { get; set; }

        /// <summary>
        /// Gets or sets ID of the trip this event is referring to, for example
        /// for a TRIP\_START event. Not set for events that do not belong to a
        /// specific trip such as DRIVING events between depot sites of
        /// adjacent trips.
        /// </summary>
        [JsonProperty(PropertyName = "tripId")]
        public string TripId { get; set; }

        /// <summary>
        /// Gets or sets ID of the location where the vehicle is stopped during
        /// this event. Not set for events that do not belong to a specific
        /// site such as DRIVING events or BREAK events that take place en
        /// route between two stops.
        /// </summary>
        [JsonProperty(PropertyName = "locationId")]
        public string LocationId { get; set; }

        /// <summary>
        /// Gets or sets ID of the order that is currently carried if the event
        /// is a SERVICE event. Not set for other event types.
        /// </summary>
        [JsonProperty(PropertyName = "orderId")]
        public string OrderId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "eventTypes")]
        public IList<TourEventType?> EventTypes { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tourViolations")]
        public IList<TourViolation> TourViolations { get; set; }

        /// <summary>
        /// Gets or sets duration of this event.
        /// </summary>
        [JsonProperty(PropertyName = "duration")]
        public double Duration { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
