// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// More detailed information about a tour, containing reports for each
    /// trip, an accumulated cost report and a list of events that occur along
    /// the tour.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.TourReport
    /// </summary>
    public partial class TourReport
    {
        /// <summary>
        /// Initializes a new instance of the TourReport class.
        /// </summary>
        public TourReport()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TourReport class.
        /// </summary>
        /// <param name="vehicleId">ID of vehicle of this tour.</param>
        /// <param name="costReport">Cost related values for this tour.</param>
        /// <param name="violationReport">Summary for tour violations of this
        /// tour.</param>
        public TourReport(string vehicleId, CostReport costReport, TourViolationReport violationReport = default(TourViolationReport), IList<TripReport> tripReports = default(IList<TripReport>), IList<TourEvent> tourEvents = default(IList<TourEvent>), IList<LegReport> legReports = default(IList<LegReport>))
        {
            VehicleId = vehicleId;
            CostReport = costReport;
            ViolationReport = violationReport;
            TripReports = tripReports;
            TourEvents = tourEvents;
            LegReports = legReports;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of vehicle of this tour.
        /// </summary>
        [JsonProperty(PropertyName = "vehicleId")]
        public string VehicleId { get; set; }

        /// <summary>
        /// Gets or sets cost related values for this tour.
        /// </summary>
        [JsonProperty(PropertyName = "costReport")]
        public CostReport CostReport { get; set; }

        /// <summary>
        /// Gets or sets summary for tour violations of this tour.
        /// </summary>
        [JsonProperty(PropertyName = "violationReport")]
        public TourViolationReport ViolationReport { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tripReports")]
        public IList<TripReport> TripReports { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tourEvents")]
        public IList<TourEvent> TourEvents { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "legReports")]
        public IList<LegReport> LegReports { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VehicleId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VehicleId");
            }
            if (CostReport == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CostReport");
            }
            if (CostReport != null)
            {
                CostReport.Validate();
            }
            if (TripReports != null)
            {
                foreach (var element in TripReports)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (TourEvents != null)
            {
                foreach (var element1 in TourEvents)
                {
                    if (element1 != null)
                    {
                        element1.Validate();
                    }
                }
            }
        }
    }
}
