// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Restrictions that can be set for a tour.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.TourRestrictions
    /// </summary>
    public partial class TourRestrictions
    {
        /// <summary>
        /// Initializes a new instance of the TourRestrictions class.
        /// </summary>
        public TourRestrictions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TourRestrictions class.
        /// </summary>
        /// <param name="singleTripPerTour">Restricts the number of trips for
        /// each tour to one. See Tours and Trips.</param>
        /// <param name="singleDepotPerTour">Restricts the number of depots of
        /// a tour to at most one. That means a tour without depots is also
        /// valid if this parameter is set to true. See Tours and
        /// Trips.</param>
        /// <param name="maximumTravelTimePerTour">Restricts the maximum
        /// allowed total travel time per tour in seconds. The travel time
        /// contains all waiting, service and driving times. Drivers' working
        /// hours may be more restrictive and enforce a lower limit. Is
        /// infinite if it is not set.</param>
        /// <param name="maximumDrivingTimePerTour">Restricts the maximum
        /// allowed total driving time per tour in seconds. Drivers' working
        /// hours may be more restrictive and enforce a lower limit. Is
        /// infinite if it is not set. Not supported for time dependent driving
        /// times.</param>
        /// <param name="workingHours">Defines the rules regarding drivers'
        /// working hours. Drivers' working hours are only active if this
        /// member is set.</param>
        public TourRestrictions(bool? singleTripPerTour = default(bool?), bool? singleDepotPerTour = default(bool?), double? maximumTravelTimePerTour = default(double?), double? maximumDrivingTimePerTour = default(double?), WorkingHours workingHours = default(WorkingHours))
        {
            SingleTripPerTour = singleTripPerTour;
            SingleDepotPerTour = singleDepotPerTour;
            MaximumTravelTimePerTour = maximumTravelTimePerTour;
            MaximumDrivingTimePerTour = maximumDrivingTimePerTour;
            WorkingHours = workingHours;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets restricts the number of trips for each tour to one.
        /// See Tours and Trips.
        /// </summary>
        [JsonProperty(PropertyName = "singleTripPerTour")]
        public bool? SingleTripPerTour { get; set; }

        /// <summary>
        /// Gets or sets restricts the number of depots of a tour to at most
        /// one. That means a tour without depots is also valid if this
        /// parameter is set to true. See Tours and Trips.
        /// </summary>
        [JsonProperty(PropertyName = "singleDepotPerTour")]
        public bool? SingleDepotPerTour { get; set; }

        /// <summary>
        /// Gets or sets restricts the maximum allowed total travel time per
        /// tour in seconds. The travel time contains all waiting, service and
        /// driving times. Drivers' working hours may be more restrictive and
        /// enforce a lower limit. Is infinite if it is not set.
        /// </summary>
        [JsonProperty(PropertyName = "maximumTravelTimePerTour")]
        public double? MaximumTravelTimePerTour { get; set; }

        /// <summary>
        /// Gets or sets restricts the maximum allowed total driving time per
        /// tour in seconds. Drivers' working hours may be more restrictive and
        /// enforce a lower limit. Is infinite if it is not set. Not supported
        /// for time dependent driving times.
        /// </summary>
        [JsonProperty(PropertyName = "maximumDrivingTimePerTour")]
        public double? MaximumDrivingTimePerTour { get; set; }

        /// <summary>
        /// Gets or sets defines the rules regarding drivers' working hours.
        /// Drivers' working hours are only active if this member is set.
        /// </summary>
        [JsonProperty(PropertyName = "workingHours")]
        public WorkingHours WorkingHours { get; set; }

    }
}
