// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class TourViolationReport : ViolationReport
    {
        /// <summary>
        /// Initializes a new instance of the TourViolationReport class.
        /// </summary>
        public TourViolationReport()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TourViolationReport class.
        /// </summary>
        /// <param name="maximumOpeningIntervalExceedance">The longest opening
        /// interval exceedance. Corresponds to tour events with violation type
        /// OPENING\_INTERVAL.</param>
        /// <param name="restPositionViolated">Indicates if any daily rest is
        /// scheduled at an unexpected position according to possible rest
        /// positions that can for example be defined by multi day drivers'
        /// working hours.</param>
        /// <param name="planningHorizonExceedance">The duration by which the
        /// start or the end of the planning horizon is exceeded. Corresponds
        /// to tour events with violation type PLANNING\_HORIZON.</param>
        /// <param name="operatingIntervalExceedance">The duration by which the
        /// end of the driver operating intervals is exceeded. Corresponds to
        /// tour events with violation type OPERATING\_INTERVAL.</param>
        /// <param name="maximumDrivingTimePerTourExceedance">The duration by
        /// which the specified maximum driving time per tour is exceeded.
        /// (either specified by an explicit value or by the drivers' working
        /// hours restriction). Corresponds to tour events with violation type
        /// MAXIMUM\_DRIVING\_TIME\_PER\_TOUR.</param>
        /// <param name="maximumTravelTimePerTourExceedance">The duration by
        /// which the the specified maximum travel time per tour is exceeded.
        /// (either specified by an explicit value or by the drivers' working
        /// hours restriction). Corresponds to tour events with violation type
        /// MAXIMUM\_TRAVEL\_TIME\_PER\_TOUR.</param>
        public TourViolationReport(double? maximumOpeningIntervalExceedance = default(double?), IList<double?> maximumQuantityScenarioExceedance = default(IList<double?>), IList<string> vehicleEquipmentViolations = default(IList<string>), bool? restPositionViolated = default(bool?), double? planningHorizonExceedance = default(double?), double? operatingIntervalExceedance = default(double?), double? maximumDrivingTimePerTourExceedance = default(double?), double? maximumTravelTimePerTourExceedance = default(double?))
            : base(maximumOpeningIntervalExceedance, maximumQuantityScenarioExceedance, vehicleEquipmentViolations, restPositionViolated)
        {
            PlanningHorizonExceedance = planningHorizonExceedance;
            OperatingIntervalExceedance = operatingIntervalExceedance;
            MaximumDrivingTimePerTourExceedance = maximumDrivingTimePerTourExceedance;
            MaximumTravelTimePerTourExceedance = maximumTravelTimePerTourExceedance;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the duration by which the start or the end of the
        /// planning horizon is exceeded. Corresponds to tour events with
        /// violation type PLANNING\_HORIZON.
        /// </summary>
        [JsonProperty(PropertyName = "planningHorizonExceedance")]
        public double? PlanningHorizonExceedance { get; set; }

        /// <summary>
        /// Gets or sets the duration by which the end of the driver operating
        /// intervals is exceeded. Corresponds to tour events with violation
        /// type OPERATING\_INTERVAL.
        /// </summary>
        [JsonProperty(PropertyName = "operatingIntervalExceedance")]
        public double? OperatingIntervalExceedance { get; set; }

        /// <summary>
        /// Gets or sets the duration by which the specified maximum driving
        /// time per tour is exceeded. (either specified by an explicit value
        /// or by the drivers' working hours restriction). Corresponds to tour
        /// events with violation type MAXIMUM\_DRIVING\_TIME\_PER\_TOUR.
        /// </summary>
        [JsonProperty(PropertyName = "maximumDrivingTimePerTourExceedance")]
        public double? MaximumDrivingTimePerTourExceedance { get; set; }

        /// <summary>
        /// Gets or sets the duration by which the the specified maximum travel
        /// time per tour is exceeded. (either specified by an explicit value
        /// or by the drivers' working hours restriction). Corresponds to tour
        /// events with violation type MAXIMUM\_TRAVEL\_TIME\_PER\_TOUR.
        /// </summary>
        [JsonProperty(PropertyName = "maximumTravelTimePerTourExceedance")]
        public double? MaximumTravelTimePerTourExceedance { get; set; }

    }
}
