// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class TransportOrder : Order
    {
        /// <summary>
        /// Initializes a new instance of the TransportOrder class.
        /// </summary>
        public TransportOrder()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TransportOrder class.
        /// </summary>
        /// <param name="id">An unique ID used to identify the order.</param>
        /// <param name="groupId">The unique identifier of an order group. The
        /// preferences that apply to orders with the same group ID are
        /// specified in the order group consideration. Order groups may be
        /// referenced in the order group IDs of a vehicle.</param>
        /// <param name="serviceTimeForPickup">Overall service time at the site
        /// required to pick up the order. Additionally there may be a site
        /// dependent or vehicle dependent service time of the stop. See
        /// Service time calculation.</param>
        /// <param name="serviceTimeForDelivery">Overall service time at the
        /// site required to deliver the order. Additionally there may be a
        /// site dependent or vehicle dependent service time of the stop. See
        /// Service time calculation.</param>
        public TransportOrder(string id, string groupId = default(string), IList<string> requiredVehicleEquipment = default(IList<string>), IList<double?> quantities = default(IList<double?>), double? serviceTimeForPickup = default(double?), double? serviceTimeForDelivery = default(double?))
            : base(id, groupId, requiredVehicleEquipment)
        {
            Quantities = quantities;
            ServiceTimeForPickup = serviceTimeForPickup;
            ServiceTimeForDelivery = serviceTimeForDelivery;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "quantities")]
        public IList<double?> Quantities { get; set; }

        /// <summary>
        /// Gets or sets overall service time at the site required to pick up
        /// the order. Additionally there may be a site dependent or vehicle
        /// dependent service time of the stop. See Service time calculation.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTimeForPickup")]
        public double? ServiceTimeForPickup { get; set; }

        /// <summary>
        /// Gets or sets overall service time at the site required to deliver
        /// the order. Additionally there may be a site dependent or vehicle
        /// dependent service time of the stop. See Service time calculation.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTimeForDelivery")]
        public double? ServiceTimeForDelivery { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
