// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An operation schedule for a single trip. A trip contains the sequence
    /// of stops that are served. At the beginning and end of each trip the
    /// vehicle does not carry any load. A trip starts at the vehicle start
    /// location or at a depot, and ends at the vehicle end location or at a
    /// depot. See Tours and Trips.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.Trip
    /// </summary>
    public partial class Trip
    {
        /// <summary>
        /// Initializes a new instance of the Trip class.
        /// </summary>
        public Trip()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Trip class.
        /// </summary>
        /// <param name="id">The reference ID of this trip. Response trips that
        /// are identical to input plan trips in stops and stop sequence have
        /// the same trip ID as the corresponding input plan trip. The ID also
        /// stays the same if the trip's position within its tour changes or if
        /// its vehicle changes. Response trips that are changed input plan
        /// trips or newly generated as result of a PlanToursRequest get a
        /// newly generated ID. Trip changes caused by a ChangeToursRequest do
        /// not change the trip ID.</param>
        public Trip(string id, IList<TripStop> stops = default(IList<TripStop>))
        {
            Id = id;
            Stops = stops;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the reference ID of this trip. Response trips that are
        /// identical to input plan trips in stops and stop sequence have the
        /// same trip ID as the corresponding input plan trip. The ID also
        /// stays the same if the trip's position within its tour changes or if
        /// its vehicle changes. Response trips that are changed input plan
        /// trips or newly generated as result of a PlanToursRequest get a
        /// newly generated ID. Trip changes caused by a ChangeToursRequest do
        /// not change the trip ID.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "stops")]
        public IList<TripStop> Stops { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (Stops != null)
            {
                foreach (var element in Stops)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
