// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class TripDepotStructureFault : TripStructureFault
    {
        /// <summary>
        /// Initializes a new instance of the TripDepotStructureFault class.
        /// </summary>
        public TripDepotStructureFault()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TripDepotStructureFault class.
        /// </summary>
        /// <param name="vehicleId">ID of the vehicle serving the input tour
        /// with invalid structure in case of a PlanToursRequest. In case of a
        /// ChangeToursRequest this parameter contains the ID of the vehicle
        /// that would serve a tour with invalid structure.</param>
        /// <param name="tripId">ID of the input trip with invalid structure in
        /// case of a PlanToursRequest. In case of a ChangeToursRequest this
        /// parameter contains the ID of the trip that would have an invalid
        /// structure.</param>
        /// <param name="orderId">ID of the order that violates the trip depot
        /// structure.</param>
        /// <param name="taskType">Task type of the task that violates the trip
        /// depot structure. Possible values include: 'PICKUP', 'DELIVERY',
        /// 'VISIT'</param>
        /// <param name="hint">A free-text hint what to do to fix the
        /// problem.</param>
        public TripDepotStructureFault(string vehicleId, string tripId, string orderId, TaskType taskType, string hint = default(string))
            : base(vehicleId, tripId, hint)
        {
            OrderId = orderId;
            TaskType = taskType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the order that violates the trip depot
        /// structure.
        /// </summary>
        [JsonProperty(PropertyName = "orderId")]
        public string OrderId { get; set; }

        /// <summary>
        /// Gets or sets task type of the task that violates the trip depot
        /// structure. Possible values include: 'PICKUP', 'DELIVERY', 'VISIT'
        /// </summary>
        [JsonProperty(PropertyName = "taskType")]
        public TaskType TaskType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (OrderId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OrderId");
            }
        }
    }
}
