// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// More detailed information about a trip, containing an accumulated cost
    /// report.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.TripReport
    /// </summary>
    public partial class TripReport
    {
        /// <summary>
        /// Initializes a new instance of the TripReport class.
        /// </summary>
        public TripReport()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TripReport class.
        /// </summary>
        /// <param name="tripId">ID of the corresponding trip to this
        /// report.</param>
        /// <param name="costReport">Cost related values for this trip.</param>
        /// <param name="violationReport">Summary for tour violations of this
        /// trip.</param>
        /// <param name="orderGroupId">If there is at least one order with a
        /// groupId in the trip, the orderGroupId of a tripReport is the
        /// groupId that occurs most often among the orders of this trip. If no
        /// order of this trip has a groupId then this field is not set. If a
        /// planToursRequest has a trip in the input plan with different
        /// groupIds among the orders, first the orderGroupId of the trip is
        /// determined and then only orders of the same groupId are inserted in
        /// this trip during automatic planning. A changeToursRequest can
        /// change the orderGroupId of a trip for example by removing orders
        /// from the trip. All changeToursActions are performed even if options
        /// of the orderGroupConsideration are not fulfilled or if the
        /// orderGroupId does not match with any of the orderGroupIds of the
        /// target vehicle. For further information please have a look at the
        /// technical concept Order Groups.</param>
        public TripReport(string tripId, CostReport costReport, TripViolationReport violationReport = default(TripViolationReport), string orderGroupId = default(string))
        {
            TripId = tripId;
            CostReport = costReport;
            ViolationReport = violationReport;
            OrderGroupId = orderGroupId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the corresponding trip to this report.
        /// </summary>
        [JsonProperty(PropertyName = "tripId")]
        public string TripId { get; set; }

        /// <summary>
        /// Gets or sets cost related values for this trip.
        /// </summary>
        [JsonProperty(PropertyName = "costReport")]
        public CostReport CostReport { get; set; }

        /// <summary>
        /// Gets or sets summary for tour violations of this trip.
        /// </summary>
        [JsonProperty(PropertyName = "violationReport")]
        public TripViolationReport ViolationReport { get; set; }

        /// <summary>
        /// Gets or sets if there is at least one order with a groupId in the
        /// trip, the orderGroupId of a tripReport is the groupId that occurs
        /// most often among the orders of this trip. If no order of this trip
        /// has a groupId then this field is not set. If a planToursRequest has
        /// a trip in the input plan with different groupIds among the orders,
        /// first the orderGroupId of the trip is determined and then only
        /// orders of the same groupId are inserted in this trip during
        /// automatic planning. A changeToursRequest can change the
        /// orderGroupId of a trip for example by removing orders from the
        /// trip. All changeToursActions are performed even if options of the
        /// orderGroupConsideration are not fulfilled or if the orderGroupId
        /// does not match with any of the orderGroupIds of the target vehicle.
        /// For further information please have a look at the technical concept
        /// Order Groups.
        /// </summary>
        [JsonProperty(PropertyName = "orderGroupId")]
        public string OrderGroupId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (TripId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TripId");
            }
            if (CostReport == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CostReport");
            }
            if (CostReport != null)
            {
                CostReport.Validate();
            }
        }
    }
}
