// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A stop groups subsequent tasks of a tour that are carried out at the
    /// same site. If there is more than one task at the same customer site,
    /// tasks are grouped to one stop and scheduled in order of their type:
    /// DELIVERY tasks before VISIT tasks before PICKUP tasks. If there is more
    /// than one task at the same depot site, all DELIVERY tasks are grouped to
    /// one stop and all PICKUP tasks are grouped to another one. See Orders,
    /// Locations, and Stops.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.Stop
    /// </summary>
    public partial class TripStop
    {
        /// <summary>
        /// Initializes a new instance of the TripStop class.
        /// </summary>
        public TripStop()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TripStop class.
        /// </summary>
        /// <param name="locationId">The reference to the location of the site
        /// where the stop is served. This location is either a customer site
        /// or a depot site.</param>
        /// <param name="customerId">ID corresponding to the customerId of a
        /// customer site. This parameter needs to be set if the locationId of
        /// the stop belongs to a customer site with defined customer ID. Else,
        /// the parameter must not be set.</param>
        public TripStop(string locationId, string customerId = default(string), IList<OrderTask> tasks = default(IList<OrderTask>))
        {
            LocationId = locationId;
            CustomerId = customerId;
            Tasks = tasks;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the reference to the location of the site where the
        /// stop is served. This location is either a customer site or a depot
        /// site.
        /// </summary>
        [JsonProperty(PropertyName = "locationId")]
        public string LocationId { get; set; }

        /// <summary>
        /// Gets or sets ID corresponding to the customerId of a customer site.
        /// This parameter needs to be set if the locationId of the stop
        /// belongs to a customer site with defined customer ID. Else, the
        /// parameter must not be set.
        /// </summary>
        [JsonProperty(PropertyName = "customerId")]
        public string CustomerId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "tasks")]
        public IList<OrderTask> Tasks { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (LocationId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LocationId");
            }
            if (Tasks != null)
            {
                foreach (var element in Tasks)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
