// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class TripsMergedFault : TourStructureFault
    {
        /// <summary>
        /// Initializes a new instance of the TripsMergedFault class.
        /// </summary>
        public TripsMergedFault()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TripsMergedFault class.
        /// </summary>
        /// <param name="vehicleId">ID of the vehicle that would serve a tour
        /// with invalid structure.</param>
        /// <param name="tripIdA">ID of the trip that would be merged with the
        /// trip corresponding to tripIdB.</param>
        /// <param name="tripIdB">ID of the trip that would be merged with the
        /// trip corresponding to tripIdA.</param>
        /// <param name="objectId">ID of the object in the ChangeToursAction
        /// that would cause the merge of two trips. In case of a move trips
        /// action it will be a tripId, in case of a move orders action it will
        /// be a orderId, in case of a remove orders action it will be a
        /// orderId, in case of a remove trips action it will be a tripId in
        /// case of a move stops action it will be a position of the stop
        /// within the trip (either the position of the stop itself or of the
        /// stop containing the corresponding "partner" task).</param>
        /// <param name="hint">A free-text hint what to do to fix the
        /// problem.</param>
        public TripsMergedFault(string vehicleId, string tripIdA, string tripIdB, string objectId, string hint = default(string))
            : base(hint)
        {
            VehicleId = vehicleId;
            TripIdA = tripIdA;
            TripIdB = tripIdB;
            ObjectId = objectId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID of the vehicle that would serve a tour with invalid
        /// structure.
        /// </summary>
        [JsonProperty(PropertyName = "vehicleId")]
        public string VehicleId { get; set; }

        /// <summary>
        /// Gets or sets ID of the trip that would be merged with the trip
        /// corresponding to tripIdB.
        /// </summary>
        [JsonProperty(PropertyName = "tripIdA")]
        public string TripIdA { get; set; }

        /// <summary>
        /// Gets or sets ID of the trip that would be merged with the trip
        /// corresponding to tripIdA.
        /// </summary>
        [JsonProperty(PropertyName = "tripIdB")]
        public string TripIdB { get; set; }

        /// <summary>
        /// Gets or sets ID of the object in the ChangeToursAction that would
        /// cause the merge of two trips. In case of a move trips action it
        /// will be a tripId, in case of a move orders action it will be a
        /// orderId, in case of a remove orders action it will be a orderId, in
        /// case of a remove trips action it will be a tripId in case of a move
        /// stops action it will be a position of the stop within the trip
        /// (either the position of the stop itself or of the stop containing
        /// the corresponding "partner" task).
        /// </summary>
        [JsonProperty(PropertyName = "objectId")]
        public string ObjectId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VehicleId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VehicleId");
            }
            if (TripIdA == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TripIdA");
            }
            if (TripIdB == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TripIdB");
            }
            if (ObjectId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ObjectId");
            }
        }
    }
}
