// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A vehicle that is used to transport goods or perform visits. In
    /// transport use cases, vehicles are mostly trucks, for customer visits,
    /// also cars may be used. Several IDs can be specified to simplify the use
    /// of multiple vehicles that are of the same type.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xtour.Vehicle
    /// </summary>
    public partial class Vehicle
    {
        /// <summary>
        /// Initializes a new instance of the Vehicle class.
        /// </summary>
        public Vehicle()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Vehicle class.
        /// </summary>
        /// <param name="distanceMatrixId">Distance matrix of this vehicle if
        /// distance mode ExistingDistanceMatrixPerVehicle is specified. Empty
        /// otherwise. If not, an exception is thrown. The distance matrix is
        /// specified by its ID, which can be retrieved in the distance matrix
        /// summary of the corresponding DistanceMatrixResponse. The ID is
        /// considered case sensitively. The distance matrix has to contain
        /// every location that is necessary for the tour planning, otherwise
        /// an exception is thrown.</param>
        /// <param name="startLocationId">ID of the vehicle's start location.
        /// May be a vehicle location or a site. Opening intervals and service
        /// times are not considered for a vehicle's start location. If no
        /// start location is specified, it is assumed that the vehicle is
        /// available at the first stop.</param>
        /// <param name="endLocationId">ID of the vehicle's end location. May
        /// be a vehicle location or a site. Opening intervals and service
        /// times are not considered for a vehicle's end location. If no end
        /// location is specified, it is assumed that the vehicle remains at
        /// the last stop.</param>
        /// <param name="serviceTimeFactorForOrders">A factor that is
        /// multiplied with the service times of all orders' tasks carried out
        /// by this vehicle, for example if loading/unloading is more or less
        /// complicated than for other vehicles. A factor less than one means
        /// that the vehicle speeds up the service, a factor greater than one
        /// means that it slows the service down. See Service time
        /// calculation.</param>
        /// <param name="serviceTimePerStop">Vehicle dependent service time,
        /// for example for maneuvering. This service time will be considered
        /// for each stop served by this vehicle. Additionally there may be a
        /// site dependent or order dependent service time of the stop. See
        /// Service time calculation.</param>
        public Vehicle(IList<string> ids = default(IList<string>), IList<MaximumQuantityScenario> maximumQuantityScenarios = default(IList<MaximumQuantityScenario>), string distanceMatrixId = default(string), string startLocationId = default(string), string endLocationId = default(string), double? serviceTimeFactorForOrders = default(double?), double? serviceTimePerStop = default(double?), IList<string> equipment = default(IList<string>), IList<string> orderGroupIds = default(IList<string>))
        {
            Ids = ids;
            MaximumQuantityScenarios = maximumQuantityScenarios;
            DistanceMatrixId = distanceMatrixId;
            StartLocationId = startLocationId;
            EndLocationId = endLocationId;
            ServiceTimeFactorForOrders = serviceTimeFactorForOrders;
            ServiceTimePerStop = serviceTimePerStop;
            Equipment = equipment;
            OrderGroupIds = orderGroupIds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "ids")]
        public IList<string> Ids { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "maximumQuantityScenarios")]
        public IList<MaximumQuantityScenario> MaximumQuantityScenarios { get; set; }

        /// <summary>
        /// Gets or sets distance matrix of this vehicle if distance mode
        /// ExistingDistanceMatrixPerVehicle is specified. Empty otherwise. If
        /// not, an exception is thrown. The distance matrix is specified by
        /// its ID, which can be retrieved in the distance matrix summary of
        /// the corresponding DistanceMatrixResponse. The ID is considered case
        /// sensitively. The distance matrix has to contain every location that
        /// is necessary for the tour planning, otherwise an exception is
        /// thrown.
        /// </summary>
        [JsonProperty(PropertyName = "distanceMatrixId")]
        public string DistanceMatrixId { get; set; }

        /// <summary>
        /// Gets or sets ID of the vehicle's start location. May be a vehicle
        /// location or a site. Opening intervals and service times are not
        /// considered for a vehicle's start location. If no start location is
        /// specified, it is assumed that the vehicle is available at the first
        /// stop.
        /// </summary>
        [JsonProperty(PropertyName = "startLocationId")]
        public string StartLocationId { get; set; }

        /// <summary>
        /// Gets or sets ID of the vehicle's end location. May be a vehicle
        /// location or a site. Opening intervals and service times are not
        /// considered for a vehicle's end location. If no end location is
        /// specified, it is assumed that the vehicle remains at the last stop.
        /// </summary>
        [JsonProperty(PropertyName = "endLocationId")]
        public string EndLocationId { get; set; }

        /// <summary>
        /// Gets or sets a factor that is multiplied with the service times of
        /// all orders' tasks carried out by this vehicle, for example if
        /// loading/unloading is more or less complicated than for other
        /// vehicles. A factor less than one means that the vehicle speeds up
        /// the service, a factor greater than one means that it slows the
        /// service down. See Service time calculation.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTimeFactorForOrders")]
        public double? ServiceTimeFactorForOrders { get; set; }

        /// <summary>
        /// Gets or sets vehicle dependent service time, for example for
        /// maneuvering. This service time will be considered for each stop
        /// served by this vehicle. Additionally there may be a site dependent
        /// or order dependent service time of the stop. See Service time
        /// calculation.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTimePerStop")]
        public double? ServiceTimePerStop { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "equipment")]
        public IList<string> Equipment { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "orderGroupIds")]
        public IList<string> OrderGroupIds { get; set; }

    }
}
