// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the vehicle to be used which activates rules of different
    /// algorithms. Please note that all values apply to the complete vehicle
    /// including trailers. Note that the results may be incorrect because the
    /// legal definition of a vehicle type may differ from country to country
    /// and it may also differ from the technical definition. As an example, a
    /// truck with a weight of 7.5 tons is a truck by legal definition in
    /// Germany but is not a truck by definition of toll. Most parameters are
    /// used for several use cases. They are denoted with (1) for routing, (2)
    /// for toll, (3) for emission calculation, (4) for truck attributes, and
    /// (5) for preferred routes. The default is a VW Golf VI. Give as many
    /// details on the vehicle as possible in order to obtain the best result.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.vehicleprofile.VehicleProfile
    /// </summary>
    public partial class VehicleProfile
    {
        /// <summary>
        /// Initializes a new instance of the VehicleProfile class.
        /// </summary>
        public VehicleProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VehicleProfile class.
        /// </summary>
        /// <param name="engine">Defines the engine parameters of the vehicle.
        /// These parameters are only relevant if the driveType is
        /// MOTOR\_VEHICLE.</param>
        /// <param name="weight">Defines the weight parameters of the vehicle.
        /// The actual weight of the vehicle is the sum of the empty weight and
        /// the load weight.</param>
        /// <param name="dimensions">Defines the size parameters of the
        /// vehicle, e.g. height, length, etc.</param>
        /// <param name="axle">Defines the number of axles of the vehicle and
        /// the axle load.</param>
        /// <param name="legalCondition">Defines a legal condition of the
        /// vehicle, e.g. whether the vehicle is delivering goods or is an
        /// emergency vehicle.</param>
        /// <param name="load">Defines the current load of the vehicle</param>
        /// <param name="speeds">Defines the speed values used by the routing
        /// algorithm to calculate the travel time of a road segment. All speed
        /// values given here are internally rounded to km/h.</param>
        /// <param name="driveType">The type of the vehicle, e.g. motorized,
        /// pedestrian, etc. (1,2,3,4). Possible values include:
        /// 'MOTOR_VEHICLE', 'BICYCLE', 'PEDESTRIAN'</param>
        /// <param name="yearOfManufacture">The vehicle's construction year.
        /// (3)</param>
        /// <param name="numberOfPassengers">The actual number of passengers
        /// including the driver. (2)</param>
        /// <param name="numberOfTrailers">The number of trailers.
        /// (2,4)</param>
        /// <param name="preferredRouteTypes">The road networks to be preferred
        /// by the routing algorithm as a comma-separated list (only if the
        /// feature layer PTV\_PreferredRoutes is enabled). The available types
        /// can be requested through the xRuntime service and are documented in
        /// the manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)</param>
        /// <param name="restrictedRouteTypes">The road networks that should be
        /// avoided as far as possible, e.g. for convenience reasons, as a
        /// comma-separated list (only if the feature layer
        /// PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)</param>
        /// <param name="highlyRestrictedRouteTypes">The road networks that
        /// must be avoided, e.g. due to legal limitations, as a
        /// comma-separated list (only if the feature layer
        /// PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)</param>
        /// <param name="prohibitedRouteTypes">The road networks that are
        /// prohibited for the vehicle as a comma-separated list (only if the
        /// feature layer PTV\_PreferredRoutes is enabled). The available types
        /// can be requested through the xRuntime service and are documented in
        /// the manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)</param>
        /// <param name="electronicTollCollectionSubscriptions">The
        /// subscriptions for electronic toll collection systems the vehicle
        /// can use as a comma-separated list (only if toll is enabled). The
        /// available types can be requested through the xRuntime service and
        /// are returned in
        /// xruntime.TollFeatures.electronicTollCollectionSubscriptions for the
        /// map and in
        /// xruntime.TollFeatures.electronicTollCollectionSubscriptions for a
        /// country or subdivision. (2)</param>
        public VehicleProfile(Engine engine = default(Engine), Weight weight = default(Weight), Dimensions dimensions = default(Dimensions), Axle axle = default(Axle), LegalCondition legalCondition = default(LegalCondition), Load load = default(Load), Speeds speeds = default(Speeds), DriveType? driveType = default(DriveType?), int? yearOfManufacture = default(int?), int? numberOfPassengers = default(int?), int? numberOfTrailers = default(int?), string preferredRouteTypes = default(string), string restrictedRouteTypes = default(string), string highlyRestrictedRouteTypes = default(string), string prohibitedRouteTypes = default(string), string electronicTollCollectionSubscriptions = default(string))
        {
            Engine = engine;
            Weight = weight;
            Dimensions = dimensions;
            Axle = axle;
            LegalCondition = legalCondition;
            Load = load;
            Speeds = speeds;
            DriveType = driveType;
            YearOfManufacture = yearOfManufacture;
            NumberOfPassengers = numberOfPassengers;
            NumberOfTrailers = numberOfTrailers;
            PreferredRouteTypes = preferredRouteTypes;
            RestrictedRouteTypes = restrictedRouteTypes;
            HighlyRestrictedRouteTypes = highlyRestrictedRouteTypes;
            ProhibitedRouteTypes = prohibitedRouteTypes;
            ElectronicTollCollectionSubscriptions = electronicTollCollectionSubscriptions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines the engine parameters of the vehicle. These
        /// parameters are only relevant if the driveType is MOTOR\_VEHICLE.
        /// </summary>
        [JsonProperty(PropertyName = "engine")]
        public Engine Engine { get; set; }

        /// <summary>
        /// Gets or sets defines the weight parameters of the vehicle. The
        /// actual weight of the vehicle is the sum of the empty weight and the
        /// load weight.
        /// </summary>
        [JsonProperty(PropertyName = "weight")]
        public Weight Weight { get; set; }

        /// <summary>
        /// Gets or sets defines the size parameters of the vehicle, e.g.
        /// height, length, etc.
        /// </summary>
        [JsonProperty(PropertyName = "dimensions")]
        public Dimensions Dimensions { get; set; }

        /// <summary>
        /// Gets or sets defines the number of axles of the vehicle and the
        /// axle load.
        /// </summary>
        [JsonProperty(PropertyName = "axle")]
        public Axle Axle { get; set; }

        /// <summary>
        /// Gets or sets defines a legal condition of the vehicle, e.g. whether
        /// the vehicle is delivering goods or is an emergency vehicle.
        /// </summary>
        [JsonProperty(PropertyName = "legalCondition")]
        public LegalCondition LegalCondition { get; set; }

        /// <summary>
        /// Gets or sets defines the current load of the vehicle
        /// </summary>
        [JsonProperty(PropertyName = "load")]
        public Load Load { get; set; }

        /// <summary>
        /// Gets or sets defines the speed values used by the routing algorithm
        /// to calculate the travel time of a road segment. All speed values
        /// given here are internally rounded to km/h.
        /// </summary>
        [JsonProperty(PropertyName = "speeds")]
        public Speeds Speeds { get; set; }

        /// <summary>
        /// Gets or sets the type of the vehicle, e.g. motorized, pedestrian,
        /// etc. (1,2,3,4). Possible values include: 'MOTOR_VEHICLE',
        /// 'BICYCLE', 'PEDESTRIAN'
        /// </summary>
        [JsonProperty(PropertyName = "driveType")]
        public DriveType? DriveType { get; set; }

        /// <summary>
        /// Gets or sets the vehicle's construction year. (3)
        /// </summary>
        [JsonProperty(PropertyName = "yearOfManufacture")]
        public int? YearOfManufacture { get; set; }

        /// <summary>
        /// Gets or sets the actual number of passengers including the driver.
        /// (2)
        /// </summary>
        [JsonProperty(PropertyName = "numberOfPassengers")]
        public int? NumberOfPassengers { get; set; }

        /// <summary>
        /// Gets or sets the number of trailers. (2,4)
        /// </summary>
        [JsonProperty(PropertyName = "numberOfTrailers")]
        public int? NumberOfTrailers { get; set; }

        /// <summary>
        /// Gets or sets the road networks to be preferred by the routing
        /// algorithm as a comma-separated list (only if the feature layer
        /// PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)
        /// </summary>
        [JsonProperty(PropertyName = "preferredRouteTypes")]
        public string PreferredRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets the road networks that should be avoided as far as
        /// possible, e.g. for convenience reasons, as a comma-separated list
        /// (only if the feature layer PTV\_PreferredRoutes is enabled). The
        /// available types can be requested through the xRuntime service and
        /// are documented in the manual as layer-specific properties of the
        /// feature layer PTV\_PreferredRoutes. (5)
        /// </summary>
        [JsonProperty(PropertyName = "restrictedRouteTypes")]
        public string RestrictedRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets the road networks that must be avoided, e.g. due to
        /// legal limitations, as a comma-separated list (only if the feature
        /// layer PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)
        /// </summary>
        [JsonProperty(PropertyName = "highlyRestrictedRouteTypes")]
        public string HighlyRestrictedRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets the road networks that are prohibited for the vehicle
        /// as a comma-separated list (only if the feature layer
        /// PTV\_PreferredRoutes is enabled). The available types can be
        /// requested through the xRuntime service and are documented in the
        /// manual as layer-specific properties of the feature layer
        /// PTV\_PreferredRoutes. (5)
        /// </summary>
        [JsonProperty(PropertyName = "prohibitedRouteTypes")]
        public string ProhibitedRouteTypes { get; set; }

        /// <summary>
        /// Gets or sets the subscriptions for electronic toll collection
        /// systems the vehicle can use as a comma-separated list (only if toll
        /// is enabled). The available types can be requested through the
        /// xRuntime service and are returned in
        /// xruntime.TollFeatures.electronicTollCollectionSubscriptions for the
        /// map and in
        /// xruntime.TollFeatures.electronicTollCollectionSubscriptions for a
        /// country or subdivision. (2)
        /// </summary>
        [JsonProperty(PropertyName = "electronicTollCollectionSubscriptions")]
        public string ElectronicTollCollectionSubscriptions { get; set; }

    }
}
