// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a visit of a visiting day.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.Visit
    /// </summary>
    public partial class Visit
    {
        /// <summary>
        /// Initializes a new instance of the Visit class.
        /// </summary>
        public Visit()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Visit class.
        /// </summary>
        /// <param name="visitDate">The date of the visit.</param>
        /// <param name="serviceTime">Service time for this visit.</param>
        /// <param name="orderId">The unique identifier of the order associated
        /// with this visit.</param>
        /// <param name="visitNumber">The visit number (of the total visits) of
        /// the order with orderId.</param>
        /// <param name="travelTimeToVisit">Time taken to travel from the
        /// previous visit of the day this this one. For the first visit of the
        /// day this is the travel time from the field worker location. This
        /// value is only set if determineShortestVisitSequencePerDay is
        /// enabled.</param>
        public Visit(System.DateTime visitDate, double serviceTime, string orderId, int visitNumber, double? travelTimeToVisit = default(double?))
        {
            VisitDate = visitDate;
            ServiceTime = serviceTime;
            OrderId = orderId;
            VisitNumber = visitNumber;
            TravelTimeToVisit = travelTimeToVisit;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the date of the visit.
        /// </summary>
        [JsonConverter(typeof(DateJsonConverter))]
        [JsonProperty(PropertyName = "visitDate")]
        public System.DateTime VisitDate { get; set; }

        /// <summary>
        /// Gets or sets service time for this visit.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTime")]
        public double ServiceTime { get; set; }

        /// <summary>
        /// Gets or sets the unique identifier of the order associated with
        /// this visit.
        /// </summary>
        [JsonProperty(PropertyName = "orderId")]
        public string OrderId { get; set; }

        /// <summary>
        /// Gets or sets the visit number (of the total visits) of the order
        /// with orderId.
        /// </summary>
        [JsonProperty(PropertyName = "visitNumber")]
        public int VisitNumber { get; set; }

        /// <summary>
        /// Gets or sets time taken to travel from the previous visit of the
        /// day this this one. For the first visit of the day this is the
        /// travel time from the field worker location. This value is only set
        /// if determineShortestVisitSequencePerDay is enabled.
        /// </summary>
        [JsonProperty(PropertyName = "travelTimeToVisit")]
        public double? TravelTimeToVisit { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (OrderId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OrderId");
            }
        }
    }
}
