// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a visiting day. If determineShortestVisitSequencePerDay is
    /// true, the sequence of visits as present in VisitsResponse is optimal.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.VisitDay
    /// </summary>
    public partial class VisitDay
    {
        /// <summary>
        /// Initializes a new instance of the VisitDay class.
        /// </summary>
        public VisitDay()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VisitDay class.
        /// </summary>
        /// <param name="visitDate">Date of the day</param>
        /// <param name="startIndex">Index of the first visit of the day in
        /// visit array in VisitsResponse. If startIndex equals endIndex the
        /// day has no visits.</param>
        /// <param name="endIndex">Index after the last visit of the day in
        /// visit array in VisitsResponse. If startIndex equals endIndex the
        /// day has no visits.</param>
        /// <param name="travelTime">If determineShortestVisitSequencePerDay is
        /// true, this is set to the total travel time for that day.</param>
        /// <param name="serviceTime">Total service time for that day.</param>
        /// <param name="travelTimeAfterLastVisit">Travel time from the last
        /// visit of the day to the field worker location, if no overnight stay
        /// occurs on this day. In case of an overnight stay, it is the travel
        /// time from the last visit of the day to the first visit of the next
        /// day. This value is only set if determineShortestVisitSequencePerDay
        /// is enabled.</param>
        /// <param name="overnightStay">True if an overnight stay occured on
        /// this day. The overnight location always matches the location of the
        /// last visit of the day.</param>
        public VisitDay(System.DateTime? visitDate = default(System.DateTime?), int? startIndex = default(int?), int? endIndex = default(int?), double? travelTime = default(double?), double? serviceTime = default(double?), double? travelTimeAfterLastVisit = default(double?), bool? overnightStay = default(bool?))
        {
            VisitDate = visitDate;
            StartIndex = startIndex;
            EndIndex = endIndex;
            TravelTime = travelTime;
            ServiceTime = serviceTime;
            TravelTimeAfterLastVisit = travelTimeAfterLastVisit;
            OvernightStay = overnightStay;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets date of the day
        /// </summary>
        [JsonConverter(typeof(DateJsonConverter))]
        [JsonProperty(PropertyName = "visitDate")]
        public System.DateTime? VisitDate { get; set; }

        /// <summary>
        /// Gets or sets index of the first visit of the day in visit array in
        /// VisitsResponse. If startIndex equals endIndex the day has no
        /// visits.
        /// </summary>
        [JsonProperty(PropertyName = "startIndex")]
        public int? StartIndex { get; set; }

        /// <summary>
        /// Gets or sets index after the last visit of the day in visit array
        /// in VisitsResponse. If startIndex equals endIndex the day has no
        /// visits.
        /// </summary>
        [JsonProperty(PropertyName = "endIndex")]
        public int? EndIndex { get; set; }

        /// <summary>
        /// Gets or sets if determineShortestVisitSequencePerDay is true, this
        /// is set to the total travel time for that day.
        /// </summary>
        [JsonProperty(PropertyName = "travelTime")]
        public double? TravelTime { get; set; }

        /// <summary>
        /// Gets or sets total service time for that day.
        /// </summary>
        [JsonProperty(PropertyName = "serviceTime")]
        public double? ServiceTime { get; set; }

        /// <summary>
        /// Gets or sets travel time from the last visit of the day to the
        /// field worker location, if no overnight stay occurs on this day. In
        /// case of an overnight stay, it is the travel time from the last
        /// visit of the day to the first visit of the next day. This value is
        /// only set if determineShortestVisitSequencePerDay is enabled.
        /// </summary>
        [JsonProperty(PropertyName = "travelTimeAfterLastVisit")]
        public double? TravelTimeAfterLastVisit { get; set; }

        /// <summary>
        /// Gets or sets true if an overnight stay occured on this day. The
        /// overnight location always matches the location of the last visit of
        /// the day.
        /// </summary>
        [JsonProperty(PropertyName = "overnightStay")]
        public bool? OvernightStay { get; set; }

    }
}
