// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents visit pattern options for an order of the visit planning use
    /// case.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.VisitPatternOptions
    /// </summary>
    public partial class VisitPatternOptions
    {
        /// <summary>
        /// Initializes a new instance of the VisitPatternOptions class.
        /// </summary>
        public VisitPatternOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VisitPatternOptions class.
        /// </summary>
        /// <param name="flexibleChoiceOfVisitPatterns">Defines if an arbitrary
        /// visit pattern can be chosen for each week. If this parameter is set
        /// to true, the maximumNumberOfVisitPatternDeviations is
        /// ignored.</param>
        /// <param name="maximumNumberOfVisitPatternDeviations">Defines the
        /// maximum number of weeks in which a deviation from the regular visit
        /// pattern is allowed. The upper bound for this parameter is set to
        /// half of the number of feasible visit weeks. If
        /// flexibleChoiceOfVisitPatterns is set to true, this parameter is
        /// ignored.</param>
        /// <param name="firstVisitDay">Fixes the first visit day for an
        /// order.</param>
        public VisitPatternOptions(IList<Week> visitPatterns = default(IList<Week>), bool? flexibleChoiceOfVisitPatterns = default(bool?), int? maximumNumberOfVisitPatternDeviations = default(int?), IList<System.DateTime?> forbiddenVisitDays = default(IList<System.DateTime?>), System.DateTime? firstVisitDay = default(System.DateTime?))
        {
            VisitPatterns = visitPatterns;
            FlexibleChoiceOfVisitPatterns = flexibleChoiceOfVisitPatterns;
            MaximumNumberOfVisitPatternDeviations = maximumNumberOfVisitPatternDeviations;
            ForbiddenVisitDays = forbiddenVisitDays;
            FirstVisitDay = firstVisitDay;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "visitPatterns")]
        public IList<Week> VisitPatterns { get; set; }

        /// <summary>
        /// Gets or sets defines if an arbitrary visit pattern can be chosen
        /// for each week. If this parameter is set to true, the
        /// maximumNumberOfVisitPatternDeviations is ignored.
        /// </summary>
        [JsonProperty(PropertyName = "flexibleChoiceOfVisitPatterns")]
        public bool? FlexibleChoiceOfVisitPatterns { get; set; }

        /// <summary>
        /// Gets or sets defines the maximum number of weeks in which a
        /// deviation from the regular visit pattern is allowed. The upper
        /// bound for this parameter is set to half of the number of feasible
        /// visit weeks. If flexibleChoiceOfVisitPatterns is set to true, this
        /// parameter is ignored.
        /// </summary>
        [JsonProperty(PropertyName = "maximumNumberOfVisitPatternDeviations")]
        public int? MaximumNumberOfVisitPatternDeviations { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "forbiddenVisitDays")]
        public IList<System.DateTime?> ForbiddenVisitDays { get; set; }

        /// <summary>
        /// Gets or sets fixes the first visit day for an order.
        /// </summary>
        [JsonConverter(typeof(DateJsonConverter))]
        [JsonProperty(PropertyName = "firstVisitDay")]
        public System.DateTime? FirstVisitDay { get; set; }

    }
}
