// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contains parameter values for the visit planning use cases.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.clusterplanningprofile.VisitPlanning
    /// </summary>
    public partial class VisitPlanning
    {
        /// <summary>
        /// Initializes a new instance of the VisitPlanning class.
        /// </summary>
        public VisitPlanning()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VisitPlanning class.
        /// </summary>
        /// <param name="overnightStay">Contains parameter values for use cases
        /// in which the visit plan is calculated with overnight stays.</param>
        /// <param name="workloadBalancing">Contains parameter values for use
        /// cases in which the daily workload in a visit plan needs to be
        /// balanced.</param>
        /// <param name="compactnessLevel">Defines the exponent with which the
        /// distances are incorporated in the model.</param>
        /// <param name="dailyDistanceWeight">Defines the importance of daily
        /// cluster compactness. If the daily cluster compactness should be
        /// more important than the weekly cluster compactness, set this value
        /// higher than the weeklyDistanceWeight.</param>
        /// <param name="weeklyDistanceWeight">Defines the importance of weekly
        /// cluster compactness. If the weekly cluster compactness should be
        /// more important than the daily cluster compactness, set this value
        /// higher than the dailyDistanceWeight.</param>
        /// <param name="approximationTolerance">Defines (in percent) how close
        /// to the optimal solution value the solver should come before exiting
        /// an iteration. For instance, compared to 10% the value of 5% means
        /// better solution at the cost of higher running time.</param>
        /// <param name="performPreprocessingStep">Perform preprocessing to
        /// reduce the complexity of the optimization problem. For example by
        /// excluding forbidden or redundant combinations. For large problems
        /// the preprocessing itself can be very time-consuming.</param>
        /// <param name="maximumNumberOfIterations">The maximum number of
        /// iterations the solver may use to provide a solution.</param>
        /// <param name="minimumRelativeImprovement">The minimum relative
        /// solution value improvement (in percent) between iterations. If the
        /// relative improvement is less than the given value, no further
        /// iterations will be performed.</param>
        public VisitPlanning(OvernightStay overnightStay = default(OvernightStay), WorkloadBalancing workloadBalancing = default(WorkloadBalancing), int? compactnessLevel = default(int?), int? dailyDistanceWeight = default(int?), int? weeklyDistanceWeight = default(int?), double? approximationTolerance = default(double?), bool? performPreprocessingStep = default(bool?), int? maximumNumberOfIterations = default(int?), double? minimumRelativeImprovement = default(double?))
        {
            OvernightStay = overnightStay;
            WorkloadBalancing = workloadBalancing;
            CompactnessLevel = compactnessLevel;
            DailyDistanceWeight = dailyDistanceWeight;
            WeeklyDistanceWeight = weeklyDistanceWeight;
            ApproximationTolerance = approximationTolerance;
            PerformPreprocessingStep = performPreprocessingStep;
            MaximumNumberOfIterations = maximumNumberOfIterations;
            MinimumRelativeImprovement = minimumRelativeImprovement;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets contains parameter values for use cases in which the
        /// visit plan is calculated with overnight stays.
        /// </summary>
        [JsonProperty(PropertyName = "overnightStay")]
        public OvernightStay OvernightStay { get; set; }

        /// <summary>
        /// Gets or sets contains parameter values for use cases in which the
        /// daily workload in a visit plan needs to be balanced.
        /// </summary>
        [JsonProperty(PropertyName = "workloadBalancing")]
        public WorkloadBalancing WorkloadBalancing { get; set; }

        /// <summary>
        /// Gets or sets defines the exponent with which the distances are
        /// incorporated in the model.
        /// </summary>
        [JsonProperty(PropertyName = "compactnessLevel")]
        public int? CompactnessLevel { get; set; }

        /// <summary>
        /// Gets or sets defines the importance of daily cluster compactness.
        /// If the daily cluster compactness should be more important than the
        /// weekly cluster compactness, set this value higher than the
        /// weeklyDistanceWeight.
        /// </summary>
        [JsonProperty(PropertyName = "dailyDistanceWeight")]
        public int? DailyDistanceWeight { get; set; }

        /// <summary>
        /// Gets or sets defines the importance of weekly cluster compactness.
        /// If the weekly cluster compactness should be more important than the
        /// daily cluster compactness, set this value higher than the
        /// dailyDistanceWeight.
        /// </summary>
        [JsonProperty(PropertyName = "weeklyDistanceWeight")]
        public int? WeeklyDistanceWeight { get; set; }

        /// <summary>
        /// Gets or sets defines (in percent) how close to the optimal solution
        /// value the solver should come before exiting an iteration. For
        /// instance, compared to 10% the value of 5% means better solution at
        /// the cost of higher running time.
        /// </summary>
        [JsonProperty(PropertyName = "approximationTolerance")]
        public double? ApproximationTolerance { get; set; }

        /// <summary>
        /// Gets or sets perform preprocessing to reduce the complexity of the
        /// optimization problem. For example by excluding forbidden or
        /// redundant combinations. For large problems the preprocessing itself
        /// can be very time-consuming.
        /// </summary>
        [JsonProperty(PropertyName = "performPreprocessingStep")]
        public bool? PerformPreprocessingStep { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of iterations the solver may use to
        /// provide a solution.
        /// </summary>
        [JsonProperty(PropertyName = "maximumNumberOfIterations")]
        public int? MaximumNumberOfIterations { get; set; }

        /// <summary>
        /// Gets or sets the minimum relative solution value improvement (in
        /// percent) between iterations. If the relative improvement is less
        /// than the given value, no further iterations will be performed.
        /// </summary>
        [JsonProperty(PropertyName = "minimumRelativeImprovement")]
        public double? MinimumRelativeImprovement { get; set; }

    }
}
