// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents an order for the visit planning use case.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xcluster.VisitOrder
    /// </summary>
    public partial class VisitPlanningOrder
    {
        /// <summary>
        /// Initializes a new instance of the VisitPlanningOrder class.
        /// </summary>
        public VisitPlanningOrder()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VisitPlanningOrder class.
        /// </summary>
        /// <param name="id">The unique identifier of this order.</param>
        /// <param name="locationId">The unique identifier of the customer
        /// location that should be visited in this order.</param>
        /// <param name="visitRhythmInWeeks">Defines the visit rhythm of the
        /// order, i.e. the number of weeks in which the order needs to be
        /// handled (again). For example, a visitRhythmInWeeks of 2 means that
        /// the customer has to be visited every 2 weeks.</param>
        /// <param name="numberOfVisitsPerWeek">Defines the number of visits
        /// per (visiting) week for this order. This parameter needs to be
        /// between one and the number of workDays per week.</param>
        /// <param name="visitPatternOptions">Defines the visit pattern options
        /// for the order.</param>
        /// <param name="weekOfPossibleFirstVisit">The calendar week where the
        /// first visit for this order could happen. If the parameter is
        /// omitted, the first week of the planningPeriod is assumed to be the
        /// first possible week for this visit. If the visitRhythmInWeeks is
        /// more than 1, the first visit may take place in some of the
        /// following weeks, according to the rhythm.</param>
        /// <param name="weekOfPossibleLastVisit">The week, relative to the
        /// planning period, where the last visit for this order may happen. If
        /// this parameter is omitted, visits are possible during the whole
        /// planning period.</param>
        public VisitPlanningOrder(string id, string locationId, int visitRhythmInWeeks, int numberOfVisitsPerWeek, VisitPatternOptions visitPatternOptions = default(VisitPatternOptions), int? weekOfPossibleFirstVisit = default(int?), int? weekOfPossibleLastVisit = default(int?), IList<double?> serviceTimes = default(IList<double?>))
        {
            Id = id;
            LocationId = locationId;
            VisitRhythmInWeeks = visitRhythmInWeeks;
            NumberOfVisitsPerWeek = numberOfVisitsPerWeek;
            VisitPatternOptions = visitPatternOptions;
            WeekOfPossibleFirstVisit = weekOfPossibleFirstVisit;
            WeekOfPossibleLastVisit = weekOfPossibleLastVisit;
            ServiceTimes = serviceTimes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique identifier of this order.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the unique identifier of the customer location that
        /// should be visited in this order.
        /// </summary>
        [JsonProperty(PropertyName = "locationId")]
        public string LocationId { get; set; }

        /// <summary>
        /// Gets or sets defines the visit rhythm of the order, i.e. the number
        /// of weeks in which the order needs to be handled (again). For
        /// example, a visitRhythmInWeeks of 2 means that the customer has to
        /// be visited every 2 weeks.
        /// </summary>
        [JsonProperty(PropertyName = "visitRhythmInWeeks")]
        public int VisitRhythmInWeeks { get; set; }

        /// <summary>
        /// Gets or sets defines the number of visits per (visiting) week for
        /// this order. This parameter needs to be between one and the number
        /// of workDays per week.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfVisitsPerWeek")]
        public int NumberOfVisitsPerWeek { get; set; }

        /// <summary>
        /// Gets or sets defines the visit pattern options for the order.
        /// </summary>
        [JsonProperty(PropertyName = "visitPatternOptions")]
        public VisitPatternOptions VisitPatternOptions { get; set; }

        /// <summary>
        /// Gets or sets the calendar week where the first visit for this order
        /// could happen. If the parameter is omitted, the first week of the
        /// planningPeriod is assumed to be the first possible week for this
        /// visit. If the visitRhythmInWeeks is more than 1, the first visit
        /// may take place in some of the following weeks, according to the
        /// rhythm.
        /// </summary>
        [JsonProperty(PropertyName = "weekOfPossibleFirstVisit")]
        public int? WeekOfPossibleFirstVisit { get; set; }

        /// <summary>
        /// Gets or sets the week, relative to the planning period, where the
        /// last visit for this order may happen. If this parameter is omitted,
        /// visits are possible during the whole planning period.
        /// </summary>
        [JsonProperty(PropertyName = "weekOfPossibleLastVisit")]
        public int? WeekOfPossibleLastVisit { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "serviceTimes")]
        public IList<double?> ServiceTimes { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (LocationId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LocationId");
            }
        }
    }
}
