// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This type includes options to control job status and progress updates.
    /// All parameters are optional.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.jobs.WatchRequest
    /// </summary>
    public partial class WatchRequest
    {
        /// <summary>
        /// Initializes a new instance of the WatchRequest class.
        /// </summary>
        public WatchRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WatchRequest class.
        /// </summary>
        /// <param name="id">The job's ID.</param>
        /// <param name="progressUpdatePeriod">If defined this optional
        /// parameter enables additional progress updates with the specified
        /// interval. If no new progress update arrives during the specified
        /// period, watchJob will wait for and return with the next available
        /// progress update. Important updates such as terminal states will
        /// always return immediately. The minimum period must be at least
        /// 250ms. If no progress waiting period is defined, progress will only
        /// be sent as part of status updates.</param>
        /// <param name="maximumPollingPeriod">Specifies the timeout after
        /// which watchJob will report the last status even if no further
        /// updates are available. If not specified a configured default is
        /// used.</param>
        public WatchRequest(string id, int? progressUpdatePeriod = default(int?), int? maximumPollingPeriod = default(int?))
        {
            Id = id;
            ProgressUpdatePeriod = progressUpdatePeriod;
            MaximumPollingPeriod = maximumPollingPeriod;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the job's ID.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets if defined this optional parameter enables additional
        /// progress updates with the specified interval. If no new progress
        /// update arrives during the specified period, watchJob will wait for
        /// and return with the next available progress update. Important
        /// updates such as terminal states will always return immediately. The
        /// minimum period must be at least 250ms. If no progress waiting
        /// period is defined, progress will only be sent as part of status
        /// updates.
        /// </summary>
        [JsonProperty(PropertyName = "progressUpdatePeriod")]
        public int? ProgressUpdatePeriod { get; set; }

        /// <summary>
        /// Gets or sets specifies the timeout after which watchJob will report
        /// the last status even if no further updates are available. If not
        /// specified a configured default is used.
        /// </summary>
        [JsonProperty(PropertyName = "maximumPollingPeriod")]
        public int? MaximumPollingPeriod { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
        }
    }
}
