// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A waypoint defines the start or destination of a route or a route leg.
    /// Every waypoint corresponds to an InputWaypoint, but not every input
    /// waypoint corresponds to a waypoint in the route. It is guaranteed that
    /// the waypoint of index *n* starts the leg of index *n*. That means that
    /// the number of waypoints equals the number of legs plus 1.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.xroute.Waypoint
    /// </summary>
    public partial class Waypoint
    {
        /// <summary>
        /// Initializes a new instance of the Waypoint class.
        /// </summary>
        public Waypoint()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Waypoint class.
        /// </summary>
        /// <param name="country">Country the waypoint is located in. This
        /// value is determined based on the Waypoint.linkedCoordinate. Note
        /// that for this reason rare situations can occur close to borders
        /// where the Waypoint.referenceCoordinate for the waypoint is not in
        /// the same country.</param>
        /// <param name="linkedCoordinate">The coordinate where input location
        /// was linked to the road network. This location is always on the
        /// route.</param>
        /// <param name="referenceCoordinate">The location of the waypoint on
        /// the route. For an OffRoadWaypoint this is the input location, for
        /// an OnRoadWaypoint this is the linked location. Use this location to
        /// mark the waypoint on the map.</param>
        /// <param name="linkDistance">Distance as the crow flies from the
        /// input coordinate to the linked coordinate.</param>
        /// <param name="linkTravelTime">Assumed travel time it takes to get
        /// from the input coordinate to the linked coordinate. The speed can
        /// be configured by
        /// vehicleprofile.Speeds.speedForLinkDistance.</param>
        /// <param name="name">The name of the corresponding input waypoint.
        /// This user-defined name is available only if InputWaypoint.name for
        /// the corresponding input waypoint is set.</param>
        /// <param name="nodeIndex">The index in the list of
        /// RouteResponse.nodes of the corresponding node. It is available only
        /// if the list of nodes is requested by ResultFields.nodes.</param>
        public Waypoint(string country, Coordinate linkedCoordinate, Coordinate referenceCoordinate, double linkDistance, double linkTravelTime, string name = default(string), int? nodeIndex = default(int?))
        {
            Name = name;
            Country = country;
            LinkedCoordinate = linkedCoordinate;
            ReferenceCoordinate = referenceCoordinate;
            LinkDistance = linkDistance;
            LinkTravelTime = linkTravelTime;
            NodeIndex = nodeIndex;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the corresponding input waypoint. This
        /// user-defined name is available only if InputWaypoint.name for the
        /// corresponding input waypoint is set.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets country the waypoint is located in. This value is
        /// determined based on the Waypoint.linkedCoordinate. Note that for
        /// this reason rare situations can occur close to borders where the
        /// Waypoint.referenceCoordinate for the waypoint is not in the same
        /// country.
        /// </summary>
        [JsonProperty(PropertyName = "country")]
        public string Country { get; set; }

        /// <summary>
        /// Gets or sets the coordinate where input location was linked to the
        /// road network. This location is always on the route.
        /// </summary>
        [JsonProperty(PropertyName = "linkedCoordinate")]
        public Coordinate LinkedCoordinate { get; set; }

        /// <summary>
        /// Gets or sets the location of the waypoint on the route. For an
        /// OffRoadWaypoint this is the input location, for an OnRoadWaypoint
        /// this is the linked location. Use this location to mark the waypoint
        /// on the map.
        /// </summary>
        [JsonProperty(PropertyName = "referenceCoordinate")]
        public Coordinate ReferenceCoordinate { get; set; }

        /// <summary>
        /// Gets or sets distance as the crow flies from the input coordinate
        /// to the linked coordinate.
        /// </summary>
        [JsonProperty(PropertyName = "linkDistance")]
        public double LinkDistance { get; set; }

        /// <summary>
        /// Gets or sets assumed travel time it takes to get from the input
        /// coordinate to the linked coordinate. The speed can be configured by
        /// vehicleprofile.Speeds.speedForLinkDistance.
        /// </summary>
        [JsonProperty(PropertyName = "linkTravelTime")]
        public double LinkTravelTime { get; set; }

        /// <summary>
        /// Gets or sets the index in the list of RouteResponse.nodes of the
        /// corresponding node. It is available only if the list of nodes is
        /// requested by ResultFields.nodes.
        /// </summary>
        [JsonProperty(PropertyName = "nodeIndex")]
        public int? NodeIndex { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Country == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Country");
            }
            if (LinkedCoordinate == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LinkedCoordinate");
            }
            if (ReferenceCoordinate == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ReferenceCoordinate");
            }
            if (LinkedCoordinate != null)
            {
                LinkedCoordinate.Validate();
            }
            if (ReferenceCoordinate != null)
            {
                ReferenceCoordinate.Validate();
            }
        }
    }
}
