// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    public partial class WaypointEvent : RouteEvent
    {
        /// <summary>
        /// Initializes a new instance of the WaypointEvent class.
        /// </summary>
        public WaypointEvent()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WaypointEvent class.
        /// </summary>
        /// <param name="eventType">The type of the current route event.
        /// Possible values include: 'MANEUVER_EVENT', 'TOUR_EVENT',
        /// 'TOLL_EVENT', 'WAYPOINT_EVENT', 'ROUTE_VIOLATION_EVENT',
        /// 'UTC_OFFSET_EVENT', 'COUNTRY_EVENT'</param>
        /// <param name="startsAt">The point in time at which the event starts.
        /// This field is only present if a time-consideration scenario with a
        /// reference time is given in the request. The time zone is that of
        /// the reference time. Use the UTCOffsetEvent to derive the local
        /// time.</param>
        /// <param name="coordinate">The location at which the event occurs.
        /// This coordinate is not necessarily the coordinate of the related
        /// node. The event such as a traffic incident can, for example, occur
        /// in the middle of a long segment. This coordinate is designed to
        /// draw an icon on a map to mark the event.</param>
        /// <param name="nodeIndex">The index of the node in the
        /// RouteResponse.nodes list. As every segment starts at the node with
        /// the same index, it is also equal to the segment in the
        /// RouteResponse.segments list, if present, except for the very last
        /// index. This field is only present if the list of nodes is
        /// present.</param>
        /// <param name="distanceFromStart">The distance of the route from the
        /// start up to this event.</param>
        /// <param name="travelTimeFromStart">The travel time for the route
        /// from the start up to this event.</param>
        /// <param name="waypointIndex">The index of the waypoint in the
        /// RouteResponse.waypoints list. This field is only present if the
        /// list of waypoints is present.</param>
        /// <param name="waypointName">The name of the waypoint as given in the
        /// corresponding InputWaypoint. This field is only present if its is
        /// not empty. This is useful to identify input waypoints when the
        /// waypoints list is not available in the response.</param>
        public WaypointEvent(RouteEventType? eventType = default(RouteEventType?), System.DateTime? startsAt = default(System.DateTime?), Coordinate coordinate = default(Coordinate), int? nodeIndex = default(int?), double? distanceFromStart = default(double?), double? travelTimeFromStart = default(double?), int? waypointIndex = default(int?), string waypointName = default(string))
            : base(eventType, startsAt, coordinate, nodeIndex, distanceFromStart, travelTimeFromStart)
        {
            WaypointIndex = waypointIndex;
            WaypointName = waypointName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the index of the waypoint in the
        /// RouteResponse.waypoints list. This field is only present if the
        /// list of waypoints is present.
        /// </summary>
        [JsonProperty(PropertyName = "waypointIndex")]
        public int? WaypointIndex { get; set; }

        /// <summary>
        /// Gets or sets the name of the waypoint as given in the corresponding
        /// InputWaypoint. This field is only present if its is not empty. This
        /// is useful to identify input waypoints when the waypoints list is
        /// not available in the response.
        /// </summary>
        [JsonProperty(PropertyName = "waypointName")]
        public string WaypointName { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
