// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contains parameter values for use cases in which the daily workload in
    /// a visit plan needs to be balanced.
    /// Hint: Corresponding type in xServer API documentation -
    /// com.ptvgroup.xserver.clusterplanningprofile.WorkloadBalancing
    /// </summary>
    public partial class WorkloadBalancing
    {
        /// <summary>
        /// Initializes a new instance of the WorkloadBalancing class.
        /// </summary>
        public WorkloadBalancing()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WorkloadBalancing class.
        /// </summary>
        /// <param name="approximationTolerance">Defines (in percent) how close
        /// to the optimal solution value the solver should come before exiting
        /// an iteration. For instance, compared to 10% the value of 5% means
        /// better solution at the cost of higher running time.</param>
        /// <param name="performPreprocessingStep">Perform preprocessing to
        /// reduce the complexity of the optimization problem. For example by
        /// excluding forbidden or redundant combinations. For large problems
        /// the preprocessing itself can be very time-consuming.</param>
        /// <param name="maximumNumberOfIterations">The maximum number of
        /// iterations the solver may use to improve the workload balance. A
        /// higher number might lead to a better solution at the cost of higher
        /// running time.</param>
        public WorkloadBalancing(double? approximationTolerance = default(double?), bool? performPreprocessingStep = default(bool?), int? maximumNumberOfIterations = default(int?))
        {
            ApproximationTolerance = approximationTolerance;
            PerformPreprocessingStep = performPreprocessingStep;
            MaximumNumberOfIterations = maximumNumberOfIterations;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets defines (in percent) how close to the optimal solution
        /// value the solver should come before exiting an iteration. For
        /// instance, compared to 10% the value of 5% means better solution at
        /// the cost of higher running time.
        /// </summary>
        [JsonProperty(PropertyName = "approximationTolerance")]
        public double? ApproximationTolerance { get; set; }

        /// <summary>
        /// Gets or sets perform preprocessing to reduce the complexity of the
        /// optimization problem. For example by excluding forbidden or
        /// redundant combinations. For large problems the preprocessing itself
        /// can be very time-consuming.
        /// </summary>
        [JsonProperty(PropertyName = "performPreprocessingStep")]
        public bool? PerformPreprocessingStep { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of iterations the solver may use to
        /// improve the workload balance. A higher number might lead to a
        /// better solution at the cost of higher running time.
        /// </summary>
        [JsonProperty(PropertyName = "maximumNumberOfIterations")]
        public int? MaximumNumberOfIterations { get; set; }

    }
}
