// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace XServerClient
{
    using Models;
    using System.IO;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for XServer.
    /// </summary>
    public static partial class XServerExtensions
    {
            /// <summary>
            /// Determines the time zone for a given location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='x'>
            /// The value in x-direction (west to east), longitude for WGS84.
            /// </param>
            /// <param name='y'>
            /// The value in y-direction (south to north), latitude for WGS84.
            /// </param>
            /// <param name='timeZoneMethodParameters'>
            /// Additional parameters for the operation
            /// </param>
            public static TimeZoneResponse TimeZoneMethod(this IXServer operations, double x, double y, TimeZoneMethodParameters timeZoneMethodParameters = default(TimeZoneMethodParameters))
            {
                return operations.TimeZoneMethodAsync(x, y, timeZoneMethodParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Determines the time zone for a given location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='x'>
            /// The value in x-direction (west to east), longitude for WGS84.
            /// </param>
            /// <param name='y'>
            /// The value in y-direction (south to north), latitude for WGS84.
            /// </param>
            /// <param name='timeZoneMethodParameters'>
            /// Additional parameters for the operation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<TimeZoneResponse> TimeZoneMethodAsync(this IXServer operations, double x, double y, TimeZoneMethodParameters timeZoneMethodParameters = default(TimeZoneMethodParameters), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.TimeZoneMethodWithHttpMessagesAsync(x, y, timeZoneMethodParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Searches for locations matching a given address, specified as a free-form
            /// text input.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='address'>
            /// The input address.
            /// </param>
            /// <param name='locationsParameters'>
            /// Additional parameters for the operation
            /// </param>
            public static LocationsResponse Locations(this IXServer operations, string address, LocationsParameters locationsParameters = default(LocationsParameters))
            {
                return operations.LocationsAsync(address, locationsParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Searches for locations matching a given address, specified as a free-form
            /// text input.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='address'>
            /// The input address.
            /// </param>
            /// <param name='locationsParameters'>
            /// Additional parameters for the operation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<LocationsResponse> LocationsAsync(this IXServer operations, string address, LocationsParameters locationsParameters = default(LocationsParameters), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.LocationsWithHttpMessagesAsync(address, locationsParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Render a single map tile according the concept of the Map Tile API. By
            /// means of different frameworks a map image can be composed of multiple
            /// tiles. These tiles can be cached and reused for drawing of similar sections
            /// of a map. Optionally it is possible to return textual information on drawn
            /// Feature Layer data. Therefore, this operation can return either an image
            /// directly or a structured response which contains the image and additional
            /// information on drawn Feature Layer data such as their positions and names.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='zoomLevel'>
            /// Zoom level. Details about zoom levels are documented in the Map Tile API.
            /// </param>
            /// <param name='x'>
            /// Horizontal tile index.
            /// </param>
            /// <param name='y'>
            /// Vertical tile index.
            /// </param>
            /// <param name='tileBinaryParameters'>
            /// Additional parameters for the operation
            /// </param>
            public static Stream TileBinary(this IXServer operations, int zoomLevel, int x, int y, TileBinaryParameters tileBinaryParameters = default(TileBinaryParameters))
            {
                return operations.TileBinaryAsync(zoomLevel, x, y, tileBinaryParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Render a single map tile according the concept of the Map Tile API. By
            /// means of different frameworks a map image can be composed of multiple
            /// tiles. These tiles can be cached and reused for drawing of similar sections
            /// of a map. Optionally it is possible to return textual information on drawn
            /// Feature Layer data. Therefore, this operation can return either an image
            /// directly or a structured response which contains the image and additional
            /// information on drawn Feature Layer data such as their positions and names.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='zoomLevel'>
            /// Zoom level. Details about zoom levels are documented in the Map Tile API.
            /// </param>
            /// <param name='x'>
            /// Horizontal tile index.
            /// </param>
            /// <param name='y'>
            /// Vertical tile index.
            /// </param>
            /// <param name='tileBinaryParameters'>
            /// Additional parameters for the operation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Stream> TileBinaryAsync(this IXServer operations, int zoomLevel, int x, int y, TileBinaryParameters tileBinaryParameters = default(TileBinaryParameters), CancellationToken cancellationToken = default(CancellationToken))
            {
                var _result = await operations.TileBinaryWithHttpMessagesAsync(zoomLevel, x, y, tileBinaryParameters, null, cancellationToken).ConfigureAwait(false);
                _result.Request.Dispose();
                return _result.Body;
            }

            /// <summary>
            /// Calculates a route from start to destination and returns route information.
            /// This operation supports exactly two on-road waypoints.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='startX'>
            /// The longitude in WGS84 (EPSG:4326) of the start location. The location is
            /// interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='startY'>
            /// The latitude in WGS84 (EPSG:4326) of the start location. The location is
            /// interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='destinationX'>
            /// The longitude in WGS84 (EPSG:4326) of the destination location. The
            /// location is interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='destinationY'>
            /// The latitude in WGS84 (EPSG:4326) of the destination location. The location
            /// is interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='routeParameters'>
            /// Additional parameters for the operation
            /// </param>
            public static RouteResponse Route(this IXServer operations, double startX, double startY, double destinationX, double destinationY, RouteParameters routeParameters = default(RouteParameters))
            {
                return operations.RouteAsync(startX, startY, destinationX, destinationY, routeParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Calculates a route from start to destination and returns route information.
            /// This operation supports exactly two on-road waypoints.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='startX'>
            /// The longitude in WGS84 (EPSG:4326) of the start location. The location is
            /// interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='startY'>
            /// The latitude in WGS84 (EPSG:4326) of the start location. The location is
            /// interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='destinationX'>
            /// The longitude in WGS84 (EPSG:4326) of the destination location. The
            /// location is interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='destinationY'>
            /// The latitude in WGS84 (EPSG:4326) of the destination location. The location
            /// is interpreted as an routing.OnRoadRouteLocation.
            /// </param>
            /// <param name='routeParameters'>
            /// Additional parameters for the operation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<RouteResponse> RouteAsync(this IXServer operations, double startX, double startY, double destinationX, double destinationY, RouteParameters routeParameters = default(RouteParameters), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RouteWithHttpMessagesAsync(startX, startY, destinationX, destinationY, routeParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns information about the data used by PTV xServer as a REST service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='dataInformationParameters'>
            /// Additional parameters for the operation
            /// </param>
            public static DataInformationResponse DataInformation(this IXServer operations, DataInformationParameters dataInformationParameters = default(DataInformationParameters))
            {
                return operations.DataInformationAsync(dataInformationParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns information about the data used by PTV xServer as a REST service.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='dataInformationParameters'>
            /// Additional parameters for the operation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataInformationResponse> DataInformationAsync(this IXServer operations, DataInformationParameters dataInformationParameters = default(DataInformationParameters), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DataInformationWithHttpMessagesAsync(dataInformationParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Calculates a cluster planning for the given request. In contrast to the
            /// method planClusters, not all locations need to be covered.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ClustersResponse CoverLocations(this IXServer operations, CoverLocationsRequest body)
            {
                return operations.CoverLocationsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Calculates a cluster planning for the given request. In contrast to the
            /// method planClusters, not all locations need to be covered.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClustersResponse> CoverLocationsAsync(this IXServer operations, CoverLocationsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CoverLocationsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type ClustersResponse for the given job. If the
            /// calculation ended with an exception, fetchClustersResponse will rethrow it.
            /// If the id of the job is unknown, a XServerException with message 'unknown
            /// id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ClustersResponse FetchClustersResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchClustersResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type ClustersResponse for the given job. If the
            /// calculation ended with an exception, fetchClustersResponse will rethrow it.
            /// If the id of the job is unknown, a XServerException with message 'unknown
            /// id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClustersResponse> FetchClustersResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchClustersResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type VisitSequenceResponse for the given job. If the
            /// calculation ended with an exception, fetchVisitSequenceResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VisitSequenceResponse FetchVisitSequenceResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchVisitSequenceResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type VisitSequenceResponse for the given job. If the
            /// calculation ended with an exception, fetchVisitSequenceResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VisitSequenceResponse> FetchVisitSequenceResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchVisitSequenceResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type VisitsResponse for the given job. If the
            /// calculation ended with an exception, fetchVisitsResponse will rethrow it.
            /// If the id of the job is unknown, a XServerException with message 'unknown
            /// id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VisitsResponse FetchVisitsResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchVisitsResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type VisitsResponse for the given job. If the
            /// calculation ended with an exception, fetchVisitsResponse will rethrow it.
            /// If the id of the job is unknown, a XServerException with message 'unknown
            /// id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VisitsResponse> FetchVisitsResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchVisitsResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Solves visit sequencing problems with street distances. This is equivalent
            /// to a traveling salesman problem (TSP) with street distances.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VisitSequenceResponse OptimizeVisitSequence(this IXServer operations, OptimizeVisitSequenceRequest body)
            {
                return operations.OptimizeVisitSequenceAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Solves visit sequencing problems with street distances. This is equivalent
            /// to a traveling salesman problem (TSP) with street distances.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VisitSequenceResponse> OptimizeVisitSequenceAsync(this IXServer operations, OptimizeVisitSequenceRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.OptimizeVisitSequenceWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Calculates a cluster planning for the given request including all of the
            /// locations.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ClustersResponse PlanClusters(this IXServer operations, PlanClustersRequest body)
            {
                return operations.PlanClustersAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Calculates a cluster planning for the given request including all of the
            /// locations.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ClustersResponse> PlanClustersAsync(this IXServer operations, PlanClustersRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PlanClustersWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Calculates a daily visit planning for the given request in a certain
            /// planning period.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VisitsResponse PlanVisits(this IXServer operations, PlanVisitsRequest body)
            {
                return operations.PlanVisitsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Calculates a daily visit planning for the given request in a certain
            /// planning period.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VisitsResponse> PlanVisitsAsync(this IXServer operations, PlanVisitsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PlanVisitsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of coverLocations. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchClustersResponse. If the job ended with status
            /// FAILED, fetchClustersResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartCoverLocations(this IXServer operations, CoverLocationsRequest body)
            {
                return operations.StartCoverLocationsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of coverLocations. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchClustersResponse. If the job ended with status
            /// FAILED, fetchClustersResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartCoverLocationsAsync(this IXServer operations, CoverLocationsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartCoverLocationsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of optimizeVisitSequence. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using fetchVisitSequenceResponse.
            /// If the job ended with status FAILED, fetchVisitSequenceResponse throws the
            /// exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartOptimizeVisitSequence(this IXServer operations, OptimizeVisitSequenceRequest body)
            {
                return operations.StartOptimizeVisitSequenceAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of optimizeVisitSequence. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using fetchVisitSequenceResponse.
            /// If the job ended with status FAILED, fetchVisitSequenceResponse throws the
            /// exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartOptimizeVisitSequenceAsync(this IXServer operations, OptimizeVisitSequenceRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartOptimizeVisitSequenceWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of planClusters. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchClustersResponse. If the job ended with status
            /// FAILED, fetchClustersResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartPlanClusters(this IXServer operations, PlanClustersRequest body)
            {
                return operations.StartPlanClustersAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of planClusters. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchClustersResponse. If the job ended with status
            /// FAILED, fetchClustersResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartPlanClustersAsync(this IXServer operations, PlanClustersRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartPlanClustersWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of planVisits. Calling this operation will
            /// not block until the result has been calculated. Instead of a result object,
            /// a Job object is returned which identifies the started calculation. To get
            /// status updates on a running job, use the operation watchJob. If the status
            /// changes to SUCCEEDED, the calculation was successful and the result can be
            /// obtained using fetchVisitsResponse. If the job ended with status FAILED,
            /// fetchVisitsResponse throws the exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartPlanVisits(this IXServer operations, PlanVisitsRequest body)
            {
                return operations.StartPlanVisitsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of planVisits. Calling this operation will
            /// not block until the result has been calculated. Instead of a result object,
            /// a Job object is returned which identifies the started calculation. To get
            /// status updates on a running job, use the operation watchJob. If the status
            /// changes to SUCCEEDED, the calculation was successful and the result can be
            /// obtained using fetchVisitsResponse. If the job ended with status FAILED,
            /// fetchVisitsResponse throws the exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartPlanVisitsAsync(this IXServer operations, PlanVisitsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartPlanVisitsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates a snapshot of the current state of automatically updated data, such
            /// as PTV\_TrafficIncidents Feature Layer. See technical concept about content
            /// snapshots for more details. Returns the ID of the content snapshot.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ContentSnapshotResponse CreateContentSnapshot(this IXServer operations, CreateContentSnapshotRequest body)
            {
                return operations.CreateContentSnapshotAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates a snapshot of the current state of automatically updated data, such
            /// as PTV\_TrafficIncidents Feature Layer. See technical concept about content
            /// snapshots for more details. Returns the ID of the content snapshot.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ContentSnapshotResponse> CreateContentSnapshotAsync(this IXServer operations, CreateContentSnapshotRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateContentSnapshotWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a content snapshot.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VoidResponse DeleteContentSnapshot(this IXServer operations, DeleteContentSnapshotRequest body)
            {
                return operations.DeleteContentSnapshotAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a content snapshot.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VoidResponse> DeleteContentSnapshotAsync(this IXServer operations, DeleteContentSnapshotRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteContentSnapshotWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a high-performance routing network with a given ID considering user
            /// privileges and concurrent usage.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VoidResponse DeleteHighPerformanceRoutingNetwork(this IXServer operations, DeleteHighPerformanceRoutingNetworkRequest body)
            {
                return operations.DeleteHighPerformanceRoutingNetworkAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a high-performance routing network with a given ID considering user
            /// privileges and concurrent usage.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VoidResponse> DeleteHighPerformanceRoutingNetworkAsync(this IXServer operations, DeleteHighPerformanceRoutingNetworkRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteHighPerformanceRoutingNetworkWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type HighPerformanceRoutingNetworkResponse for the given
            /// job. If the calculation ended with an exception,
            /// fetchHighPerformanceRoutingNetworkResponse will rethrow it. If the id of
            /// the job is unknown, a XServerException with message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static HighPerformanceRoutingNetworkResponse FetchHighPerformanceRoutingNetworkResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchHighPerformanceRoutingNetworkResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type HighPerformanceRoutingNetworkResponse for the given
            /// job. If the calculation ended with an exception,
            /// fetchHighPerformanceRoutingNetworkResponse will rethrow it. If the id of
            /// the job is unknown, a XServerException with message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<HighPerformanceRoutingNetworkResponse> FetchHighPerformanceRoutingNetworkResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchHighPerformanceRoutingNetworkResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Determines the time zone for a given location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static TimeZoneResponse GetTimeZone(this IXServer operations, TimeZoneRequest body)
            {
                return operations.GetTimeZoneAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Determines the time zone for a given location.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<TimeZoneResponse> GetTimeZoneAsync(this IXServer operations, TimeZoneRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTimeZoneWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists available content snapshots including their meta data considering
            /// user privileges.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ContentSnapshotsListResponse ListContentSnapshots(this IXServer operations, ListContentSnapshotsRequest body)
            {
                return operations.ListContentSnapshotsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists available content snapshots including their meta data considering
            /// user privileges.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ContentSnapshotsListResponse> ListContentSnapshotsAsync(this IXServer operations, ListContentSnapshotsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListContentSnapshotsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists available high-performance routing networks including their meta data
            /// considering user privileges. Both networks of the map and user-created
            /// networks are listed. Networks belonging to the map have no scope, no
            /// tenant, and cannot be deleted. See technical concept about multitenancy on
            /// how to list networks for all available tenants or scopes.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static HighPerformanceRoutingNetworksListResponse ListHighPerformanceRoutingNetworks(this IXServer operations, ListHighPerformanceRoutingNetworksRequest body)
            {
                return operations.ListHighPerformanceRoutingNetworksAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists available high-performance routing networks including their meta data
            /// considering user privileges. Both networks of the map and user-created
            /// networks are listed. Networks belonging to the map have no scope, no
            /// tenant, and cannot be deleted. See technical concept about multitenancy on
            /// how to list networks for all available tenants or scopes.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<HighPerformanceRoutingNetworksListResponse> ListHighPerformanceRoutingNetworksAsync(this IXServer operations, ListHighPerformanceRoutingNetworksRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListHighPerformanceRoutingNetworksWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates a high-performance routing network. Returns the ID of the
            /// high-performance routing network. Calling this operation will not block
            /// until the result has been calculated. Instead of a result object, a Job
            /// object is returned which identifies the started calculation. To get status
            /// updates on a running job, use the operation watchJob. If the status changes
            /// to SUCCEEDED, the calculation was successful and the result can be obtained
            /// using fetchHighPerformanceRoutingNetworkResponse. If the job ended with
            /// status FAILED, fetchHighPerformanceRoutingNetworkResponse throws the
            /// exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartCreateHighPerformanceRoutingNetwork(this IXServer operations, CreateHighPerformanceRoutingNetworkRequest body)
            {
                return operations.StartCreateHighPerformanceRoutingNetworkAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates a high-performance routing network. Returns the ID of the
            /// high-performance routing network. Calling this operation will not block
            /// until the result has been calculated. Instead of a result object, a Job
            /// object is returned which identifies the started calculation. To get status
            /// updates on a running job, use the operation watchJob. If the status changes
            /// to SUCCEEDED, the calculation was successful and the result can be obtained
            /// using fetchHighPerformanceRoutingNetworkResponse. If the job ended with
            /// status FAILED, fetchHighPerformanceRoutingNetworkResponse throws the
            /// exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartCreateHighPerformanceRoutingNetworkAsync(this IXServer operations, CreateHighPerformanceRoutingNetworkRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartCreateHighPerformanceRoutingNetworkWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates a distance matrix by calculating road distances and travel times
            /// between given locations. An InvalidValueException is returned if the
            /// feature layer theme PTV\_RestrictionZones is activated.
            /// PTV\_RestrictionZones cannot be used for distance matrices. Returns a
            /// summary of this distance matrix calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static DistanceMatrixResponse CreateDistanceMatrix(this IXServer operations, CreateDistanceMatrixRequest body)
            {
                return operations.CreateDistanceMatrixAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Creates a distance matrix by calculating road distances and travel times
            /// between given locations. An InvalidValueException is returned if the
            /// feature layer theme PTV\_RestrictionZones is activated.
            /// PTV\_RestrictionZones cannot be used for distance matrices. Returns a
            /// summary of this distance matrix calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DistanceMatrixResponse> CreateDistanceMatrixAsync(this IXServer operations, CreateDistanceMatrixRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateDistanceMatrixWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Deletes a distance matrix with a given ID considering user privileges and
            /// concurrent usage.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VoidResponse DeleteDistanceMatrix(this IXServer operations, DeleteDistanceMatrixRequest body)
            {
                return operations.DeleteDistanceMatrixAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Deletes a distance matrix with a given ID considering user privileges and
            /// concurrent usage.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VoidResponse> DeleteDistanceMatrixAsync(this IXServer operations, DeleteDistanceMatrixRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteDistanceMatrixWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type DistanceMatrixResponse for the given job. If the
            /// calculation ended with an exception, fetchDistanceMatrixResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static DistanceMatrixResponse FetchDistanceMatrixResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchDistanceMatrixResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type DistanceMatrixResponse for the given job. If the
            /// calculation ended with an exception, fetchDistanceMatrixResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DistanceMatrixResponse> FetchDistanceMatrixResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchDistanceMatrixResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Gets the distance matrix contents for specific matrix elements specified as
            /// relations between route locations or specified as an array of start and
            /// destination locations. Returns arrays representing the matrix contents for
            /// the requested part of the matrix.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static DistanceMatrixResponse GetDistanceMatrix(this IXServer operations, GetDistanceMatrixRequest body)
            {
                return operations.GetDistanceMatrixAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Gets the distance matrix contents for specific matrix elements specified as
            /// relations between route locations or specified as an array of start and
            /// destination locations. Returns arrays representing the matrix contents for
            /// the requested part of the matrix.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DistanceMatrixResponse> GetDistanceMatrixAsync(this IXServer operations, GetDistanceMatrixRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDistanceMatrixWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Lists available distance matrices including their meta data considering
            /// user privileges and concurrent usage. See technical concept about
            /// multitenancy how to list matrices for all available tenants or scopes.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static DistanceMatrixListResponse ListDistanceMatrices(this IXServer operations, ListDistanceMatricesRequest body)
            {
                return operations.ListDistanceMatricesAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Lists available distance matrices including their meta data considering
            /// user privileges and concurrent usage. See technical concept about
            /// multitenancy how to list matrices for all available tenants or scopes.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DistanceMatrixListResponse> ListDistanceMatricesAsync(this IXServer operations, ListDistanceMatricesRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListDistanceMatricesWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of createDistanceMatrix. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchDistanceMatrixResponse. If the job ended with status FAILED,
            /// fetchDistanceMatrixResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartCreateDistanceMatrix(this IXServer operations, CreateDistanceMatrixRequest body)
            {
                return operations.StartCreateDistanceMatrixAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of createDistanceMatrix. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchDistanceMatrixResponse. If the job ended with status FAILED,
            /// fetchDistanceMatrixResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartCreateDistanceMatrixAsync(this IXServer operations, CreateDistanceMatrixRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartCreateDistanceMatrixWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of updateDistanceMatrix. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchDistanceMatrixResponse. If the job ended with status FAILED,
            /// fetchDistanceMatrixResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartUpdateDistanceMatrix(this IXServer operations, UpdateDistanceMatrixRequest body)
            {
                return operations.StartUpdateDistanceMatrixAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of updateDistanceMatrix. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchDistanceMatrixResponse. If the job ended with status FAILED,
            /// fetchDistanceMatrixResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartUpdateDistanceMatrixAsync(this IXServer operations, UpdateDistanceMatrixRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartUpdateDistanceMatrixWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Updates an existing distance matrix by extending it with new locations or
            /// overwriting existing entries. Returns a summary of this distance matrix
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static DistanceMatrixResponse UpdateDistanceMatrix(this IXServer operations, UpdateDistanceMatrixRequest body)
            {
                return operations.UpdateDistanceMatrixAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates an existing distance matrix by extending it with new locations or
            /// overwriting existing entries. Returns a summary of this distance matrix
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DistanceMatrixResponse> UpdateDistanceMatrixAsync(this IXServer operations, UpdateDistanceMatrixRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateDistanceMatrixWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type PackedBinsResponse for the given job. If the
            /// calculation ended with an exception, fetchPackedBinsResponse will rethrow
            /// it. If the id of the job is unknown, a XServerException with message
            /// 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static PackedBinsResponse FetchPackedBinsResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchPackedBinsResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type PackedBinsResponse for the given job. If the
            /// calculation ended with an exception, fetchPackedBinsResponse will rethrow
            /// it. If the id of the job is unknown, a XServerException with message
            /// 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<PackedBinsResponse> FetchPackedBinsResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchPackedBinsResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Performs a bin packing operation as described by the request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static PackedBinsResponse PackBins(this IXServer operations, PackBinsRequest body)
            {
                return operations.PackBinsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Performs a bin packing operation as described by the request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<PackedBinsResponse> PackBinsAsync(this IXServer operations, PackBinsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PackBinsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of packBins. Calling this operation will
            /// not block until the result has been calculated. Instead of a result object,
            /// a Job object is returned which identifies the started calculation. To get
            /// status updates on a running job, use the operation watchJob. If the status
            /// changes to SUCCEEDED, the calculation was successful and the result can be
            /// obtained using fetchPackedBinsResponse. If the job ended with status
            /// FAILED, fetchPackedBinsResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartPackBins(this IXServer operations, PackBinsRequest body)
            {
                return operations.StartPackBinsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of packBins. Calling this operation will
            /// not block until the result has been calculated. Instead of a result object,
            /// a Job object is returned which identifies the started calculation. To get
            /// status updates on a running job, use the operation watchJob. If the status
            /// changes to SUCCEEDED, the calculation was successful and the result can be
            /// obtained using fetchPackedBinsResponse. If the job ended with status
            /// FAILED, fetchPackedBinsResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartPackBinsAsync(this IXServer operations, PackBinsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartPackBinsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type LocationsBulkResponse for the given job. If the
            /// calculation ended with an exception, fetchLocationsBulkResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static LocationsBulkResponse FetchLocationsBulkResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchLocationsBulkResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type LocationsBulkResponse for the given job. If the
            /// calculation ended with an exception, fetchLocationsBulkResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<LocationsBulkResponse> FetchLocationsBulkResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchLocationsBulkResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Searches for locations matching a given address
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static LocationsResponse SearchLocations(this IXServer operations, SearchLocationsRequest body)
            {
                return operations.SearchLocationsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Searches for locations matching a given address
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<LocationsResponse> SearchLocationsAsync(this IXServer operations, SearchLocationsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.SearchLocationsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// For each element of a list of addresses, searches for locations matching
            /// that address.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static LocationsBulkResponse SearchLocationsInBulk(this IXServer operations, SearchLocationsBulkRequest body)
            {
                return operations.SearchLocationsInBulkAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// For each element of a list of addresses, searches for locations matching
            /// that address.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<LocationsBulkResponse> SearchLocationsInBulkAsync(this IXServer operations, SearchLocationsBulkRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.SearchLocationsInBulkWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of searchLocationsInBulk. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using fetchLocationsBulkResponse.
            /// If the job ended with status FAILED, fetchLocationsBulkResponse throws the
            /// exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartSearchLocationsInBulk(this IXServer operations, SearchLocationsBulkRequest body)
            {
                return operations.StartSearchLocationsInBulkAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of searchLocationsInBulk. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using fetchLocationsBulkResponse.
            /// If the job ended with status FAILED, fetchLocationsBulkResponse throws the
            /// exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartSearchLocationsInBulkAsync(this IXServer operations, SearchLocationsBulkRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartSearchLocationsInBulkWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Render image(s) of a map and return information on drawn Feature Layer
            /// data.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static MapResponse RenderMap(this IXServer operations, MapRequest body)
            {
                return operations.RenderMapAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Render image(s) of a map and return information on drawn Feature Layer
            /// data.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<MapResponse> RenderMapAsync(this IXServer operations, MapRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RenderMapWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Calculate the areas which can be reached from a location within given
            /// horizons. This operation requires a special license.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ReachableAreasResponse CalculateReachableAreas(this IXServer operations, ReachableAreasRequest body)
            {
                return operations.CalculateReachableAreasAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Calculate the areas which can be reached from a location within given
            /// horizons. This operation requires a special license.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReachableAreasResponse> CalculateReachableAreasAsync(this IXServer operations, ReachableAreasRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CalculateReachableAreasWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Calculates and returns route information.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static RouteResponse CalculateRoute(this IXServer operations, RouteRequest body)
            {
                return operations.CalculateRouteAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Calculates and returns route information.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<RouteResponse> CalculateRouteAsync(this IXServer operations, RouteRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CalculateRouteWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type ReachableAreasResponse for the given job. If the
            /// calculation ended with an exception, fetchReachableAreasResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ReachableAreasResponse FetchReachableAreasResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchReachableAreasResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type ReachableAreasResponse for the given job. If the
            /// calculation ended with an exception, fetchReachableAreasResponse will
            /// rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ReachableAreasResponse> FetchReachableAreasResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchReachableAreasResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type RouteResponse for the given job. If the calculation
            /// ended with an exception, fetchRouteResponse will rethrow it. If the id of
            /// the job is unknown, a XServerException with message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static RouteResponse FetchRouteResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchRouteResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type RouteResponse for the given job. If the calculation
            /// ended with an exception, fetchRouteResponse will rethrow it. If the id of
            /// the job is unknown, a XServerException with message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<RouteResponse> FetchRouteResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchRouteResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of calculateReachableAreas. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchReachableAreasResponse. If the job ended with status FAILED,
            /// fetchReachableAreasResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartCalculateReachableAreas(this IXServer operations, ReachableAreasRequest body)
            {
                return operations.StartCalculateReachableAreasAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of calculateReachableAreas. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchReachableAreasResponse. If the job ended with status FAILED,
            /// fetchReachableAreasResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartCalculateReachableAreasAsync(this IXServer operations, ReachableAreasRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartCalculateReachableAreasWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of calculateRoute. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchRouteResponse. If the job ended with status
            /// FAILED, fetchRouteResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartCalculateRoute(this IXServer operations, RouteRequest body)
            {
                return operations.StartCalculateRouteAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of calculateRoute. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchRouteResponse. If the job ended with status
            /// FAILED, fetchRouteResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartCalculateRouteAsync(this IXServer operations, RouteRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartCalculateRouteWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Attempts to delete a running job. If successful, the returned job will have
            /// state DELETED.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job DeleteJob(this IXServer operations, JobRequest body)
            {
                return operations.DeleteJobAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Attempts to delete a running job. If successful, the returned job will have
            /// state DELETED.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> DeleteJobAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteJobWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Immediately deletes a running request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VoidResponse DeleteRequest(this IXServer operations, StopDeleteRequest body)
            {
                return operations.DeleteRequestAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Immediately deletes a running request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VoidResponse> DeleteRequestAsync(this IXServer operations, StopDeleteRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteRequestWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns information about the data used by PTV xServer.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static DataInformationResponse GetDataInformation(this IXServer operations, DataInformationRequest body)
            {
                return operations.GetDataInformationAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns information about the data used by PTV xServer.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DataInformationResponse> GetDataInformationAsync(this IXServer operations, DataInformationRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDataInformationWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Attempts to stop a running job. If the status of the job changes to
            /// SUCCEEDED, preliminary results can be fetched, if available.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StopJob(this IXServer operations, JobRequest body)
            {
                return operations.StopJobAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Attempts to stop a running job. If the status of the job changes to
            /// SUCCEEDED, preliminary results can be fetched, if available.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StopJobAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StopJobWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Tries to stop a running request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static VoidResponse StopRequest(this IXServer operations, StopDeleteRequest body)
            {
                return operations.StopRequestAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Tries to stop a running request.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<VoidResponse> StopRequestAsync(this IXServer operations, StopDeleteRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StopRequestWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Returns the status of the given job.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job WatchJob(this IXServer operations, WatchRequest body)
            {
                return operations.WatchJobAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Returns the status of the given job.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> WatchJobAsync(this IXServer operations, WatchRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.WatchJobWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Change existing tours via specified actions. Returns a plan containing the
            /// changed tours and reports with additional information about those changed
            /// tours. The source tour(s) and target tour are always returned even if the
            /// tours did not change (for example if an addTripAction with an insertion
            /// position of type insertion at best position does not find a valid insertion
            /// position). Furthermore the stored request will be the original
            /// PlanToursRequest with changed tours information contained in the input
            /// plan.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ToursResponse ChangeTours(this IXServer operations, ChangeToursRequest body)
            {
                return operations.ChangeToursAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Change existing tours via specified actions. Returns a plan containing the
            /// changed tours and reports with additional information about those changed
            /// tours. The source tour(s) and target tour are always returned even if the
            /// tours did not change (for example if an addTripAction with an insertion
            /// position of type insertion at best position does not find a valid insertion
            /// position). Furthermore the stored request will be the original
            /// PlanToursRequest with changed tours information contained in the input
            /// plan.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ToursResponse> ChangeToursAsync(this IXServer operations, ChangeToursRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ChangeToursWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type ChangeToursProposalsResponse for the given job. If
            /// the calculation ended with an exception, fetchChangeToursProposalsResponse
            /// will rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ChangeToursProposalsResponse FetchChangeToursProposalsResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchChangeToursProposalsResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type ChangeToursProposalsResponse for the given job. If
            /// the calculation ended with an exception, fetchChangeToursProposalsResponse
            /// will rethrow it. If the id of the job is unknown, a XServerException with
            /// message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ChangeToursProposalsResponse> FetchChangeToursProposalsResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchChangeToursProposalsResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Fetches results of type ToursResponse for the given job. If the calculation
            /// ended with an exception, fetchToursResponse will rethrow it. If the id of
            /// the job is unknown, a XServerException with message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ToursResponse FetchToursResponse(this IXServer operations, JobRequest body)
            {
                return operations.FetchToursResponseAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Fetches results of type ToursResponse for the given job. If the calculation
            /// ended with an exception, fetchToursResponse will rethrow it. If the id of
            /// the job is unknown, a XServerException with message 'unknown id' is thrown.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ToursResponse> FetchToursResponseAsync(this IXServer operations, JobRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FetchToursResponseWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Propose ChangeToursActions to change an existing tour plan as desired.
            /// Returns proposed ChangeToursActions with resulting TourReports if the
            /// corresponding ChangeToursAction would be applied via a ChangeToursRequest.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ChangeToursProposalsResponse FindChangeToursProposals(this IXServer operations, FindChangeToursProposalsRequest body)
            {
                return operations.FindChangeToursProposalsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Propose ChangeToursActions to change an existing tour plan as desired.
            /// Returns proposed ChangeToursActions with resulting TourReports if the
            /// corresponding ChangeToursAction would be applied via a ChangeToursRequest.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ChangeToursProposalsResponse> FindChangeToursProposalsAsync(this IXServer operations, FindChangeToursProposalsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.FindChangeToursProposalsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Plan tours that ideally include all orders that are specified in the
            /// request. Returns a plan with tours and reports with additional information
            /// about the planned tours.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static ToursResponse PlanTours(this IXServer operations, PlanToursRequest body)
            {
                return operations.PlanToursAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Plan tours that ideally include all orders that are specified in the
            /// request. Returns a plan with tours and reports with additional information
            /// about the planned tours.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ToursResponse> PlanToursAsync(this IXServer operations, PlanToursRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.PlanToursWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of changeTours. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchToursResponse. If the job ended with status
            /// FAILED, fetchToursResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartChangeTours(this IXServer operations, ChangeToursRequest body)
            {
                return operations.StartChangeToursAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of changeTours. Calling this operation
            /// will not block until the result has been calculated. Instead of a result
            /// object, a Job object is returned which identifies the started calculation.
            /// To get status updates on a running job, use the operation watchJob. If the
            /// status changes to SUCCEEDED, the calculation was successful and the result
            /// can be obtained using fetchToursResponse. If the job ended with status
            /// FAILED, fetchToursResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartChangeToursAsync(this IXServer operations, ChangeToursRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartChangeToursWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of findChangeToursProposals. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchChangeToursProposalsResponse. If the job ended with status FAILED,
            /// fetchChangeToursProposalsResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartFindChangeToursProposals(this IXServer operations, FindChangeToursProposalsRequest body)
            {
                return operations.StartFindChangeToursProposalsAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of findChangeToursProposals. Calling this
            /// operation will not block until the result has been calculated. Instead of a
            /// result object, a Job object is returned which identifies the started
            /// calculation. To get status updates on a running job, use the operation
            /// watchJob. If the status changes to SUCCEEDED, the calculation was
            /// successful and the result can be obtained using
            /// fetchChangeToursProposalsResponse. If the job ended with status FAILED,
            /// fetchChangeToursProposalsResponse throws the exception that occurred during
            /// calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartFindChangeToursProposalsAsync(this IXServer operations, FindChangeToursProposalsRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartFindChangeToursProposalsWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// This is the asynchronous version of planTours. Calling this operation will
            /// not block until the result has been calculated. Instead of a result object,
            /// a Job object is returned which identifies the started calculation. To get
            /// status updates on a running job, use the operation watchJob. If the status
            /// changes to SUCCEEDED, the calculation was successful and the result can be
            /// obtained using fetchToursResponse. If the job ended with status FAILED,
            /// fetchToursResponse throws the exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            public static Job StartPlanTours(this IXServer operations, PlanToursRequest body)
            {
                return operations.StartPlanToursAsync(body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// This is the asynchronous version of planTours. Calling this operation will
            /// not block until the result has been calculated. Instead of a result object,
            /// a Job object is returned which identifies the started calculation. To get
            /// status updates on a running job, use the operation watchJob. If the status
            /// changes to SUCCEEDED, the calculation was successful and the result can be
            /// obtained using fetchToursResponse. If the job ended with status FAILED,
            /// fetchToursResponse throws the exception that occurred during calculation.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<Job> StartPlanToursAsync(this IXServer operations, PlanToursRequest body, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StartPlanToursWithHttpMessagesAsync(body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Render a single map tile according the concept of the Map Tile API. By
            /// means of different frameworks a map image can be composed of multiple
            /// tiles. These tiles can be cached and reused for drawing of similar sections
            /// of a map. Optionally it is possible to return textual information on drawn
            /// Feature Layer data. Therefore, this operation can return either an image
            /// directly or a structured response which contains the image and additional
            /// information on drawn Feature Layer data such as their positions and names.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='zoomLevel'>
            /// Zoom level. Details about zoom levels are documented in the Map Tile API.
            /// </param>
            /// <param name='x'>
            /// Horizontal tile index.
            /// </param>
            /// <param name='y'>
            /// Vertical tile index.
            /// </param>
            /// <param name='tileParameters'>
            /// Additional parameters for the operation
            /// </param>
            public static TileResponse Tile(this IXServer operations, int zoomLevel, int x, int y, TileParameters tileParameters = default(TileParameters))
            {
                return operations.TileAsync(zoomLevel, x, y, tileParameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Render a single map tile according the concept of the Map Tile API. By
            /// means of different frameworks a map image can be composed of multiple
            /// tiles. These tiles can be cached and reused for drawing of similar sections
            /// of a map. Optionally it is possible to return textual information on drawn
            /// Feature Layer data. Therefore, this operation can return either an image
            /// directly or a structured response which contains the image and additional
            /// information on drawn Feature Layer data such as their positions and names.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='zoomLevel'>
            /// Zoom level. Details about zoom levels are documented in the Map Tile API.
            /// </param>
            /// <param name='x'>
            /// Horizontal tile index.
            /// </param>
            /// <param name='y'>
            /// Vertical tile index.
            /// </param>
            /// <param name='tileParameters'>
            /// Additional parameters for the operation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<TileResponse> TileAsync(this IXServer operations, int zoomLevel, int x, int y, TileParameters tileParameters = default(TileParameters), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.TileWithHttpMessagesAsync(zoomLevel, x, y, tileParameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
